|       SYSTEM library   

	.globl  __exit
	.globl  _mul
	.globl  _div
	.globl  _trap
	.globl  _ffloat
	.globl	_fneg
	.globl	_fmul
	.globl	_fadd
	.globl	_fcmp
	.globl	_fdiv
	.globl	_ftrunc
	.globl	_fsub
	.globl	start
	.globl  _sdiv
	.globl	_run
	.globl  _environ
	.globl  _endtext
	.globl  _m2goto
        .globl  _m2setgoto

_endtext:
_run:
	movl	sp@,d2
	lea	sp@(4),a3
	movl	d2,d1
	asll	#2,d1
	lea	a3@(4,d1:l),a4
	movl	a4,_environ
	movl    #-1, a3
	movl    #0, a6
	tstl	sp@-
	jsr	_Exceptions__Exceptions
	movl    start, a0
	jsr	a0@
m2done: jsr	__exit

_trap:	movl	a4, sp@-
	movl	d7, sp@-
	jsr	_Exceptions_RAISEC

	|  m2setgoto - arg is pointer to record in which we must put sp,
	|              pc, fp, and mp of routine that called Goto.Setgoto
	|             (which is what called us).  Still have old fp in a6.
	|
	|   a6@   is link to fp
	|   a6@(4)  is ret pc
	|   a6@(8)  is arg to SetGoto boring except where we want stack to pop
	|   a6@(12) is stacked module pointer (mp)
_m2setgoto:
	movl    sp@(4), a0
	lea    a6@(8), a1
	movl    a1, a0@
	movl    a6@(4), a0@(4)
	movl	a6@, a0@(8)
	movl    a6@(12),a0@(12)
	rts

	|  m2goto - arg is pointer to record containing sp, pc, fp, mp of
	|           environment we wish to go back (hopefully) to.
_m2goto:
	movl	sp@(4), a0
	movl	a0@, sp
	movl	a0@(8), a6
	movl    a0@(12),sp@(4)   | put mp back on stack
	movl    a0@(4), a0
	jmp	a0@

_mul:	movw	d4, d6
	movw	d5, d7
	swap	d4
	swap	d5
	mulu	d7, d4
	mulu	d6, d5
	addw	d5, d4
	swap	d4
	clrw	d4
	mulu	d7, d6
	addl	d6, d4
	rts

_div:	clrl	d7
	moveq	#1, d6
	tstl	d5
	bmi	div1
	bnes	div2
	moveq	#3,d7
	jsr	_trap
div2:
	cmpl	d4, d5
	bccs	div1
	lsll	#1, d6
	lsll	#1, d5
	bpls	div2
div1:
	cmpl	d5, d4
	bcss	div3
	subl	d5, d4
	addl	d6, d7
div3:
	lsrl	#1, d5
	lsrl	#1, d6
	bnes	div1
	rts

_sdiv:
	moveq	#1, d3
	moveq	#1, d6
	clrl	d7
	tstl	d4
       	bpls	sdiv4
	negl	d4
	negl	d3
sdiv4:
	tstl	d5
	bpls	sdiv5
	negl	d5
	negl	d3
sdiv5:
	bnes	sdiv2
	moveq	#3, d7
	jsr	_trap
sdiv2:
	cmpl	d4, d5
	bccs	sdiv1
	lsll	#1,d6
	lsll	#1,d5
	bras	sdiv2
sdiv1:
	cmpl	d5, d4
	bcss	sdiv3
	subl	d5, d4
	addl	d6, d7
sdiv3:
	lsrl	#1, d5
	lsrl	#1, d6
	bnes	sdiv1
	tstl	d3
	bpls	sdiv6
	negl	d7
sdiv6:
	rts

	
	.globl	_transfer
	.globl	_newproc

| NEWPROCESS(proc: PROC; wkspbase: ADDRESS; 
|		wkspsize: CARDar: PROCESS)
| creates a new process and assigns its 'id' to 'procvar'.
| Called from compiled code r frame set up, i.e.
| a6@(proc)	value of 'proc'
| a6@(wkspbase)	value of 'wkspbase'
| a6@(wkspsize) value of 'wkspsize'
| a6@(procvar)	address of 'procvar'

	proc	= 20
	wkspbase= 16
	wkspsize= 12
	procvar	= 8

_newproc:
	link	a6, #0
	movl	a6@(wkspbase), a1
	movl	a6@(wkspsize), d0
	movl	a1, a0
	addl	d0, a0			| stack base in a0
	movl	#m2done, a0@-		| push a return address
	clrl	a0@-			| push a frame pointer
	movl	a6@(proc), a0@-		| push proc entry
	lea	a0@(8), a2
	movl	a2, a0@-		| push a frame pointer
	movl	a0, a0@-		| save frame pointer
	movl	a6@(procvar), a2
	movl	a0, a2@			| update process variable
	unlk  a6
	rts

| TRANSFER(VAR from, to: PROCESS)
| A process is represented by a pointer to its save area.,
| which is allocated from the workspace passed initially to NEWPROCESS.
| Called as a normal Modula-2 procedure, i.e.
| a6@(from)	address of 'from'
| a6@(to)	address of 'to'

	from = 12
	to = 8 

_transfer:
	link	a6,#0
	movl	a6@(from),a0
	movl	a6@(to), a1
	movl	a6, sp@-
	movl	sp, a0@
	movl	a1@, sp
	movl	sp@+, a6
	unlk	a6
	rts	

|
| modula 2 floating point library
|    written by:        trevor morris with thanks to krzysztof zielinski
|
|   32 bit floating point format:
|       bits 0 to 7:    twos complement exponent in range -127 to +127. the
|                       value -128 is used to represent floating point zero
|                       (nt -128 but with a non
|                       zero mantissa is invalid but should not cause problems.
|                       the routines given below never produce such a number).
|       bits 8 to 30:
	.globl	 _fadd
	.globl	 _fsub
	.globl	 _fmul
	.globl	 _fdiv
	.globl   _fcmp
	.globl	 _fabs
        .globl   _fneg
        .globl   _ftrunc
        .globl   _ffloat

|
|           trap codes set to HALT fault for the moment
|
integerdivbyzero    =     4
addsuboverflow      =     4
muloverflow         =     4
divoverflow         =     4
divbyzero           =     4
bigtotrunc          =     4
negtotrunc          =     4



|         name : _fadd
|         function                 res = arg1 + arg2
|
|         use of registers :
|                              d0 -  arg1
|                              d1 -  arg2
|                              d7 -  res



_fadd:  moveq   #0x40,d7 
        lsll   #1,d7       
        cmpb   d0,d7
        bne   add1
        movl  d1,d7               
        rts
add1:   cmpb   d1,d7           
        bne    add2
	movl  d0,d7
        rts
add2:   movb  d0,d2             
        movb  d1,d3               
        clrb  d0
        clrb   d1
        moveq   #31,d6          
        bset    d6,d0            
        sne     d4               
        bset    d6,d1
        sne     d5
        lsrl   #1,d0              
        lsrl   #1,d1             
        cmpb   d3,d2
        bne   add_args_different  
        cmpl   d1,d0          
        bne   add_args_different
	cmpb   d5,d4
        bne   add_returnzero    
        lsll   #1,d0
        bra  add_inc_exp
add_args_different:
	bgts	add_no_swap
        exg     d3,d2            
        exg     d1,d0            
        exg     d5,d4              
add_no_swap:
        movb  d2,d6            
        subb   d3,d6             
        bvs   add_wipeout        
        cmpb  #32,d6             
        bge   add_wipeout     
        lsrl   d6,d1           
        cmpb   d5,d4
        beq   add_do_add         
        negl   d1
add_do_add:
        addl   d1,d0             
        bmis   add_inc_exp
add_dec_exp_loop:
        lsll   #1,d0              
        bmi   add_round_result   
        subqb  #1,d2
        bvc   add_dec_exp_loop
add_returnzero:
        rts
add_inc_exp:
        addqb  #1,d2
        bvs   add_overflow
add_round_result:
        addl   d7,d0            
        bmi   add_check_exp      
        addqb  #1,d2
        bvs   add_overflow       
        bra   add_result_ready
add_check_exp:
        cmpb   d2,d7
        beq   add_returnzero     
add_result_ready:
        movl  d0,d7              
        movb  d2,d7
        moveq   #31,d6            
        tstb   d4                 
        bne   add_neg_result     
        bclr    d6,d7
        rts
add_neg_result:
        bset    d6,d7
        rts
add_wipeout:
        lsll   #1,d0
        bra   add_result_ready
add_overflow:
        moveq   #addsuboverflow,d7
        jmp     _trap

|         name : _fsub
|         function t
|                    res = arg1 - arg2
|
|         use of registers :
|                              d0 -  arg1
|                              d1 -  arg2
|                              d7 -  res
_fsub:
        cmpb   #0x80,d1
        beq   sub_zero
        moveq   #31,d2
        bchg    d2,d1
        bra     _fadd
sub_zero:
        movl  d0,d7
	rts

|
|	name : _fmul
|
|         use of registers :
|                             d0 - arg1
|                             d1 - arg2
|                             d7 - res
|


_fmul:  moveq   #0x40,d7
        lsll   #1,d7              
        cmpb   d0,d7  
        beq   mul_returnzero
        cmpb   d1,d7
        beq   mul_returnzero
        movb  d0,d2
        addb   d1,d2         
        bvc   mul_check_exp
        bpl   mul_returnzero      
        cmpb   d2,d7             
        beq   mul_exp_ok
        bra   mul_overflow        
mul_check_exp:    
        cmpb   d2,d7 
        beq   mul_returnzero      
mul_exp_ok:
        clrb   d0                  
        clrb   d1                  
        moveq   #31,d6              
        bset    d6,d0              
        sne     d4          
        bset    d6,d1              
        sne     d5                
        cmpb   d5,d4        
        beqs   mul_positive_result         
        bset    d6,d6
mul_positive_result:
        lsrl   #1,d0              
        lsrl   #1,d1              
        moveq   #7,d5       
        moveq   #23,d3             
        clrl   d4                 
mul_loop:
        lsrl   #1,d4            
        btst    d5,d1             
        beq   mul_dont_add        
        addl   d0,d4              
mul_dont_add:
        addql  #1,d5        
        dbra    d3,mul_loop     
        bclr    d6,d4
	bne   mul_dont_dec_exp  
        lsll   #1,d4              
        addl   d7,d4            
        bpl   mul_exp_not_deced   
        bclr    d6,d4 
        subqb  #1,d2              
        cmpb   d2,d7               
        bne   mul_pack_result     
mul_returnzero:
        rts                         
mul_dont_dec_exp:  
        addl   d7,d4             
mul_exp_not_deced:
        cmpb   d2,d7              
        beq   mul_overflow      
mul_pack_result:
        orl   d6,d7
        orl    d4,d7              
        movb  d2,d7
	rts
mul_overflow:               
        moveq   #muloverflow,d7
        jmp     _trap

|         name : _fdiv
|         function : floating point division
|                    res = arg1/arg2
|
|         use of registers :
|                             d0 - arg1
|                             d1 - arg2
|                             d7 - res
|
div_by_zero:
        moveq   #divbyzero,d7
        jmp     _trap
_fdiv:  moveq   #0x40,d7             
        lsll    #1,d7             
        cmpb   d0,d7              
        beq   div_returnzero
        cmpb   d1,d7               
        movb  d0,d2            
        subb   d1,d2              
        bvc   div_exp_ok          
        bmi   div_overflow
div_returnzero:
        rts
div_exp_ok:
        clrb   d0                
        clrb   d1                  
        moveq   #31,d6
	bset    d6,d0
        sne	d4
        bset    d6,d1
        sne     d5
        cmpb   d5,d4            
        beq   div_positive_result
        bset    d6,d6            
div_positive_result: 
        lsrl   #1,d0              
        lsrl   #1,d1             
        movb  d6,d5             
        moveq   #25,d3           
        clrl   d4              
div_loop:
        cmpl   d1,d0         
        bcs   div_nosub       
        subl   d1,d0
        bset    d5,d4              
div_nosub:
        subqb  #1,d5            
        lsll   #1,d0
	dbeq    d3,div_loop       
        bclr    d6,d4              
        bne   div_round_and_inc_exp   
        lsll   #1,d4             
        addl   d7,d4              
        bpl   div_inc_exp        
        bclr    d6,d4             
        cmpb   d2,d7       
        bne   div_pack_result
        rts
div_round_and_inc_exp:
        addl   d7,d4         
div_inc_exp:
        addqb  #1,d2              
        bvs   div_overflow
div_pack_result:
        orl    d6,d7
	orl    d4,d7
        movb  d2,d7           
        rts                      
div_overflow:
        moveq   #divoverflow,d7
        jmp     _trap

|         name : _fcmp
|         function : floating point comparision
|                    arg1 : arg2
|       results:
|
|         use of registers :
|                              d0 -  arg1
|                              d1 -  a :
|                   arg1 > arg2  ---->  d0=0  d1=1
|                   arg1 = arg2  ---->  d0=0  --->  d0=1  d1=0
|

_fcmp:  cmpl   d1,d0        
        beq   cmp_eq                
        cmpb  #0x80,d0            
        beq   cmp_arg1_zero       
        cmpb  #0x80,d1              
        beq   cmp_arg2_zero      
        moveq   #31,d2             
        bclr    d2,d0          
        bne   cmp_arg1_neg       
        tstl   d1             
        bmi   cmp_gt              
cmp_size_test:
        cmpb   d1,d0
        bgt   cmp_gt         
        blt   cmp_lt             
        cmpl   d1,d0             
        bgt   cmp_gt             
cmp_lt: moveq   #1,d0           
        clrl   d1                 
        rts             
cmp_eq: clrl   d0
        clrl   d1
        rts
cmp_gt: clrl   d0
        moveq   #1,d1
        rts
cmp_arg1_zero:
        cmpb   d0,d1        
        beq   cmp_eq
	tstl  d1
        bmi   cmp_gt            
        bra   cmp_lt             
cmp_arg2_zero:
        tstl   d0                
        bmi   cmp_lt         
        bra   cmp_gt
cmp_arg1_neg:
        bclr    d2,d1           
        beq   cmp_lt              
        exg     d0,d1              
        bra   cmp_size_test     

|        name: _fabs
|        function : floating point abs
|                   res = | arg |
|        use of registers :
|                                 d0 - es
|
_fabs:
        moveq   #31,d1
        bclr    d1,d0
        rts





|        name : _fneg
|        function : floating point negation
|                           res = -arg
|        use of registers :
|                            d0 = arg
|
_fneg:	cmpb #0x80,d0
        beq   neg1
	movw  #31,d2
        bchg    d2,d0
neg1:   rts  

|        name : _ffloat
|        function  : takes signed integer x returns floating point
|                    representation
|        use of registers :
|                            d0 - arg
|                            d0 - res
|


_ffloat:
        moveq   #32,d2       
        tstl   d0                 
        beq   float_zero     
        smi     d3                  
        bpl   float_loop        
        negl   d0
float_loop:
        subqb  #1,d2              
   	lsll   #1,d0
	bpl   float_loop       
        tstb   d3                 
        bne   float_put_exp     
        moveq   #31,d1
        bclr    d1,d0
float_put_exp:
        movb  d2,d0          
        rts
float_zero:
        bset    #7,d0             
        rts

|        name : _ftrunc
|        function : takes floating point x retuigned integer x
|                   error if x is negative
|
|        use of registers :
|           - argument
|                             d0 - result
|


_ftrunc:
        moveq   #31,d2
        bset	d2,d0
	bne  trunc_neg
        tstb   d0                   
        beq   trunc_returnzero     
        bmi   trunc_returnzero     
        moveq   #32,d1               
        subb   d0,d1               
        bmi   trunc_toobig         
        clrb   d0                
        lsrl   d1,d0             
        rts                   
trunc_returnzero:
        clrl   d0
        rts
trunc_neg:
        moveq	#negtotrunc,d7
        jmp     _trap
trunc_toobig:
        moveq   #bigtotrunc,d7
        jmp     _trap

