(*
    Title: 	Arithmetic - Implementation
    LastEdit:	"Mon Sep 17 14:07:17 1984"
    Author: 	pr
		Cambridge University Computer Laboratory
*)
IMPLEMENTATION MODULE Arithmetic;

FROM Exceptions IMPORT RAISE;

CONST 
    ImaginarySquareRoot = "ImaginarySquareRoot";

CONST
    RZero = 0.0;
    ROne = 1.0;
    RTwo = 2.0;
    SmallReal = 0.000001;

PROCEDURE CMax (x, y: CARDINAL): CARDINAL;
BEGIN
    IF x > y THEN RETURN x ELSE RETURN y END;
END CMax;

PROCEDURE CMin (x, y: CARDINAL): CARDINAL;
BEGIN
    IF x < y THEN RETURN x ELSE RETURN y END;
END CMin;


PROCEDURE ISign (x: INTEGER): INTEGER;
BEGIN
    IF x = 0 THEN
        RETURN 0;
    ELSE
        IF x > 0 THEN
                RETURN +1;
        ELSE
            RETURN -1;
        END;
    END;
END ISign;


PROCEDURE IMax (x, y: INTEGER): INTEGER;
BEGIN
    IF x > y THEN  RETURN x ELSE RETURN y END;
END IMax;


PROCEDURE IMin (x, y: INTEGER): INTEGER;
BEGIN
    IF x < y THEN  RETURN x ELSE RETURN y END;
END IMin;

PROCEDURE Fix (x: REAL): INTEGER;
    BEGIN
        IF x >= RZero THEN
            RETURN TRUNC (x);
        ELSE
            RETURN - INTEGER (TRUNC (-x));
        END (* if *);
    END Fix;

PROCEDURE RSign (x: REAL): REAL;
BEGIN
    IF x = RZero THEN
        RETURN RZero;
    ELSE
        IF x > RZero THEN
                RETURN ROne;
        ELSE
            RETURN - ROne;
        END;
    END;
END RSign;


PROCEDURE RMax (x, y: REAL): REAL;
BEGIN
    IF x > y THEN RETURN x ELSE RETURN y  END;
END RMax;


PROCEDURE RMin (x, y: REAL): REAL;
BEGIN
    IF x < y THEN RETURN x ELSE RETURN y END;
END RMin;


PROCEDURE SquareRoot (y: REAL): REAL;
    VAR
        invert:     BOOLEAN;
        x,
        delta:      REAL;
    BEGIN
        IF y <= RZero THEN
            IF y = RZero THEN
                RETURN RZero;
            END;
            RAISE(ImaginarySquareRoot);
        END;
        invert := y < ROne;
        IF invert THEN
            y := ROne / y;
        END;
        x := y;
        REPEAT
            delta := (x * x - y) / (RTwo * x);
            x := x - delta;
        UNTIL ABS (delta) < (SmallReal * y);
        IF invert THEN
            RETURN ROne / x;
        ELSE
            RETURN x;
        END;
    END SquareRoot;

PROCEDURE Round (x: REAL): INTEGER;
    BEGIN
        IF x >= 0.0 THEN
            RETURN TRUNC (x + 0.5);
        ELSE
            RETURN -INTEGER (TRUNC (0.5 - x));
        END;
    END Round;



BEGIN

END Arithmetic.
