(*
    Title: 	Exceptions - Implementation
    LastEdit:	"Tue Dec 15 16:28:10 1987"
    Author: 	Mick Jordan
		Acorn Research Centre

    Implementation for Unix.
    Prints a message on STDERR and then quits with core dump.
*)

(* $T-, $R- *)

IMPLEMENTATION MODULE Exceptions;

IMPORT UnixCall;

FROM SYSTEM IMPORT CALLEXTFUNC, CALLEXTPROC, ADR;
FROM UnixSignals IMPORT SIGQUIT;

CONST STDERR = 2;

PROCEDURE RAISE(ex: ARRAY OF CHAR);
    VAR
        pid: INTEGER;
        nl: ARRAY [0 .. 1] OF CHAR;
    BEGIN
        Output("Modula-2 exception - ");
        Output(ex);
        nl[0] := 12C; nl[1] := 0C;
        Output(nl);
        pid := INTEGER(CALLEXTFUNC(UnixCall.getpid));
        CALLEXTPROC(UnixCall.kill, pid, SIGQUIT);
    END RAISE;

PROCEDURE RAISEC(code: StdException);
VAR
    s: ARRAY [0..30] OF CHAR;
BEGIN
    CASE code OF
      CaseIndexOutOfRange: s := "CASE index out of range"; |
      AssignmentOutOfRange: s := "Assigned value out of range"; |
      ArrayIndexOutOfRange: s := "Array index out of range"; |
      ReturnMissing: s := "missing RETURN in function"; |
      HaltFault: s := "HALT";
    END (* case *);
    RAISE(s);
END RAISEC;

PROCEDURE Output(chars: ARRAY OF CHAR);
    VAR
        i: CARDINAL;
        rc: INTEGER;
    BEGIN
        i := 0;
        WHILE (i <= HIGH(chars)) AND (chars[i] # 0C) DO
            INC(i);
        END (* while *);
        CALLEXTPROC(UnixCall.write, STDERR, ADR(chars), i)
    END Output;

END Exceptions.

