IMPLEMENTATION MODULE Hosts;


IMPORT
  Exceptions, SYSTEM, SystemTypes, UnixCall, UnixLibCall, UnixSocket;


TYPE
  HostEntry  = POINTER TO HostEntryR;
  HostEntryR =
    RECORD
      name:   SystemTypes.String;
      aliases:SYSTEM.ADDRESS;
      family: UnixSocket.Family;
      length: INTEGER;
      addr:   SYSTEM.ADDRESS
    END;


VAR
  ownId:  HostId;
  ownName:ARRAY [0..31] OF CHAR;


PROCEDURE OwnName():SystemTypes.String;
  BEGIN
    RETURN SYSTEM.ADR(ownName)
  END OwnName;


PROCEDURE OwnId():HostId;
  BEGIN
    RETURN ownId
  END OwnId;


PROCEDURE Id(name:SystemTypes.String; VAR hostId:HostId):INTEGER;
  VAR
    hostPtr:HostEntry;
  BEGIN
    hostPtr := HostEntry(SYSTEM.CALLEXTFUNC(UnixLibCall.gethostbyname, name));
    IF INTEGER(hostPtr) = 0 THEN RETURN -1 END;
    hostId := HostId(hostPtr^.addr^);
    RETURN 0
  END Id;


PROCEDURE Init();
  VAR
    i:INTEGER;
  BEGIN
    i := HIGH(ownName);
    SYSTEM.CALLEXTPROC(UnixCall.gethostname, SYSTEM.ADR(ownName), i);
    ownName[i] := CHR(0);
    IF Id(SYSTEM.ADR(ownName), ownId) < 0 THEN
      Exceptions.RAISE("Cannot get ownID")
    END
  END Init;
    

BEGIN
  Init()
END Hosts.
