(*
    Title:	Iterator things
    LastEdit:	"Fri Dec 18 17:11:31 1987"
    Author:	Derek McAuley,Oms1,4663,329629
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE Iterator;


PROCEDURE Init(VAR s:State);
  BEGIN
    s.pos := 0;
    s.gen := 0;
    s.bits := Bits{St};
  END Init;


PROCEDURE Broken(VAR s:State):BOOLEAN;
  BEGIN
    RETURN Br IN s.bits;
  END Broken;


PROCEDURE Finished(VAR s:State):BOOLEAN;
  BEGIN
    RETURN Fin IN s.bits;
  END Finished;


PROCEDURE Starting(VAR s:State):BOOLEAN;
  BEGIN
    RETURN St IN s.bits;
  END Starting;


PROCEDURE Exhausted(VAR s:State):BOOLEAN;
  BEGIN
    RETURN Ex IN s.bits;
  END Exhausted;


PROCEDURE Break(VAR s:State);
  BEGIN
    INCL(s.bits, Br);
  END Break;


PROCEDURE Finish(VAR s:State);
  BEGIN
    INCL(s.bits, Fin);
  END Finish;


PROCEDURE Exhaust(VAR s:State);
  BEGIN
    INCL(s.bits, Ex);
  END Exhaust;


PROCEDURE Check(
  VAR state:     State;
      generation:Generation;
      startValue:CARDINAL
 ):CARDINAL;
  BEGIN
    IF St IN state.bits THEN
      EXCL(state.bits, St);
      state.gen := generation;
      state.pos := startValue;
    ELSIF state.gen # generation THEN
      INCL(state.bits, Br);
    ELSIF state.pos = 0 THEN
      INCL(state.bits, Fin);
      INCL(state.bits, Ex);
    END; (* if *)
    RETURN state.pos;
  END Check;


END Iterator.
