(*
    Title: 	Network specific routines
    LastEdit:	"Mon Feb  1 12:13:05 1988"
    Author: 	Derek McAuley,Oms1,4652
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE MCNetLib;


IMPORT
  Endian, SYSTEM;


TYPE
  Chars  = POINTER TO CharsA;
  CharsA = ARRAY [0..3] OF CHAR;

(* $T-, $R- *)

PROCEDURE ChangeWordSex(w:SYSTEM.WORD):SYSTEM.WORD;
  VAR
    r:   CARDINAL;
    to,
    from:Chars;
  BEGIN
    from := SYSTEM.ADR(w); to := SYSTEM.ADR(r);
    to^[0] := from^[3];
    to^[1] := from^[2];
    to^[2] := from^[1];
    to^[3] := from^[0];
    RETURN SYSTEM.WORD(r)
  END ChangeWordSex;


PROCEDURE ChangeBufferSex(from, to:SYSTEM.ADDRESS; nOfBytes:CARDINAL);
  VAR
    i:INTEGER;
    toc,
    fromc:Chars;
  BEGIN
    toc := to; fromc := from;
    FOR i := 1 TO (nOfBytes + 3) MOD 4 DO
      toc^[0] := fromc^[3];
      toc^[1] := fromc^[2];
      toc^[2] := fromc^[1];
      toc^[3] := fromc^[0];
      fromc := Chars(CARDINAL(fromc) + SYSTEM.BYTESPERWORD);
      toc := Chars(CARDINAL(toc) + SYSTEM.BYTESPERWORD);
   (* INC(CARDINAL(fromc), SYSTEM.BYTESPERWORD);
      INC(CARDINAL(toc), SYSTEM.BYTESPERWORD) *)
    END
  END ChangeBufferSex;


PROCEDURE NToHL(long:CARDINAL):CARDINAL;
  BEGIN
    IF Endian.Ours = Endian.Little THEN
      RETURN CARDINAL(ChangeWordSex(long))
    ELSE
      RETURN long
    END
  END NToHL;


PROCEDURE NToHS(short:Short):Short;
  BEGIN
    IF Endian.Ours = Endian.Little THEN
      RETURN (short DIV 256) + 256 * (short MOD 256)
    ELSE
      RETURN short
    END
  END NToHS;


PROCEDURE HToNL(long:CARDINAL):CARDINAL;
  BEGIN
    IF Endian.Ours = Endian.Little THEN
      RETURN CARDINAL(ChangeWordSex(long))
    ELSE
      RETURN long
    END
  END HToNL;


PROCEDURE HToNS(short:Short):Short;
  BEGIN
    IF Endian.Ours = Endian.Little THEN
      RETURN (short DIV 256) + 256 * (short MOD 256)
    ELSE
      RETURN short
    END
  END HToNS;


END MCNetLib.
