(*
    Title: 	Sort - Implementation
    LastEdit:	"Mon Sep 10 10:41:57 1984"
    Author: 	pr
		Cambridge University Computer Laboratory

    Shell sort
*)

IMPLEMENTATION MODULE Sort;

FROM SYSTEM IMPORT WORD;

PROCEDURE Sort(VAR data: ARRAY OF WORD; length: CARDINAL; 
       Precedes: Comparator);
VAR
    step, i, j, k: CARDINAL;
    x: WORD;
BEGIN
    IF length = 0 THEN
        RETURN 
    END (* if *);

    step := length;     (* length > 0 *)
    REPEAT
        step := (step + 2) DIV 3;
        FOR i := step+1 TO length DO
            j := i-1;
            LOOP
                IF j <= step-1 THEN 
                    EXIT 
                END;
                k := j - step;
                IF Precedes (data [k], data [j]) THEN
                    EXIT;
                END;
                x := data [j];
                data [j] := data [k];
                data [k] := x;
                j := k;
            END;
        END;
    UNTIL step <= 1;
END Sort;

PROCEDURE INTEGERComparator(l, r: WORD): BOOLEAN;
BEGIN
    RETURN INTEGER(l) < INTEGER(r);
END INTEGERComparator;

PROCEDURE CARDINALComparator(l, r: WORD): BOOLEAN;
BEGIN
    RETURN CARDINAL(l) < CARDINAL(r);
END CARDINALComparator;

END Sort.
