(*
    Title: 	UnixEnv - Implementation
    LastEdit:	"Wed Feb 27 19:08:53 1985"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)


IMPLEMENTATION MODULE UnixEnv;

FROM SYSTEM IMPORT ADDRESS, CALLEXTFUNC, WORD;
FROM SystemTypes IMPORT String;

IMPORT Strings, UnixLibCall;

FROM Storage IMPORT ALLOCATE;

VAR equalsign : ARRAY [0..0] OF CHAR;

PROCEDURE GetEnvVar(name: ARRAY OF CHAR; VAR value: ARRAY OF CHAR): EnvRc;
    VAR
        namestr, valstr: String;
    BEGIN
        namestr := Strings.CopyCS (name);
        valstr := ADDRESS (CALLEXTFUNC (UnixLibCall.getenv, namestr));
	Strings.Dispose (namestr);
        IF valstr # NIL THEN
           Strings.CopySC (valstr, value);
           RETURN Found;
        ELSE
           RETURN NotFound;
        END;
    END GetEnvVar;

    
PROCEDURE SetEnvVar(name: ARRAY OF CHAR; value: ARRAY OF CHAR): EnvRc;
    VAR
        namestr, valstr, valstr1: String;
        res : WORD;
    BEGIN
	namestr := Strings.CopyCS (name);
        valstr := ADDRESS (CALLEXTFUNC (UnixLibCall.getenv, namestr));
        IF valstr = NIL THEN
            RETURN NotFound;
        END;

        valstr := Strings.ConcatSC (namestr, equalsign);
        valstr1 := Strings.ConcatSC (valstr, value);
        res := CALLEXTFUNC (UnixLibCall.putenv, valstr1);
        Strings.Dispose (valstr);
        Strings.Dispose (namestr);
        RETURN Found;
    END SetEnvVar;

BEGIN
   equalsign[0] := "=";
END UnixEnv.
