IMPLEMENTATION MODULE UnixErrors;

FROM TextIO IMPORT WriteChars, NewLine;
FROM SysStreams IMPORT sysErr;
FROM UnixMCI IMPORT errnoPtr;

PROCEDURE PErrorN(prompt: ARRAY OF CHAR; n: INTEGER);
VAR c: SysErrorString;
BEGIN
	c := "Unknown error";
	IF n <= SysNErr THEN
		c := sysErrList[n];
        END;
(*  Output prompt unless null					      *)
        IF prompt[0] # 0C THEN
            WriteChars(sysErr, prompt); WriteChars(sysErr, ": ");
        END;
        WriteChars(sysErr, c); NewLine(sysErr);
END PErrorN;

PROCEDURE PError(prompt: ARRAY OF CHAR);
BEGIN
    PErrorN(prompt, errnoPtr^);
END PError;

PROCEDURE SetError(VAR Err: SysErrorString);
BEGIN
    CASE i OF
	0: Err := "Error 0";
    |   1: Err := "Not owner";
    |   2: Err := "No such file or directory";
    |   3: Err := "No such process";
    |   4: Err := "Interrupted system call";
    |   5: Err := "I/O error";
    |   6: Err := "No such device or address";
    |   7: Err := "Arg list too long";
    |   8: Err := "Exec format error";
    |   9: Err := "Bad file number";
    |  10: Err := "No children";
    |  11: Err := "No more processes";
    |  12: Err := "Not enough core";
    |  13: Err := "Permission denied";
    |  14: Err := "Bad address";
    |  15: Err := "Block device required";
    |  16: Err := "Mount device busy";
    |  17: Err := "File exists";
    |  18: Err := "Cross-device link";
    |  19: Err := "No such device";
    |  20: Err := "Not a directory";
    |  21: Err := "Is a directory";
    |  22: Err := "Invalid argument";
    |  23: Err := "File table overflow";
    |  24: Err := "Too many open files";
    |  25: Err := "Not a typewriter";
    |  26: Err := "Text file busy";
    |  27: Err := "File too large";
    |  28: Err := "No space left on device";
    |  29: Err := "Illegal seek";
    |  30: Err := "Read-only file system";
    |  31: Err := "Too many links";
    |  32: Err := "Broken pipe";
    |  33: Err := "Argument too large";
    |  34: Err := "Result too large";
    END;
END SetError;

VAR i: CARDINAL;
BEGIN
    FOR i:=0 TO SysNErr DO SetError(sysErrList[i]); END;

END UnixErrors .
