(*
    Title: 	UnixIO - Implementation
    LastEdit:	"Wed Jan 27 17:27:26 1988"
    Author: 	Mick Jordan
		Acorn Research Centre
*)

IMPLEMENTATION MODULE UnixIO; 
(*$T-,$R-*)

IMPORT
  UnixCall, UnixErrNo, UnixMCI, UnixSelect;

FROM SYSTEM IMPORT  ADR, CALLEXTFUNC, WORD, ADDRESS;


PROCEDURE Close(fildes : INTEGER) : INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.close, fildes));

    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^;
    ELSE
        RETURN 0
    END
END Close;

PROCEDURE Creat(name : ARRAY OF CHAR; mode : BITSET) : INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.creat, ADR(name), mode));

    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^
    ELSE
        RETURN r0
    END
END Creat;

PROCEDURE Lseek(fildes : INTEGER;
            VAR offset : INTEGER; whence : CARDINAL) : INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.lseek, fildes, offset, whence));

    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^
    ELSE
        offset := r0;
        RETURN 0
    END
END Lseek;

PROCEDURE Open(name : ARRAY OF CHAR; flags, mode : BITSET) : INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.open, ADR(name), flags, mode));

    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^
    ELSE
        RETURN r0
    END
END Open;

PROCEDURE Read(fildes : INTEGER;
            VAR buffer : ARRAY OF WORD; nbytes : CARDINAL) : INTEGER;
VAR r0: INTEGER;
BEGIN
    UnixSelect.WaitForRead(fildes);
    REPEAT
      r0 := INTEGER(CALLEXTFUNC(UnixCall.read, fildes, ADR(buffer), nbytes))
    UNTIL r0 # UnixErrNo.EINTR;
    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^
    ELSE
        RETURN r0
    END
END Read;

PROCEDURE Write(fildes : INTEGER;
                buffer : ADDRESS; nbytes : CARDINAL) : INTEGER;
VAR r0: INTEGER;
BEGIN
    UnixSelect.WaitForWrite(fildes);
    r0 := INTEGER(CALLEXTFUNC(UnixCall.write, fildes, buffer, nbytes));

    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^
    ELSE
        RETURN r0
    END
END Write;


END UnixIO .
