(*
    Title: 	UnixMonitor - Implementation
    LastEdit:	"Tue Dec 15 16:26:43 1987"
    Author: 	Mary Thompson
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE UnixMonitor;

IMPORT UnixCall;

FROM SYSTEM    IMPORT CALLEXTPROC,ADDRESS,ADR,BYTESPERWORD,TSIZE,WORD;
FROM UnixIO    IMPORT Creat,Close;
FROM UnixMCI   IMPORT endText;
FROM Storage   IMPORT ALLOCATE, DEALLOCATE;

VAR bufsize    : CARDINAL;
    bufadr     : ADDRESS;
    sbufadr    : ADDRESS;

    
PROCEDURE MonStart(lowpc,highpc,scale : CARDINAL);
  VAR
    wbufsize : CARDINAL;
    tscale   : CARDINAL;
    pscale,i : CARDINAL;
    sbufarr  : POINTER TO ARRAY[0..4] OF INTEGER;
    BEGIN
        IF highpc > endText THEN highpc := endText; END;
        i := 1;
        tscale := scale;
        WHILE tscale > 1 DO
            tscale := tscale DIV 2;
            i := i*2;
        END;
        bufsize := (highpc-lowpc+i-1) DIV i;  (* the no of pc byte vals *)
        (* Profil uses a 16-bit word per every 2 pc values - we think.. *)
        bufsize := ((bufsize+BYTESPERWORD-1) DIV BYTESPERWORD) + 3;
        ALLOCATE(sbufadr,bufsize*TSIZE(WORD));
        sbufarr := sbufadr;
        sbufarr^[0] := lowpc;
        sbufarr^[1] := highpc;
        sbufarr^[2] := 0;  (* for compatibility with prof *)
        bufadr := ADR(sbufarr^[3]);
        pscale := 177777B DIV i;
        CALLEXTPROC(UnixCall.profil,
                    bufadr, (bufsize-3)*BYTESPERWORD, lowpc, pscale);
    END MonStart;
    
PROCEDURE MonFinish;
  VAR
    r0     : INTEGER;
    fildes : INTEGER;
    BEGIN
        CALLEXTPROC(UnixCall.profil,0,0,0,0);
        fildes := Creat("mon.out",BITSET(666B));
        IF fildes >= 0 THEN
            CALLEXTPROC(UnixCall.write,
                        fildes, sbufadr, bufsize*BYTESPERWORD);
            r0 := Close(fildes);
        END;    
        DEALLOCATE(sbufadr,bufsize*TSIZE(WORD));
    END MonFinish;
END UnixMonitor.
