(*
    Title: 	UnixProcess - Implementation
    LastEdit:	"Tue Dec 15 16:24:08 1987"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)
IMPLEMENTATION MODULE UnixProcess;

IMPORT UnixCall, UnixMCI;

FROM SYSTEM IMPORT REGISTER, CALLEXTFUNC, CALLEXTPROC, ADR;

PROCEDURE Exit(status : INTEGER);
BEGIN
    CALLEXTPROC(UnixCall.exit, status) (* no return possible *)
END Exit;

PROCEDURE Kill(pid : INTEGER; sig : CARDINAL) : INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.kill,  pid, sig));
    
    IF r0<0 THEN
	RETURN -UnixMCI.errnoPtr^
    ELSE
	RETURN 0
    END
END Kill;

PROCEDURE Wait(VAR status : INTEGER) : INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.wait, ADR(status)));
    
    IF r0<0 THEN
	RETURN -UnixMCI.errnoPtr^
    ELSE
	RETURN r0
    END
END Wait;

PROCEDURE Fork(): INTEGER;
VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.fork));
    IF r0<0 THEN RETURN -UnixMCI.errnoPtr^
    ELSE RETURN r0
    END;
END Fork;

PROCEDURE Exec(name : ARRAY OF CHAR; 
                  VAR argv : ARRAY OF CARDINAL) : INTEGER;
                  VAR r0: INTEGER;
BEGIN
    r0 := INTEGER(CALLEXTFUNC(UnixCall.exec, ADR(name), ADR(argv)));
    
    IF r0<0 THEN
        RETURN -UnixMCI.errnoPtr^	    (* any return is an error *)
    END;
END Exec;

PROCEDURE Getpid() : INTEGER;
BEGIN
    RETURN INTEGER(CALLEXTFUNC(UnixCall.getpid));
END Getpid;

END UnixProcess .
