(*
    Title: 	Unix 'System' call - Implementation
    LastEdit:	"Tue Dec 15 16:25:58 1987"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)


IMPLEMENTATION MODULE UnixSystem;

IMPORT UnixCall;

FROM SYSTEM IMPORT WORD, ADR, CALLEXTFUNC, CALLEXTPROC;
FROM UnixSignals IMPORT Signal, SIGIGN, SIGINT, SIGQUIT;
FROM UnixProcess IMPORT Wait, Exec, Fork;
FROM UnixEnv IMPORT GetEnvVar, EnvRc;

PROCEDURE System(command: ARRAY OF CHAR): INTEGER;
    VAR
        argv: ARRAY [0 .. 4] OF CARDINAL;
        istat, qstat: WORD;
        shell: ARRAY [0..79] OF CHAR;
        envrc: EnvRc;
        status, pid, rc: INTEGER;
        Mc: ARRAY [0 .. 2] OF CHAR;
    BEGIN
        Mc := "-c";
        envrc := GetEnvVar("SHELL", shell);
        IF envrc # Found THEN
            shell := "/bin/sh";
        END (* if *);
        argv[0] := ADR(shell);
        argv[1] := ADR(Mc);
        argv[2] := ADR(command);
        argv[3] := 0;
        pid := Fork();
        IF pid=0 THEN
            rc := Exec(shell, argv);
            IF rc<0 THEN CALLEXTPROC(UnixCall.exit) END;
        ELSIF pid>0 THEN
            istat := Signal(SIGINT, SIGIGN);
            qstat := Signal(SIGQUIT, SIGIGN);
            REPEAT
                rc := Wait(status);
            UNTIL (rc = pid) OR (rc = -1);
            IF rc = -1 THEN
                status := -1;
            END (* if *);
            istat := Signal(SIGINT, istat);
            qstat := Signal(SIGINT, qstat);
        ELSE
            status := -1;
        END (* if *);
        RETURN status;
    END System;

END UnixSystem.
