(*
    Title: 	UnixVersion
    LastEdit:	"Fri Jan 29 19:21:07 1988"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE UnixVersion;
IMPORT Strings, UnixEnv;


PROCEDURE GetUnixVersion(): UnixVersion;
    VAR 
        unixVersion: UnixVersion;
        rc: UnixEnv.EnvRc;
        version: ARRAY [0 .. 19] OF CHAR;

    BEGIN
        unixVersion := Unknown;
        rc := UnixEnv.GetEnvVar("M2UNIX", version);
        IF rc = UnixEnv.Found THEN
            IF Strings.EqualCC(version, "BSD4.1") THEN
                unixVersion := BSD41
            ELSIF Strings.EqualCC(version, "BSD4.2") THEN
                unixVersion := BSD42
            ELSIF Strings.EqualCC(version, "ULTRIX1.1") THEN
                unixVersion := ULTRIX11
            ELSIF Strings.EqualCC(version, "ULTRIX1.2") THEN
                unixVersion := ULTRIX12
            ELSIF Strings.EqualCC(version, "SUN4.2") THEN
                unixVersion := SUN42
	    ELSIF Strings.EqualCC(version, "SUN4.3") THEN
		unixVersion := SUN43 
            END (* if *);
        END (* if *);
        RETURN unixVersion;
    END GetUnixVersion;

END UnixVersion.
