IMPLEMENTATION MODULE Commands;

(*
    Title: 	useful commands for dispatcher
    LastEdit:	"Wed Apr 24 17:19:14 1985"
    Author: 	pr
		Cambridge University Computer Laboratory
*)


FROM Arguments IMPORT Arguments, StringArg;

FROM Context IMPORT Context, Bind, BindChar, Unbind;

FROM Dispatch IMPORT
    ImmediateContext, Dispatch, FindContexts, 
    FindRealInput;

FROM Streams IMPORT Stream, Get, ErrorCode, Delete;

FROM Storage IMPORT DEALLOCATE;

FROM SysStreams IMPORT sysErr;

FROM CharCodes IMPORT NewLineCh, CReturnCh;

FROM FileStream IMPORT CreateInput;

FROM WriteF IMPORT WriteF1, H;

FROM UnixProcess IMPORT Kill;

FROM UnixSystem IMPORT System;

FROM VAXSignals IMPORT SIGTSTP;


VAR
    NullImmediate:  Context;

PROCEDURE InValid (s: Stream): BOOLEAN;
BEGIN
    IF s^.status # Success THEN
        DISPOSE (s);
        RETURN TRUE
    ELSE RETURN FALSE
    END;
END InValid;

PROCEDURE Indirect (in, out: Stream);
    VAR
        name:       ARRAY [0 .. 40] OF CHAR;
        immediate,
        delayed:    Context;
    BEGIN
        IF Arguments (in, out, "file/m") THEN
            in := FindRealInput ();
            IF StringArg (1, name) > 0 THEN
                in := CreateInput (name);
                IF InValid (in) THEN
                    WriteF1 (out, "file %S not found\N", H (name));
                ELSE
                    FindContexts (immediate, delayed);
                    Dispatch (in, out, NullImmediate, delayed, "");
                    Delete (in);
                END (* if *);
            END (* if *);
        END (* if *);
    END Indirect;


PROCEDURE Shell (in, out: Stream);
    VAR
        length:         CARDINAL;
        char:           CHAR;
        command:        ARRAY [0 .. 80] OF CHAR;
        rc:             INTEGER;
    BEGIN
        length := 0;
        char := CHAR (Get (in));
        WHILE (char # CReturnCh) & (char # NewLineCh) DO
            command [length] := char;
            INC (length);
            char := CHAR (Get (in));
        END (* while *);
        command [length] := 0C;
        rc := System (command);
    END Shell;


PROCEDURE Pause (in, out: Stream);
    VAR
        rc:         INTEGER;
    BEGIN
        rc := Kill (0, SIGTSTP);
        IF rc < 0 THEN 
            WriteF1 (sysErr, "failed to stop (code %I)!\N", rc);
        END;
    END Pause;


BEGIN
    NullImmediate := ImmediateContext ();

END Commands.
