IMPLEMENTATION MODULE Ctrl;

(*
    Title: 	Control Character procedures
    LastEdit:	"Tue Feb 12 16:40:49 1985"
    Author: 	jd
		Cambridge University Computer Laboratory
*)


FROM CharCodes IMPORT CapitalCh;
FROM WriteF    IMPORT WriteF0;
FROM Streams   IMPORT Stream, Put;

CONST MaxControlChOrd = 31;


PROCEDURE CtrlCh (c: CHAR): CHAR;
    VAR cap: CHAR;
    VAR control: INTEGER;
BEGIN
    control := ORD (CapitalCh (c)) - ORD ("@");
    IF (control >= 0) AND (control <= MaxControlChOrd) THEN
        RETURN VAL (CHAR, control);
    ELSE RETURN c
    END;
END CtrlCh;


PROCEDURE CtrlPut (s: Stream; c: CHAR);
BEGIN
    IF ORD (c) <= MaxControlChOrd THEN
        IF c = EscapeCh THEN
            WriteF0 (s, "ESC-");
        ELSE Put (s, "^");
            Put (s, VAL (CHAR, ORD ("@") + ORD (c)));
        END;
    ELSE Put (s, c)
    END;
END CtrlPut;

END Ctrl.
