IMPLEMENTATION MODULE GKSBuf;

(*
    Title: 	GKS buffering for output devices
    LastEdit:	"Fri May 17 18:38:43 1985"
    Author: 	jd
		Cambridge University Computer Laboratory
*)

(* $T-, $R- *)

FROM SYSTEM IMPORT ADR;
FROM UnixIO IMPORT Write;
FROM Storage IMPORT ALLOCATE;

CONST
    BrMax =     10;
    BMax  =     256;
    Hwm   =     200;
    StandOut =  1;


TYPE
    BUFFER = POINTER TO BUFFERFULL;

    BUFFERFULL =
        RECORD
            next:   BUFFER;
            l:      [0..BMax];
            b:      ARRAY [1..BMax] OF CHAR;
        END;

VAR
    Start, End:             PROC;
    Chars:                  INTEGER;
    Head, Tail:             BUFFER;


PROCEDURE Void; END Void;


PROCEDURE Brackets (start, end: PROC);
BEGIN
    Start := start;
    End := end;
END Brackets;



PROCEDURE Flush (obligatory: BOOLEAN);
    VAR n: INTEGER;
    VAR buf: BUFFER;
BEGIN
    IF (Chars > 0) AND (obligatory OR (Chars > Hwm)) THEN
        End;
        buf := Head;
        REPEAT
            n := Write (StandOut, ADR(buf^.b), buf^.l); (* errors ignored!! *)
            buf := buf^.next
        UNTIL buf = Tail^.next;
        Chars := 0;
        Tail := Head;
        Head^.l := 0;
    END;
END Flush;



PROCEDURE Wrch (ch: CHAR);
BEGIN
    INC (Chars);
    IF Chars = 1 THEN Start; END;
    IF Tail^.l >= BMax THEN 
        IF Tail^.next = NIL THEN
            NEW (Tail^.next);
            Tail^.next^.next := NIL;
        END;
        Tail := Tail^.next;
        Tail^.l := 0
    END;
    WITH Tail^ DO
        INC (l);
        b [l] := ch;
    END;
END Wrch;

BEGIN
    Start := Void;
    End := Void;
    Chars := 0;
    NEW (Head);
    WITH Head^ DO
        next := NIL;
        l := 0
    END;
    Tail := Head;

END GKSBuf.
