(*
    Title: 	Dispatch tester
    LastEdit:	"Thu Feb 21 13:00:04 1985"
    Author: 	acm
		Cambridge University Computer Laboratory
*)

MODULE Test;

FROM SysStreams IMPORT sysOut;
FROM Context IMPORT Context, Bind, BindChar, ContextProc;
FROM Arguments IMPORT Arguments;
FROM Dispatch IMPORT
    ImmediateContext, DelayedContext, Dispatch, level, FindRealInput;
FROM Streams IMPORT Stream, Delete;
FROM WriteF IMPORT WriteF0;
FROM SCTermStream IMPORT CreateInOutput, TranslateCR;

VAR del, imm: Context;
    sc: Stream;

PROCEDURE one (in, out: Stream);
BEGIN
    WriteF0 (out, "one called!\N");
END one;

PROCEDURE two (in, out: Stream);
BEGIN
    WriteF0 (out, "two called!\N");
END two;

PROCEDURE three (in, out: Stream);
BEGIN
    WriteF0 (out, "three called!\N");
END three;

PROCEDURE a (in, out: Stream);
BEGIN
    WriteF0 (out, "a called!\N");
END a;

PROCEDURE b (in, out: Stream);
BEGIN
    WriteF0 (out, "b called!\N");
END b;

PROCEDURE ca (in, out: Stream);
BEGIN
    WriteF0 (out, "ca called!\N");
END ca;

PROCEDURE cb (in, out: Stream);
BEGIN
    WriteF0 (out, "cb called!\N");
END cb;

PROCEDURE new (in, out: Stream);
VAR i, d: Context;
    ch: CHAR;
    p: ARRAY [0..5] OF CHAR;
    s: Stream;
BEGIN
    IF Arguments (in, out, "please/s/m") THEN
        WriteF0 (out, "New context called\N");
        i := ImmediateContext ();
        d := DelayedContext ();
        ch := CHAR (ORD ("A") + level);
        p := "  >";
        p[0] := ch;
        BindChar (d, ch, new);
        s := FindRealInput ();
        Dispatch (s, out, i, d, p);
        WriteF0 (out, "Dropping out a level\N");
    ELSE WriteF0 (out, "Bad args to new\N");
    END;
END new;

BEGIN
    del := DelayedContext ();
    imm := ImmediateContext ();
    Bind (del, "one", one);
    Bind (del, "two", two);
    Bind (del, "three", three);
    Bind (del, "new", new);
    (*
    BindChar (imm, "a", a);
    BindChar (imm, "b", b);
    Bind (imm, "ca", ca);
    Bind (imm, "cb", cb);
    *)
    WriteF0 (sysOut, "this is a line to sysOut finishing now\N");
    WriteF0 (sysOut, "this is a line to sysOut with no CR");
    sc := CreateInOutput ();
    WriteF0 (sc, " - and this is a line to sc  finishing now\N");
    WriteF0 (sc, " - and this is a line to sc with no CR");
    Delete (sc);
    LOOP
        Dispatch (NIL, NIL, imm, del, "> ");
        WriteF0 (sysOut, "Dispatch finished\N");
    END;
END Test.
