(*
    Title: 	The binder indirection
    LastEdit:	"Mon Feb  1 13:16:47 1988"
    Author: 	Derek McAuley,Oms1,4663,329629
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE Binder;


IMPORT 
  Exceptions, Fields, Hosts, MCNetLib, RPC, RPCNets, Strings, StringStream, 
  TextIO, UnixEnv;

FROM Streams     IMPORT Stream;
FROM SystemTypes IMPORT String;

CONST
  ServiceIdPattern = 1;
  
PROCEDURE Init();
  VAR
    str: Stream;
    env: ARRAY [0..79] OF CHAR;
    name:String;
    port:CARDINAL;
  BEGIN
    IF UnixEnv.GetEnvVar("OGHMA", env) = UnixEnv.NotFound THEN
      Exceptions.RAISE("Environment variable not set")
    END;
    str := StringStream.CreateInOutChars(env);
    name := TextIO.ReadString(str, TextIO.WhiteSpace);
    WITH place.location DO
      Fields.InsertByte(udpType, 0, ORD(RPC.UdpIpNet));
      port := MCNetLib.HToNS(TextIO.ReadCARDINAL(str));
      udpPort := 0;
      Fields.InsertShort(udpPort, 0, port);
      IF udpPort = 0 THEN
        Exceptions.RAISE("Binder port bad")
      ELSIF Hosts.Id(name, machineId) < 0 THEN
        Exceptions.RAISE("Binder machine unknown")
      END;
    END;
    ServiceId := MCNetLib.HToNL(ServiceIdPattern);
    place.service := ServiceId;
    Strings.Dispose(name)
  END Init;


BEGIN
  Init()  
END Binder.
