(*
    Title: 	Usefile marshalling things
    LastEdit:	"Tue Jan  5 18:06:31 1988"
    Author: 	Derek McAuley,Oms1,4663,329629
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE MarshalLib;


IMPORT
  Exceptions, Marshal, RPC, RPCBasics, SYSTEM;

FROM SystemTypes  IMPORT String;


VAR
  theFactor:CARDINAL;


PROCEDURE ArrayOfString(
  VAR strings:ARRAY OF String; (* InOut *)
  VAR number: CARDINAL;        (* InOut *)
      m:      Marshal.T
 );
  (* For   marshalling: number is (* In *)  - marshal Min(number, max)
         unmarshalling: number is (* Out *) - elements unmarshalled.   
  *)
  VAR
    i:  INTEGER;
    max:CARDINAL;
  BEGIN
    max := HIGH(strings) + 1;
    Marshal.AWord(number, m);
    IF number > max  THEN
      IF m^.marshal THEN
        number := max
      ELSE
        Exceptions.RAISE("MarshalError")
      END
    END;
    FOR i := 0 TO INTEGER(number)-1 DO
      Marshal.AString(strings[i], m)
    END
  END ArrayOfString;


PROCEDURE Strings(
  address:SYSTEM.ADDRESS;
  number: CARDINAL;
  m:      Marshal.T
 );
  VAR
    i:  CARDINAL;
    str:String;
  BEGIN
    FOR i := 1 TO number DO
      IF m^.marshal THEN
        str := String(address^)
      END;
      Marshal.AString(str, m);
      IF NOT m^.marshal THEN
        address^ := SYSTEM.WORD(str)
      END;
      address := address + SYSTEM.BYTESPERWORD
    END
  END Strings;

END MarshalLib.
