(*
    Title: 	Talks to binder
    LastEdit:	"Wed Jan  6 09:51:37 1988"
    Author: 	Derek McAuley,Oms1,4663,329629
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE NetMember;


IMPORT
  Binder, Marshal, RPC, RPCNets, Strings;

FROM Storage     IMPORT ALLOCATE, DEALLOCATE;
FROM SystemTypes IMPORT String;


PROCEDURE Find(
      name: String;
      dist: RPC.Distance;
  VAR place:RPC.Place    (* Out *)
 ):RPC.MemberRC;
  VAR
    m:  Marshal.T;
    rc: RPC.RC;
    mrc:RPC.MemberRC;
  BEGIN
    m := RPC.ClientArguments(Binder.place, ORD(FindProc), 
                             Version, RPC.ExactlyOnce);
    Marshal.AString(name, m);
    Marshal.AWord(dist, m);
    rc := RPC.Call(m);
    IF rc # RPC.OK THEN RETURN RPC.NoBinder END;
    Marshal.AWord(mrc, m);
    IF mrc = RPC.BindOK THEN RPC.MarshalPlace(place, m) END;
    rc := RPC.EndOfResults(m);
    IF rc # RPC.OK THEN RETURN RPC.NetBinderError END;
    RETURN mrc
  END Find;


PROCEDURE Offer(
      name: String;
      dist: RPC.Distance;
      place:RPC.Place
 ):RPC.MemberRC;
  VAR
    m:  Marshal.T;
    rc: RPC.RC;
    mrc:RPC.MemberRC;
  BEGIN
    m := RPC.ClientArguments(Binder.place, ORD(OfferProc), 
                             Version, RPC.ExactlyOnce);
    Marshal.AString(name, m);
    Marshal.AWord(dist, m);
    RPC.MarshalPlace(place, m);
    rc := RPC.Call(m);
    IF rc # RPC.OK THEN RETURN RPC.NoBinder END;
    Marshal.AWord(mrc, m);
    rc := RPC.EndOfResults(m);
    IF rc # RPC.OK THEN RETURN RPC.NetBinderError END;
    RETURN mrc
  END Offer;


PROCEDURE Retract(
      name: String;
      place:RPC.Place;
      dist: RPC.Distance
 );
  VAR
    m:  Marshal.T;
    rc: RPC.RC;
    mrc:RPC.MemberRC;
  BEGIN
    m := RPC.ClientArguments(Binder.place, ORD(RetractProc), 
                             Version, RPC.AtMostOnce);
    Marshal.AString(name, m);
    RPC.MarshalPlace(place, m);
    Marshal.AWord(dist, m);
    rc := RPC.Call(m);
    IF rc = RPC.OK THEN rc := RPC.EndOfResults(m) END
  END Retract;


PROCEDURE FindAt(
      b:    RPC.Binder;
      name: String;
  VAR place:RPC.Place    (* Out *)
 ):RPC.MemberRC;
  VAR
    m:  Marshal.T;
    rc: RPC.RC;
    mrc:RPC.MemberRC;
  BEGIN
    m := RPC.ClientArguments(b, ORD(FindAtProc), 
                             Version, RPC.ExactlyOnce);
    Marshal.AString(name, m);
    rc := RPC.Call(m);
    IF rc # RPC.OK THEN RETURN RPC.NoBinder END;
    Marshal.AWord(mrc, m);
    IF mrc = RPC.BindOK THEN RPC.MarshalPlace(place, m) END;
    rc := RPC.EndOfResults(m);
    IF rc # RPC.OK THEN RETURN RPC.NetBinderError END;
    RETURN mrc
  END FindAt;


PROCEDURE Init();
  BEGIN
  END Init;


END NetMember.
