(*
    Title: 	Naff
    LastEdit:	"Tue Feb  2 11:37:24 1988"
    Author: 	Derek McAuley,Oms1,4652
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE RPCNaff;


IMPORT 
  SYSTEM, Timers;

IMPORT Threads; FROM Threads IMPORT Thread;


TYPE
  Naff  = POINTER TO NaffR;
  NaffR = 
    RECORD
      mute:       Threads.Mutex;
      cond:       Threads.Condition;
      wasSignaled:BOOLEAN
    END;


PROCEDURE WaitTimeOut(
  VAR lock:     Threads.Mutex;     (* In *)
  VAR condition:Threads.Condition; (* In *)
      seconds:  CARDINAL
 );  
  VAR
    prev,
    this,
    thing: Naff;
    thingr:NaffR;
  BEGIN
    thing := SYSTEM.ADR(thingr);
    thingr.cond := condition;
    thingr.wasSignaled := TRUE;
    Timers.CallBackSecs(seconds, Timers.FromNow, Handler, CARDINAL(thing));
    Threads.Wait(lock, condition);
    IF thingr.wasSignaled THEN
      Timers.Cancel(Handler, CARDINAL(thing))
    END;
  END WaitTimeOut;


PROCEDURE Handler(arg:CARDINAL);
  VAR
    thing:Naff;
  BEGIN
    thing := Naff(arg);
    thing^.wasSignaled := FALSE;
    Threads.Signal(thing^.cond)
  END Handler;


PROCEDURE Init();
  BEGIN END Init;


END RPCNaff.
