(* m2stub V100: at 25-Feb-88 17:43:17 *)

IMPLEMENTATION MODULE CSSecStub;

IMPORT
  Marshal, RPC, Strings, Sec, SYSTEM;

VAR
  boundTo:RPC.Place;

PROCEDURE Myname(
  VAR name:Strings.String (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(MynameProc), Version, RPC.ExactlyOnce);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AString(name, m);
    RETURN RPC.EndOfResults(m);
  END Myname;

PROCEDURE Myaddress(
  VAR address:CARDINAL (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(MyaddressProc), Version, RPC.ExactlyOnce);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(address, m);
    RETURN RPC.EndOfResults(m);
  END Myaddress;

PROCEDURE Mapname(
  VAR rc:CARDINAL; (* Out *)
  VAR address:CARDINAL; (* In *)
  VAR name:Strings.String (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(MapnameProc), Version, RPC.ExactlyOnce);
    Marshal.AWord(address, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(rc, m);
    Marshal.AString(name, m);
    RETURN RPC.EndOfResults(m);
  END Mapname;

PROCEDURE Mapaddress(
  VAR rc:CARDINAL; (* Out *)
  VAR name:Strings.String; (* In *)
  VAR address:CARDINAL (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(MapaddressProc), Version, RPC.ExactlyOnce);
    Marshal.AString(name, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(rc, m);
    Marshal.AWord(address, m);
    RETURN RPC.EndOfResults(m);
  END Mapaddress;

PROCEDURE Createchannel(
  VAR rc:CARDINAL; (* Out *)
  VAR channel:CARDINAL; (* Out *)
  VAR task:CARDINAL; (* In *)
  VAR initiatorName:Strings.String; (* In *)
  VAR initiatorAttributes:Strings.String; (* In *)
  VAR recipientName:Strings.String; (* InOut *)
  VAR recipientAttributes:Strings.String; (* InOut *)
  VAR recipientLocation:Strings.String; (* InOut *)
  VAR userdata:ARRAY OF CARDINAL; (* InOut *)
  VAR userlength:CARDINAL; (* Local *)
  VAR bandwidth:CARDINAL; (* InOut *)
  VAR priorityflag:BOOLEAN; (* InOut *)
  VAR rejectmessage:Strings.String (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(CreatechannelProc), Version, RPC.ExactlyOnce);
    Marshal.AWord(task, m);
    Marshal.AString(initiatorName, m);
    Marshal.AString(initiatorAttributes, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(rc, m);
    Marshal.AWord(channel, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    Marshal.AString(rejectmessage, m);
    RETURN RPC.EndOfResults(m);
  END Createchannel;

PROCEDURE Deletechannel(
  VAR channel:CARDINAL (* In *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(DeletechannelProc), Version, RPC.ExactlyOnce);
    Marshal.AWord(channel, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    RETURN RPC.EndOfResults(m);
  END Deletechannel;

PROCEDURE Offerservice(
  VAR rc:CARDINAL; (* Out *)
  VAR servicename:Strings.String; (* In *)
  VAR task:CARDINAL; (* In *)
  VAR unique:BOOLEAN (* In *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(OfferserviceProc), Version, RPC.ExactlyOnce);
    Marshal.AString(servicename, m);
    Marshal.AWord(task, m);
    Marshal.AWord(unique, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(rc, m);
    RETURN RPC.EndOfResults(m);
  END Offerservice;

PROCEDURE Withdrawservice(
  VAR rc:CARDINAL; (* Out *)
  VAR servicename:Strings.String (* In *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(WithdrawserviceProc), Version, RPC.ExactlyOnce);
    Marshal.AString(servicename, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(rc, m);
    RETURN RPC.EndOfResults(m);
  END Withdrawservice;

PROCEDURE AssociationCreate(
  VAR returncode:CARDINAL; (* Out *)
  VAR session:CARDINAL; (* In *)
  VAR initiatorStation:CARDINAL; (* In *)
  VAR initiatorPort:CARDINAL; (* In *)
  VAR initiatorName:Strings.String; (* In *)
  VAR initiatorAttributes:Strings.String; (* In *)
  VAR initiatorLocation:Strings.String; (* In *)
  VAR recipientStation:CARDINAL; (* Out *)
  VAR recipientPort:CARDINAL; (* Out *)
  VAR recipientName:Strings.String; (* InOut *)
  VAR recipientAttributes:Strings.String; (* InOut *)
  VAR recipientLocation:Strings.String; (* InOut *)
  VAR userdata:ARRAY OF CARDINAL; (* InOut *)
  VAR userlength:CARDINAL; (* Local *)
  VAR bandwidth:CARDINAL; (* InOut *)
  VAR priorityflag:BOOLEAN; (* InOut *)
  VAR rejectmessage:Strings.String (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(AssociationCreateProc), Version, RPC.ExactlyOnce);
    Marshal.AWord(session, m);
    Marshal.AWord(initiatorStation, m);
    Marshal.AWord(initiatorPort, m);
    Marshal.AString(initiatorName, m);
    Marshal.AString(initiatorAttributes, m);
    Marshal.AString(initiatorLocation, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    rpcRc := RPC.Call(m);
    IF rpcRc # RPC.OK THEN RETURN rpcRc END;
    Marshal.AWord(returncode, m);
    Marshal.AWord(recipientStation, m);
    Marshal.AWord(recipientPort, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    Marshal.AString(rejectmessage, m);
    RETURN RPC.EndOfResults(m);
  END AssociationCreate;

PROCEDURE Find(name:Strings.String; dist:RPC.Distance):RPC.MemberRC;
  BEGIN
    RETURN RPC.Find(name, dist, boundTo);
  END Find;

END CSSecStub.
