(* m2stub V100: at 25-Feb-88 17:43:17 *)

IMPLEMENTATION MODULE SSSecServ;

IMPORT
  Marshal,RPC, Strings, Sec, SYSTEM, SecServ;

PROCEDURE AssociationCreateStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    initiatorStation:CARDINAL; (* In *)
    initiatorPort:CARDINAL; (* In *)
    initiatorName:Strings.String; (* In *)
    initiatorAttributes:Strings.String; (* In *)
    initiatorLocation:Strings.String; (* In *)
    recipientStation:CARDINAL; (* Out *)
    recipientPort:CARDINAL; (* Out *)
    recipientName:Strings.String; (* InOut *)
    recipientAttributes:Strings.String; (* InOut *)
    recipientLocation:Strings.String; (* InOut *)
    userdata:ARRAY [0..Sec.Maxuserlength-1] OF CARDINAL; (* InOut *)
    userlength:CARDINAL; (* Local *)
    bandwidth:CARDINAL; (* InOut *)
    priorityflag:BOOLEAN; (* InOut *)
    rejectmessage:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(session, m);
    Marshal.AWord(initiatorStation, m);
    Marshal.AWord(initiatorPort, m);
    Marshal.AString(initiatorName, m);
    Marshal.AString(initiatorAttributes, m);
    Marshal.AString(initiatorLocation, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.AssociationCreate(rc, session, initiatorStation, initiatorPort, initiatorName, initiatorAttributes, initiatorLocation, recipientStation, recipientPort, recipientName, recipientAttributes, recipientLocation, userdata, userlength, bandwidth, priorityflag, rejectmessage);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AWord(recipientStation, m);
        Marshal.AWord(recipientPort, m);
        Marshal.AString(recipientName, m);
        Marshal.AString(recipientAttributes, m);
        Marshal.AString(recipientLocation, m);
        Marshal.AnArrayOfWord(userdata, userlength, m);
        Marshal.AWord(bandwidth, m);
        Marshal.AWord(priorityflag, m);
        Marshal.AString(rejectmessage, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END AssociationCreateStub;

PROCEDURE AliveStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
  BEGIN
    Marshal.AWord(session, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Alive(rc, session);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END AliveStub;

PROCEDURE RegisterlocalstubStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* Out *)
    task:CARDINAL; (* In *)
  BEGIN
    Marshal.AWord(task, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Registerlocalstub(rc, session, task);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AWord(session, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END RegisterlocalstubStub;

PROCEDURE MapnameStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    address:CARDINAL; (* In *)
    name:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(session, m);
    Marshal.AWord(address, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Mapname(rc, session, address, name);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AString(name, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MapnameStub;

PROCEDURE MapaddressStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    name:Strings.String; (* In *)
    address:CARDINAL; (* Out *)
  BEGIN
    Marshal.AWord(session, m);
    Marshal.AString(name, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Mapaddress(rc, session, name, address);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AWord(address, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MapaddressStub;

PROCEDURE MynameStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    name:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(session, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Myname(rc, session, name);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AString(name, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MynameStub;

PROCEDURE AddserviceStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    servicename:Strings.String; (* In *)
    unique:BOOLEAN; (* In *)
  BEGIN
    Marshal.AWord(session, m);
    Marshal.AString(servicename, m);
    Marshal.AWord(unique, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Addservice(rc, session, servicename, unique);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END AddserviceStub;

PROCEDURE DeleteserviceStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    servicename:Strings.String; (* In *)
  BEGIN
    Marshal.AWord(session, m);
    Marshal.AString(servicename, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecServ.Deleteservice(rc, session, servicename);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END DeleteserviceStub;

PROCEDURE Receiver(p:RPC.PktBuf):RPC.PktBuf;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
    proc:CARDINAL;
  BEGIN
    rpcRc := RPC.ServerProcedureVCheck(p, m, proc, SecServ.Version);
    IF rpcRc = RPC.OK THEN
      CASE SecServ.Procedures(proc) OF
        SecServ.AssociationCreateProc: AssociationCreateStub(m)
      | SecServ.AliveProc: AliveStub(m)
      | SecServ.RegisterlocalstubProc: RegisterlocalstubStub(m)
      | SecServ.MapnameProc: MapnameStub(m)
      | SecServ.MapaddressProc: MapaddressStub(m)
      | SecServ.MynameProc: MynameStub(m)
      | SecServ.AddserviceProc: AddserviceStub(m)
      | SecServ.DeleteserviceProc: DeleteserviceStub(m)
      ELSE RPC.SetReturnCode(RPC.ProcError, m)
      END
    ELSE
      RPC.SetReturnCode(rpcRc, m)
    END;
    RETURN RPC.EndOfCall(m)
  END Receiver;

PROCEDURE Offer(name:Strings.String; dist:RPC.Distance):RPC.MemberRC;
  VAR
    id:RPC.ServiceId;
  BEGIN
    RETURN RPC.Offer(name, dist, Receiver, 0, id);
  END Offer;

END SSSecServ.
