(* m2stub V100: at 25-Feb-88 17:43:17 *)

IMPLEMENTATION MODULE SSSecStub;

IMPORT
  Marshal,RPC, Strings, Sec, SYSTEM, SecStub;

PROCEDURE MynameStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    name:Strings.String; (* Out *)
  BEGIN
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Myname(name);
      IF rpcRc = RPC.OK THEN
        Marshal.AString(name, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MynameStub;

PROCEDURE MyaddressStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    address:CARDINAL; (* Out *)
  BEGIN
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Myaddress(address);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(address, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MyaddressStub;

PROCEDURE MapnameStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    address:CARDINAL; (* In *)
    name:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(address, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Mapname(rc, address, name);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AString(name, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MapnameStub;

PROCEDURE MapaddressStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    name:Strings.String; (* In *)
    address:CARDINAL; (* Out *)
  BEGIN
    Marshal.AString(name, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Mapaddress(rc, name, address);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AWord(address, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END MapaddressStub;

PROCEDURE CreatechannelStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    channel:CARDINAL; (* Out *)
    task:CARDINAL; (* In *)
    initiatorName:Strings.String; (* In *)
    initiatorAttributes:Strings.String; (* In *)
    recipientName:Strings.String; (* InOut *)
    recipientAttributes:Strings.String; (* InOut *)
    recipientLocation:Strings.String; (* InOut *)
    userdata:ARRAY [0..Sec.Maxuserlength-1] OF CARDINAL; (* InOut *)
    userlength:CARDINAL; (* Local *)
    bandwidth:CARDINAL; (* InOut *)
    priorityflag:BOOLEAN; (* InOut *)
    rejectmessage:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(task, m);
    Marshal.AString(initiatorName, m);
    Marshal.AString(initiatorAttributes, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Createchannel(rc, channel, task, initiatorName, initiatorAttributes, recipientName, recipientAttributes, recipientLocation, userdata, userlength, bandwidth, priorityflag, rejectmessage);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        Marshal.AWord(channel, m);
        Marshal.AString(recipientName, m);
        Marshal.AString(recipientAttributes, m);
        Marshal.AString(recipientLocation, m);
        Marshal.AnArrayOfWord(userdata, userlength, m);
        Marshal.AWord(bandwidth, m);
        Marshal.AWord(priorityflag, m);
        Marshal.AString(rejectmessage, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END CreatechannelStub;

PROCEDURE DeletechannelStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    channel:CARDINAL; (* In *)
  BEGIN
    Marshal.AWord(channel, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Deletechannel(channel);
      IF rpcRc = RPC.OK THEN
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END DeletechannelStub;

PROCEDURE OfferserviceStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    servicename:Strings.String; (* In *)
    task:CARDINAL; (* In *)
    unique:BOOLEAN; (* In *)
  BEGIN
    Marshal.AString(servicename, m);
    Marshal.AWord(task, m);
    Marshal.AWord(unique, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Offerservice(rc, servicename, task, unique);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END OfferserviceStub;

PROCEDURE WithdrawserviceStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    rc:CARDINAL; (* Out *)
    servicename:Strings.String; (* In *)
  BEGIN
    Marshal.AString(servicename, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.Withdrawservice(rc, servicename);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(rc, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END WithdrawserviceStub;

PROCEDURE AssociationCreateStub(m:Marshal.T);
  VAR
    rpcRc:RPC.RC;
    returncode:CARDINAL; (* Out *)
    session:CARDINAL; (* In *)
    initiatorStation:CARDINAL; (* In *)
    initiatorPort:CARDINAL; (* In *)
    initiatorName:Strings.String; (* In *)
    initiatorAttributes:Strings.String; (* In *)
    initiatorLocation:Strings.String; (* In *)
    recipientStation:CARDINAL; (* Out *)
    recipientPort:CARDINAL; (* Out *)
    recipientName:Strings.String; (* InOut *)
    recipientAttributes:Strings.String; (* InOut *)
    recipientLocation:Strings.String; (* InOut *)
    userdata:ARRAY [0..Sec.Maxuserlength-1] OF CARDINAL; (* InOut *)
    userlength:CARDINAL; (* Local *)
    bandwidth:CARDINAL; (* InOut *)
    priorityflag:BOOLEAN; (* InOut *)
    rejectmessage:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(session, m);
    Marshal.AWord(initiatorStation, m);
    Marshal.AWord(initiatorPort, m);
    Marshal.AString(initiatorName, m);
    Marshal.AString(initiatorAttributes, m);
    Marshal.AString(initiatorLocation, m);
    Marshal.AString(recipientName, m);
    Marshal.AString(recipientAttributes, m);
    Marshal.AString(recipientLocation, m);
    Marshal.AnArrayOfWord(userdata, userlength, m);
    Marshal.AWord(bandwidth, m);
    Marshal.AWord(priorityflag, m);
    rpcRc := RPC.EndOfArgs(m);
    IF rpcRc = RPC.OK THEN
      rpcRc := SecStub.AssociationCreate(returncode, session, initiatorStation, initiatorPort, initiatorName, initiatorAttributes, initiatorLocation, recipientStation, recipientPort, recipientName, recipientAttributes, recipientLocation, userdata, userlength, bandwidth, priorityflag, rejectmessage);
      IF rpcRc = RPC.OK THEN
        Marshal.AWord(returncode, m);
        Marshal.AWord(recipientStation, m);
        Marshal.AWord(recipientPort, m);
        Marshal.AString(recipientName, m);
        Marshal.AString(recipientAttributes, m);
        Marshal.AString(recipientLocation, m);
        Marshal.AnArrayOfWord(userdata, userlength, m);
        Marshal.AWord(bandwidth, m);
        Marshal.AWord(priorityflag, m);
        Marshal.AString(rejectmessage, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rpcRc, m)
  END AssociationCreateStub;

PROCEDURE Receiver(p:RPC.PktBuf):RPC.PktBuf;
  VAR
    m:Marshal.T;
    rpcRc:RPC.RC;
    proc:CARDINAL;
  BEGIN
    rpcRc := RPC.ServerProcedureVCheck(p, m, proc, SecStub.Version);
    IF rpcRc = RPC.OK THEN
      CASE SecStub.Procedures(proc) OF
        SecStub.MynameProc: MynameStub(m)
      | SecStub.MyaddressProc: MyaddressStub(m)
      | SecStub.MapnameProc: MapnameStub(m)
      | SecStub.MapaddressProc: MapaddressStub(m)
      | SecStub.CreatechannelProc: CreatechannelStub(m)
      | SecStub.DeletechannelProc: DeletechannelStub(m)
      | SecStub.OfferserviceProc: OfferserviceStub(m)
      | SecStub.WithdrawserviceProc: WithdrawserviceStub(m)
      | SecStub.AssociationCreateProc: AssociationCreateStub(m)
      ELSE RPC.SetReturnCode(RPC.ProcError, m)
      END
    ELSE
      RPC.SetReturnCode(rpcRc, m)
    END;
    RETURN RPC.EndOfCall(m)
  END Receiver;

PROCEDURE Offer(name:Strings.String; dist:RPC.Distance):RPC.MemberRC;
  VAR
    id:RPC.ServiceId;
  BEGIN
    RETURN RPC.Offer(name, dist, Receiver, 0, id);
  END Offer;

END SSSecStub.
