(* m2stub V100: at 25-Feb-88 17:33:28 *)

IMPLEMENTATION MODULE SecStub;

IMPORT
  CfrHand, CSSecServ, RPC, Strings, Sec;


PROCEDURE Myname(
VAR name:Strings.String (* Out *)
  ):RPC.RC;
  BEGIN
    name := Strings.CopySS(myName);
    RETURN RPC.OK
  END Myname;


PROCEDURE Myaddress(
VAR address:CARDINAL (* Out *)
  ):RPC.RC;
  BEGIN
    address := myAddress;
    RETURN RPC.OK
  END Myaddress;


PROCEDURE Mapname(
VAR rc:CARDINAL; (* Out *)
VAR address:CARDINAL; (* In *)
VAR name:Strings.String (* Out *)
  ):RPC.RC;
  BEGIN
    RETURN CSSecServ.Mapname(rc, address, name)
  END Mapname;


PROCEDURE Mapaddress(
VAR rc:CARDINAL; (* Out *)
VAR name:Strings.String; (* In *)
VAR address:CARDINAL (* Out *)
  ):RPC.RC;
  VAR
    rpcRc:RPC.RC;
  BEGIN
    rpcRc := CSSecServ.MapAddress(rc, name, address);
    Strings.Dispose(name);
    RETURN rpcRC
  END Mapaddress;


PROCEDURE Createchannel(
VAR rc:CARDINAL; (* Out *)
VAR channel:CARDINAL; (* Out *)
VAR task:CARDINAL; (* In *)
VAR initiatorName:Strings.String; (* In *)
VAR initiatorAttributes:Strings.String; (* In *)
VAR recipientName:Strings.String; (* InOut *)
VAR recipientAttributes:Strings.String; (* InOut *)
VAR recipientLocation:Strings.String; (* InOut *)
VAR userdata:ARRAY OF CARDINAL; (* InOut *)
VAR userlength:CARDINAL; (* Local *)
VAR bandwidth:CARDINAL; (* InOut *)
VAR priorityflag:BOOLEAN; (* InOut *)
VAR rejectmessage:Strings.String (* Out *)
  ):RPC.RC;
  VAR
    rpcRc:RPC.RC;
    assoc, port, peeraddr, peerport:CARDINAL;
    name, attr, loc:Strings.String;
  BEGIN
    assoc := 0;
    port := 0;
    peeraddr := 0;
    peerport := 0;
    name := recipientName;
    attr := recipientAttributes;
    loc := recipientLocation;
    
    CfrHand.AddAssociation(assoc, port, 0, 0, CfrHand.DefaultTime);
    
    rpcRC := CSSecServ.AssociationCreate(rc, curSession, myAddress, port, 
      initiatorName, initiatorAttributes, myName, peeraddr, peerport,
      recipientName, recipientAttributes, recipientLocation, userdata,
      userlength, bandwidth, priororityflag, rejectmessage);
    
    Strings.Dispose(initiatorName);
    Strings.Dispose(initiatorAttributes);
    Strings.Dispose(name);
    Strings.Dispose(attr);
    Strings.Dispose(attr);
    
    IF rpcRC = RPC.OK THEN
      CfrHand.Modifyassociation(assoc, peeraddr, peerport,CfrHand.DefaultTime)
    ELSE
      CfrHand.Deleteassociation(assoc)
    END;
    RETURN rpcRC
  END Createchannel;


PROCEDURE Deletechannel(
VAR channel:CARDINAL (* In *)
  ):RPC.RC;
  BEGIN
    RETURN RPC.OK
  END DeleteChannel;


PROCEDURE Offerservice(
VAR rc:CARDINAL; (* Out *)
VAR servicename:Strings.String; (* In *)
VAR task:CARDINAL; (* In *)
VAR unique:BOOLEAN (* In *)
  ):RPC.RC;
  VAR
    rpcRc:RPC.RC;
  BEGIN
    rpcRC := CSSecServ.Addservice(rc, servname, unique);
    Strings.Dispose(servname);
    RETURN rpcRc   
  END Offerservice;


PROCEDURE Withdrawservice(
VAR rc:CARDINAL; (* Out *)
VAR servicename:Strings.String (* In *)
  ):RPC.RC;
  VAR
    rpcRc:RPC.RC;
  BEGIN
    rpcRC := CSSecSErv.AddService(rc, servname);
    Strings.Dispose(servname);
    RETURN rpcRc
  END Withdrawservbice;


PROCEDURE AssociationCreate(
VAR returncode:CARDINAL; (* Out *)
VAR session:CARDINAL; (* In *)
VAR initiatorStation:CARDINAL; (* In *)
VAR initiatorPort:CARDINAL; (* In *)
VAR initiatorName:Strings.String; (* In *)
VAR initiatorAttributes:Strings.String; (* In *)
VAR initiatorLocation:Strings.String; (* In *)
VAR recipientStation:CARDINAL; (* Out *)
VAR recipientPort:CARDINAL; (* Out *)
VAR recipientName:Strings.String; (* InOut *)
VAR recipientAttributes:Strings.String; (* InOut *)
VAR recipientLocation:Strings.String; (* InOut *)
VAR userdata:ARRAY OF CARDINAL; (* InOut *)
VAR userlength:CARDINAL; (* Local *)
VAR bandwidth:CARDINAL; (* InOut *)
VAR priorityflag:BOOLEAN; (* InOut *)
VAR rejectmessage:Strings.String (* Out *)
  ):RPC.RC;
  BEGIN
    IF session # curSession THEN
      rc := Sec.InvalidSession;
      RETURN RPC.OK
    END;
    RETURN RPC.OK
  END AssociationCreate;


END SecStub.
