MODULE m2stub;


IMPORT
  Generate, Strings, SysStreams, UnixArgs, UtilError, WriteF;


PROCEDURE Usage ();
  BEGIN
    UtilError.ReportError(TRUE, "usage: m2stub [-v] module\n", 0, 0)
  END Usage;


PROCEDURE ParseN(args:INTEGER);
  VAR
    rc:Generate.RC;
    name:ARRAY [0..63] OF CHAR;
  BEGIN
    IF args = 2 THEN
      UnixArgs.GetArg(1, name);
      IF Strings.EqualCC("-v", name) THEN
        Generate.beVerbose := NOT Generate.beVerbose
      ELSE
        Usage();
        RETURN
      END
    END;
    UnixArgs.GetArg(args, name);
    rc := Generate.Files(name);
    IF rc # Generate.OK THEN
      UtilError.ReportError(TRUE, "m2stub: failed %i\n", rc, 0)
    END;
  END ParseN;


BEGIN
  CASE UnixArgs.argCount OF
    2,3: ParseN(UnixArgs.argCount-1)
  ELSE   Usage()
  END
END m2stub.
