(* $Header: Aout.mod,v 1.2 87/03/02 17:50:03 can Exp $ *)
(* $Log:	Aout.mod,v $
Revision 1.2  87/03/02  17:50:03  can
Tidied and commented m2ld

Revision 1.1  87/03/02  11:22:59  can
Initial revision
 *)

IMPLEMENTATION MODULE Aout;

FROM SYSTEM IMPORT WORD, TSIZE, BYTESPERWORD;

(* Now in SunSpecific.def
FROM SystemTypes IMPORT Short;
FROM Fields IMPORT Extract, Insert;

CONST
	(* Bit positions for bit field access in kludge. *)
	SrSymbolnum	= 0;
	ErSymbolnum	= 23;

	RPcrel		= 24;

	SrLength	= 25;
	ErLength	= 26;

	RExtern		= 27;

(* Validate Magic number, returns TRUE if bad, FALSE if valid. *)
PROCEDURE NBadMag( ptrHeader: PtrExec ): BOOLEAN;
BEGIN

  	 IF	(ptrHeader^.aMagic # OMAGIC) AND
		(ptrHeader^.aMagic # NMAGIC) AND
		(ptrHeader^.aMagic # ZMAGIC)
	THEN
		RETURN( TRUE );
	ELSE
		RETURN( FALSE );
	END;

END NBadMag;


(* Determine offset for text segment. *)
PROCEDURE NTxtOff( ptrHeader: PtrExec ): CARDINAL;
BEGIN

	IF ptrHeader^.aMagic = ZMAGIC THEN
		RETURN( pageSize );
	ELSE 
		RETURN( sizeExec );
	END;

END NTxtOff;


(* Determine offset for symbol table. *)
PROCEDURE NSymOff( ptrHeader: PtrExec ): CARDINAL;
BEGIN

	RETURN( NTxtOff(ptrHeader)	+
			ptrHeader^.aText	+
			ptrHeader^.aData	+
			ptrHeader^.aTrsize	+
			ptrHeader^.aDrsize	);

END NSymOff;


(* Determine offset for string table. *)
PROCEDURE NStrOff( ptrHeader: PtrExec ): CARDINAL;
BEGIN

	RETURN( NSymOff(ptrHeader) + ptrHeader^.aSyms );

END NStrOff;


PROCEDURE RSymbolnumExtract( relInfo: PtrRelocationInfo ): CARDINAL; 
BEGIN

	RETURN( Extract( relInfo^.kludge, SrSymbolnum, ErSymbolnum ) );

END RSymbolnumExtract;


PROCEDURE RSymbolnumInsert( relInfo: PtrRelocationInfo; value: CARDINAL);
BEGIN

	Insert( relInfo^.kludge, SrSymbolnum, ErSymbolnum, value );

END RSymbolnumInsert;


PROCEDURE RPcrelExtract( relInfo: PtrRelocationInfo ): BOOLEAN;
BEGIN

	RETURN( RPcrel IN relInfo^.kludge );

END RPcrelExtract;


PROCEDURE RPcrelInsert( relInfo: PtrRelocationInfo; value: BOOLEAN );
BEGIN

	IF value THEN
		INCL( relInfo^.kludge, RPcrel );
	ELSE 
		EXCL( relInfo^.kludge, RPcrel );
	END;

END RPcrelInsert;


PROCEDURE RLengthExtract( relInfo: PtrRelocationInfo ): CARDINAL;
BEGIN

	RETURN( Extract( relInfo^.kludge, SrLength, ErLength ) );

END RLengthExtract;


PROCEDURE RLengthInsert( relInfo: PtrRelocationInfo; value: CARDINAL);
BEGIN

	Insert( relInfo^.kludge, SrLength, ErLength, value );

END RLengthInsert;


PROCEDURE RExternExtract( relInfo: PtrRelocationInfo ): BOOLEAN;
BEGIN

	RETURN( RExtern IN relInfo^.kludge );

END RExternExtract;


PROCEDURE RExternInsert( relInfo: PtrRelocationInfo; value: BOOLEAN );
BEGIN

	IF value THEN
		INCL( relInfo^.kludge, RExtern );
	ELSE 
		EXCL( relInfo^.kludge, RExtern );
	END;

END RExternInsert;
*)

BEGIN

	(*  Initialise size variables. *)
	(* TSIZE on a vax returns the size in WORDS, not bytes. *)
	sizeExec := (TSIZE( Exec ) DIV TSIZE( WORD )) * BYTESPERWORD;
	sizeRelocationInfo := (TSIZE( RelocationInfo ) DIV TSIZE( WORD ))
										* BYTESPERWORD;
	sizeNlist := (TSIZE( Nlist ) DIV TSIZE( WORD )) * BYTESPERWORD;

END Aout.
