IMPLEMENTATION MODULE Foo;

IMPORT
  Marshal, RPC, Strings, SYSTEM;

VAR
  boundTo:RPC.Place;

PROCEDURE HelloWorld(
  VAR oneOne:INTEGER; (* In *)
  VAR two:BOOLEAN; (* InOut *)
  VAR three:Strings.String (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(HelloWorldProc), Version, RPC.AtMostOnce);
    Marshal.AWord(oneOne, m);
    Marshal.AWord(two, m);
    rc := RPC.Call(m);
    IF rc # RPC.OK THEN RETURN rc END;
    Marshal.AWord(two, m);
    Marshal.AString(three, m);
    RETURN RPC.EndOfResults(m);
  END HelloWorld;

PROCEDURE Not(
  VAR two:BOOLEAN (* InOut *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(NotProc), Version, RPC.ExactlyOnce);
    Marshal.AWord(two, m);
    rc := RPC.Call(m);
    IF rc # RPC.OK THEN RETURN rc END;
    Marshal.AWord(two, m);
    RETURN RPC.EndOfResults(m);
  END Not;

PROCEDURE Array(
  VAR size:CARDINAL; (* Local *)
  VAR ar1:ARRAY OF INTEGER; (* In *)
  VAR ar2:ARRAY OF CHAR (* Out *)
    ):RPC.RC;
  VAR
    m:Marshal.T;
    rc:RPC.RC;
  BEGIN
    m := RPC.ClientArguments(boundTo, ORD(ArrayProc), Version, RPC.AtLeastOnce);
    Marshal.Words(SYSTEM.ADR(ar1), 19, m);
    rc := RPC.Call(m);
    IF rc # RPC.OK THEN RETURN rc END;
    Marshal.AnArrayOfChar(ar2, size, m);
    RETURN RPC.EndOfResults(m);
  END Array;

PROCEDURE Find(name:Strings.String; dist:RPC.Distance):RPC.MemberRC;
  BEGIN
    RETURN RPC.Find(name, dist, boundTo);
  END Find;

END Foo.
