IMPLEMENTATION MODULE SSFoo;

IMPORT
  Marshal,RPC, Strings, SYSTEM, Foo;

PROCEDURE HelloWorldStub(m:Marshal.T);
  VAR
    rc:RPC.RC;
    oneOne:INTEGER; (* In *)
    two:BOOLEAN; (* InOut *)
    three:Strings.String; (* Out *)
  BEGIN
    Marshal.AWord(oneOne, m);
    Marshal.AWord(two, m);
    rc := RPC.EndOfArgs(m);
    IF rc = RPC.OK THEN
      rc := Foo.HelloWorld(oneOne, two, three);
      IF rc = RPC.OK THEN
        Marshal.AWord(two, m);
        Marshal.AString(three, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rc, m)
  END HelloWorldStub;

PROCEDURE NotStub(m:Marshal.T);
  VAR
    rc:RPC.RC;
    two:BOOLEAN; (* InOut *)
  BEGIN
    Marshal.AWord(two, m);
    rc := RPC.EndOfArgs(m);
    IF rc = RPC.OK THEN
      rc := Foo.Not(two);
      IF rc = RPC.OK THEN
        Marshal.AWord(two, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rc, m)
  END NotStub;

PROCEDURE ArrayStub(m:Marshal.T);
  VAR
    rc:RPC.RC;
    size:CARDINAL; (* Local *)
    ar1:ARRAY [0..19-1] OF INTEGER; (* In *)
    ar2:ARRAY [0..128-1] OF CHAR; (* Out *)
  BEGIN
    Marshal.Words(SYSTEM.ADR(ar1), 19, m);
    rc := RPC.EndOfArgs(m);
    IF rc = RPC.OK THEN
      rc := Foo.Array(size, ar1, ar2);
      IF rc = RPC.OK THEN
        Marshal.AnArrayOfChar(ar2, size, m);
        RETURN
      END
    END;
    RPC.SetReturnCode(rc, m)
  END ArrayStub;

PROCEDURE Receiver(p:RPC.PktBuf):RPC.PktBuf;
  VAR
    m:Marshal.T;
    rc:RPC.RC;
    proc:CARDINAL;
  BEGIN
    rc := RPC.ServerProcedureVCheck(p, m, proc, Foo.Version);
    IF rc = RPC.OK THEN
      CASE Foo.Procedures(proc) OF
        Foo.HelloWorldProc: HelloWorldStub(m)
      | Foo.NotProc: NotStub(m)
      | Foo.ArrayProc: ArrayStub(m)
      ELSE RPC.SetReturnCode(RPC.ProcError, m)
      END
    ELSE
      RPC.SetReturnCode(rc, m)
    END;
    RETURN RPC.EndOfCall(m)
  END Receiver;

PROCEDURE Offer(name:Strings.String; dist:RPC.Distance):RPC.MemberRC;
  VAR
    id:RPC.ServiceId;
  BEGIN
    RETURN RPC.Offer(name, dist, Receiver, 0, id);
  END Offer;

END SSFoo.
