IMPLEMENTATION MODULE FirstPass; (* $T- *)
FROM items IMPORT Int16Bit;
FROM labels IMPORT SetUpPermanentLabelTable;
FROM CodeProcs IMPORT ignore, next, next2, next4,
	       	      ValueOfNextByte, ValueOfNextTwoBytes,
		      LabelRelativeJump, LabelAbsoluteJump,
                      LabelRelativeJumpBack, NextInstruction,
                      StepToNextInstruction, WipeOut,
                      MarkStartOfCaseLabelTable,
                      AtCaseLabelTable,
		      FindStartOfProc,
		      NotAtEndOfTable, NotAtEndOfCode;
FROM MCMnemonics IMPORT 
    JPC, JP, JPFC, JPF, JPBC, JPB, ORJP, ANDJP, FOR1, FOR2, ENTC,
    CI, CF, CL, CLn;


PROCEDURE PreProcessInstruction ();
   
   VAR hi, low        : INTEGER;
       count, entries : CARDINAL;
       Instruction    : CARDINAL;
       Length, Offset : CARDINAL;
       Temp : CARDINAL;
BEGIN
    IF AtCaseLabelTable () THEN
        low := INTEGER (next4 ());
        hi := INTEGER (next4 ());
        entries := CARDINAL (ABS (hi-low)) + 2;
        (* 2 - one for 'telegraph pole' and one for ELSE exit *)
        LabelRelativeJump (2*entries);
        StepToNextInstruction (4);
        LabelRelativeJump (4);
        StepToNextInstruction (4);
        FOR count := 1 TO entries DO
            LabelRelativeJump (ValueOfNextTwoBytes ());
            StepToNextInstruction (2)
        END
    ELSE Instruction := NextInstruction (Length);

        IF (JPC <= Instruction) AND (Instruction <= ANDJP) THEN
            CASE Instruction OF
              JPC, JP:
                Offset := ValueOfNextTwoBytes ();
                IF Offset = 1 THEN
                    WipeOut (3)
                ELSE LabelRelativeJump (Offset);
                END;
            | JPFC, JPF, ORJP, ANDJP:
                Offset := ValueOfNextByte ();
                IF Offset = 1 THEN
                    WipeOut (2);
                ELSE LabelRelativeJump (Offset);
                END
            | JPBC, JPB:
                LabelRelativeJumpBack (ValueOfNextByte ());
            END;
        ELSIF Instruction = FOR1 THEN
            ignore (next ());
            LabelRelativeJump (ValueOfNextTwoBytes ());
        ELSIF Instruction = FOR2 THEN
            ignore (next2 ());
            LabelRelativeJump (ValueOfNextTwoBytes ());
        ELSIF Instruction = ENTC THEN
            MarkStartOfCaseLabelTable ();
        ELSIF Instruction >= CI THEN
            CASE Instruction OF
              CI, CL:
            (* CI and CL call procedure at intermediate level and call local
             procedure. The labels for these jumps can be found in the table
             that precedes the code  *)
                FindStartOfProc (ValueOfNextByte ());
            | CLn+1..CLn+15:
            (* CL1-CL15 call local procedure. Similar to above *)
                FindStartOfProc (Instruction MOD 16);
            ELSE (* do nothing *)
            END;
        END;
        StepToNextInstruction (Length);
    END;
END PreProcessInstruction;


PROCEDURE PreProcessTable ();
   BEGIN 
      WHILE NotAtEndOfTable DO
	 LabelAbsoluteJump (ValueOfNextTwoBytes ());
	 StepToNextInstruction (2)
      END
   END PreProcessTable;


PROCEDURE PreProcessCode ();
   BEGIN
      WHILE NotAtEndOfCode DO
	 PreProcessInstruction ()
      END;
      SetUpPermanentLabelTable;
   END PreProcessCode;



END FirstPass.
