IMPLEMENTATION MODULE LoadStore; (* $T- *)

FROM items IMPORT ITEM, MODE, REGISTER, Max16BitCard;
FROM PsStk IMPORT Pop, Push;
FROM CodeProcs IMPORT next, next2, LoadingFormalProcedure;
FROM UtilError IMPORT ReportError;
FROM MCMnemonics IMPORT
    LIB, LIn, LIW, LID, LLA, LGA, LLW, LLWn, LLD, LGW, LGWn, LGD, SLW, SLWn,
    SLD, SGW, SGWn, SGD;
FROM Procs IMPORT ParmSpace, LinkSpace;

PROCEDURE LocalOffset (Local: INTEGER) : INTEGER;
    BEGIN
        IF Local < 4 THEN ReportError (FALSE, "Local Var %i", Local, 0) END;
	IF Local - 4 >= ParmSpace THEN
	    RETURN Local - 3 - ParmSpace
	ELSE RETURN Local - 3 - ParmSpace - LinkSpace
	END
    END LocalOffset;

PROCEDURE SimpleLoads (Instruction : CARDINAL);
   VAR disp : CARDINAL;
       intdisp : INTEGER;
BEGIN
    IF (LIn+0 <= Instruction) AND (Instruction <= LGA) THEN
        CASE Instruction OF
          LIB: (* load immediate byte *) Push (Immediate, NoReg, next ())
        | LIW: (* load immediate word *)
            IF LoadingFormalProcedure () THEN
                Push (FormalProcedure, NoReg, next2 ())
            ELSE Push (Immediate, NoReg, next2())
            END;
        | LID: (* load immediate double word *)
            Push (Immediate, NoReg, INTEGER ((next2 () * (Max16BitCard + 1))
                                                    + next2 ()))
        | LLA: (* load local address *)
	    intdisp := LocalOffset (INTEGER (next()));
            Push (ADDRaddrRegDisp, L, - intdisp)
        | LGA: (* load global address *)
            Push (ADDRaddrRegDisp, G, next ())
        ELSE (* load immediate 0..15 *)
            Push (Immediate, NoReg, Instruction MOD 16)
        END;
    ELSIF (LLW <= Instruction) AND (Instruction <= LLWn+15) THEN
        IF Instruction >= LLWn+4 THEN
	    intdisp := LocalOffset (INTEGER (Instruction MOD 16));
            Push (AddrRegDisp, L, - intdisp)
        ELSIF Instruction = LLW THEN
	    intdisp := LocalOffset (INTEGER (next()));
            Push (AddrRegDisp, L, - intdisp)
        ELSE (* LLD *)
            intdisp :=  LocalOffset (INTEGER (next ()));
            Push (AddrRegDisp, L, -intdisp);
            Push (AddrRegDisp, L, -intdisp-1)
        END;
    ELSIF Instruction >= LGWn+2 THEN (* LGW2-LGW15 load global word *)
        Push (AddrRegDisp, G, Instruction MOD 16) 
    ELSIF Instruction = LGW THEN (* load global word *)
        Push (AddrRegDisp, G, next ())
    ELSE (* LGD load global double word *)
        disp := next ();
        Push (AddrRegDisp, G, disp);
        Push (AddrRegDisp, G, disp+1)
    END;
END SimpleLoads;

 
PROCEDURE SimpleStores (Instruction : CARDINAL);
   VAR disp : CARDINAL;
       intdisp : INTEGER;
BEGIN
    IF Instruction <= SLWn+15 THEN
        IF Instruction >= SLWn+4 THEN (* SLW4-SLW15 store local word 4-15 *)
	    intdisp := LocalOffset (INTEGER (Instruction MOD 16));
            Pop (AddrRegDisp, L, - intdisp)
        ELSIF Instruction = SLW THEN (* store local word *)
	    intdisp := LocalOffset (INTEGER (next()));
            Pop (AddrRegDisp, L, - intdisp)
        ELSE (* SLD store local double word *)
            intdisp := LocalOffset (INTEGER (next ()));
            Pop (AddrRegDisp, L, -intdisp-1);
            Pop (AddrRegDisp, L, -intdisp)
        END;
    ELSE
        IF Instruction >= SGWn+2 THEN (* SGW2-SGW15 store global word *)
            Pop (AddrRegDisp, G, Instruction MOD 16) 
        ELSIF Instruction = SGW THEN (* store global word *)
            Pop (AddrRegDisp, G, next ())
        ELSE (* SGD store global double word *)
            disp := next ();
            Pop (AddrRegDisp, G, disp+1);
            Pop (AddrRegDisp, G, disp)
        END;
    END;
END SimpleStores;

END LoadStore.
