IMPLEMENTATION MODULE Operations; (* $T- *)

FROM items IMPORT Operator, MonOperator;
FROM PsStk IMPORT SetDyadicOp, SetMonadicOp, NOTPendingRelationalOp;
FROM MCMnemonics IMPORT
    ULSS, ULEQ, UGTR, UGEQ, UADD, USUB, UMUL, UDIV, UMOD, ROR, SHL, SHR, EQL,
    NEQ, LSS, LEQ, GTR, GEQ, ORR, XORR, ANDD, INN, ADD, SUB, MUL, DIVV, MODD,
    ABSS, NEG, COM, MSK, NOTT, BIT;

PROCEDURE DyadicOp (instruction : CARDINAL);
   VAR op : Operator;
   BEGIN
      CASE instruction OF

       ULSS : (* ULSS *) op := Ulss |
       ULEQ : (* ULEQ *) op := Uleq |
       UGTR : (* UGTR *) op := Ugtr |
       UGEQ : (* UGEQ *) op := Ugeq |
       UADD : (* UADD *) op := Uadd |
       USUB : (* USUB *) op := Usub |
       UMUL : (* UMUL *) op := Umul |
       UDIV : (* UDIV *) op := Udiv |
       UMOD : (* UMOD *) op := Umod |
       ROR  : (* ROR *)  op := Ror  |
       SHL  : (* SHL *)  op := Shl  |
       SHR  : (* SHR *)  op := Shr  |
       EQL  : (* EQL *)  op := Eql  |
       NEQ  : (* NEQ *)  op := Neq  |
       LSS  : (* LSS *)  op := Lss  |
       LEQ  : (* LEQ *)  op := Leq  |
       GTR  : (* GTR *)  op := Gtr  |
       GEQ  : (* GEQ *)  op := Geq  |
       ORR  : (* OR *)   op := Or   |
       XORR : (* XOR *)  op := Xor  |
       ANDD : (* AND *)  op := And  |
       INN  : (* IN *)   op := In   |
       ADD  : (* ADD *)  op := Add  |
       SUB  : (* SUB *)  op := Sub  |
       MUL  : (* MUL *)  op := Mul  |
       DIVV : (* DIV *)  op := Div  |
       MODD : (* MOD *)  op := Mod  

      END;
      SetDyadicOp (op)
   END DyadicOp;

PROCEDURE MonadicOp (instruction : CARDINAL);
    VAR op : MonOperator;
    BEGIN
        CASE instruction OF
          
          ABSS : (* ABS *) op := Abs |
          NEG  : (* NEG *) op := Neg |
          COM  : (* COM *) op := Com |
          MSK  : (* MSK *) op := Msk |
          NOTT : (* NOT *)
                IF NOTPendingRelationalOp () THEN
                    RETURN
                ELSE
                    op := Not
                END; (* if *)        |
          BIT  : (* BIT *) op := Bit
            
        END (* case *);
        SetMonadicOp (op);
    END MonadicOp;

END Operations.
