IMPLEMENTATION MODULE SetUpCode;

FROM items IMPORT BytesPerWord;
FROM ReadMcd IMPORT MCDERROR, IMPORTFRAMEPTR, IMPORTFRAME, MODULENAME,
    KEY, KEYSIZE, MODULENAMESIZE,
    ReadMCode, CodeSize, ProcadrSize, Fixupframe, FixupSize,
    SetCodeByte, CodeByte, McdError, Importlist, ImportlistLength,
    DataSize, StringSize, Headerframe;
FROM McdFrame IMPORT XMODULE, XIMPORT;
FROM Streams IMPORT Stream, Put;
FROM WriteF IMPORT H;
FROM UtilError IMPORT ReportError;
FROM MCMnemonics IMPORT NOP;
FROM KeyOutput IMPORT OutputKeys;


PROCEDURE ReadInCode ();
    VAR s : ARRAY [0..7] OF CHAR;
        ov: CARDINAL;
    BEGIN
        ReadMCode (FALSE);
        IF McdError <> McdOK THEN
            IF (McdError = UnknownFrametype)
            OR (McdError = ModuleframeMissing) THEN
                ReportError (TRUE, "MCODE corrupt", 0, 0);
            ELSE
                CASE McdError OF
                    CodeframeOverflow:   s := "code";
                  | DataframeOverflow:   s := "data";
                  | FixupframeOverflow:  s := "fixup";
                  | StringframeOverflow: s := "string";
                END (* case *);
                ReportError (TRUE, "MCODE %S overflow *N", H(s), 0);
            END;
        END (* if *);
        FirstCodeByteNo := ProcadrSize;
        LastCodeByteNo := CodeSize - 1;
    END ReadInCode;
    
PROCEDURE code (ByteNo : CARDINAL) : CARDINAL;
    BEGIN
        RETURN CodeByte (ByteNo);
    END code;

PROCEDURE SetToNOP (ByteNo : CARDINAL);
    BEGIN
        SetCodeByte (ByteNo, NOP);
    END SetToNOP;

PROCEDURE FixupByte (ByteOffset : CARDINAL) : BOOLEAN;
    VAR count : CARDINAL;
    BEGIN
        FOR count := 0 TO FixupSize DO
            IF Fixupframe [count] = ByteOffset THEN
                RETURN TRUE;
            END (* if *);
        END (* for *);
        RETURN FALSE;
    END FixupByte;
    

PROCEDURE WriteKeyFile (KeyS: Stream);
    BEGIN
        OutputKeys (KeyS, Headerframe, Importlist);      
    END WriteKeyFile;

    
END SetUpCode.
