IMPLEMENTATION MODULE items; (* $T- *)

FROM UtilError IMPORT ReportError;

PROCEDURE PackItem (VAR item : ITEM;
                    mode : MODE; 
                    register : REGISTER; 
		    dispOrData : INTEGER; 
		    index : REGISTER);
   BEGIN
      WITH item DO
         Mode       := mode;
	 Register   := register;
         DispOrData := dispOrData;
	 Index      := index
      END
   END PackItem;


PROCEDURE PackRealStackItem (VAR item : ITEM; disp : INTEGER);
   BEGIN
(* ReportError (FALSE, "Packed a real stack item, offset %i", disp, 0); *)
      PackItem (item, AddrRegDisp, S, - disp, NoReg);
   END PackRealStackItem;

PROCEDURE PackReg (VAR item : ITEM; reg : REGISTER);
    BEGIN
        PackItem (item, DataReg, reg, 0, NoReg)
    END PackReg;

PROCEDURE equal (VAR item1, item2 : ITEM) : BOOLEAN;
   BEGIN 
      WITH item1 DO
         RETURN (Mode       = item2.Mode      )
	    AND (Register   = item2.Register  )
	    AND (DispOrData = item2.DispOrData)
	    AND (Index      = item2.Index     )
      END 
   END equal;


PROCEDURE immediate (VAR item : ITEM) : BOOLEAN;
    BEGIN 
        RETURN (item.Mode = Immediate) OR (item.Mode = FormalProcedure);
    END immediate;


PROCEDURE address (VAR item : ITEM) : BOOLEAN;
   BEGIN 
      RETURN item.Mode = ADDRaddrRegDisp
   END address;


PROCEDURE InDataReg (VAR item : ITEM) : BOOLEAN;
   BEGIN
      RETURN (item.Mode = DataReg)
         AND (item.Register <> NoReg)
   END InDataReg;


PROCEDURE slaveable (VAR item : ITEM) : BOOLEAN;
   BEGIN
      RETURN (item.Mode = AddrRegDisp)
   END slaveable;


PROCEDURE UsesSlavedAddrReg (VAR item : ITEM) : BOOLEAN;
   BEGIN
      WITH item DO
         IF (item.Mode = AddrRegDisp)
         OR (item.Mode = AddrRegIndex)
	 OR (item.Mode = ADDRaddrRegDisp) THEN
	    CASE Register OF
	       A0..A2 : RETURN TRUE
            ELSE RETURN FALSE
	    END
	 ELSE RETURN FALSE
         END
      END
   END UsesSlavedAddrReg;


PROCEDURE OnRealStack (VAR item : ITEM) : BOOLEAN;
   BEGIN
      WITH item DO
         RETURN (Mode = AddrRegDisp) AND (Register = S)
      END
   END OnRealStack;
   
PROCEDURE Int16Bit (c : CARDINAL) : INTEGER;
    BEGIN
        IF c >= Max16BitInt THEN
            RETURN (- INTEGER (Max16BitCard - c + 1))
        ELSE 
            RETURN (INTEGER (c))
        END;
    END Int16Bit;

PROCEDURE ImmediateCardToInt (VAR item :ITEM);
    BEGIN
        IF immediate (item) THEN
            item.DispOrData := Int16Bit (item.DispOrData);
        END (* if *);
    END ImmediateCardToInt;

BEGIN
   PackReg (NullRegItem, NoReg);
   PackReg (DataReg0, D0);
   PackItem (StackPreDec, PreDec, S, 0, NoReg);
END items. 
