IMPLEMENTATION MODULE Options;

FROM Storage IMPORT ALLOCATE;
FROM WriteF IMPORT WriteF1, H;
FROM TextIO IMPORT ReadINTEGER, ReadCHAR;
FROM Streams IMPORT Stream, Delete;
FROM StringStream IMPORT CreateInOutChars;
IMPORT M2LVersion; IMPORT HosVersion;
FROM UtilError IMPORT ReportError;
FROM UnixArgs IMPORT GetArg, argCount;
FROM M2Files IMPORT SetM2PathFromFile;
IMPORT Slist, Strings;
IMPORT Config;

PROCEDURE GetOptions(VAR argnum: CARDINAL; optchars: ARRAY OF CHAR);
VAR ch: CHAR;
    s: Stream;
    ldarg: LDARGSPTR; ldlibarg: LDLIBARGSPTR;
CONST
    EndStreamCh = 0C;
BEGIN
    s := CreateInOutChars(optchars);
    LOOP
        ch := ReadCHAR(s);
        CASE ch OF
            EndStreamCh:
                 EXIT;
        |   '-':
        |   'C': VCheck := TRUE;
        |   'V': ListFiles := TRUE;
        |   'L': Echo := TRUE;
        |   'E': SetM2PathFromFile;
        |   'S': DeleteGfs := FALSE;
        |   'Y': CycleCheck := TRUE;
        |   'c': NoLink := TRUE;
        |   'd': Debugging := TRUE;
        |   'v': ReportError(FALSE, "Modula-2 portable linker V%S/%S\n", 
                        H(M2LVersion.VersionId), H(HosVersion.VersionId));
	|   's': StackSize := ReadINTEGER(s);
        |   'm': 
            INC(argnum);
            IF argnum >= argCount THEN
                ReportError(TRUE, "-m must be followed by 'DefModule:ImplModule'",0,0);
            END;
            GetArg(argnum, optchars);
            Config.Set(optchars);
        |   'o':
            INC(argnum);
            IF argnum >= argCount THEN
                ReportError(TRUE, "missing argument to `-o'",0,0);
            END;
            GetArg(argnum, OutFile);
            EXIT;
            
        | 'l':
            NEW(ldlibarg);
            ldlibarg^.arg := Strings.CopyCS(optchars);
            Slist.AddE(LdLibArgs, ldlibarg);
            EXIT;

        ELSE (* pass on to the target loader *)
            NEW(ldarg);
            ldarg^.arg := Strings.CopyCS(optchars);
            Slist.AddE(LdArgs, ldarg);
            EXIT;
        END (* case *);
    END;
    Delete(s);
END GetOptions;

BEGIN
    Debugging := FALSE;
    VCheck := FALSE;
    ListFiles := FALSE;
    StackSize := 4096;
    HeapSize := 8192;
    Echo := FALSE;
    DeleteGfs := TRUE;
    LdArgs := NIL; LdLibArgs := NIL;
    OutFile[0] := 0C;
    NoLink := FALSE;
    CycleCheck := FALSE;
END Options.
