IMPLEMENTATION MODULE AuxGen2; (* $T- *)

FROM items IMPORT ITEM, MODE, REGISTER, Operator, equal, 
                  DataReg0, InDataReg, immediate, 
		  NullRegItem, PackItem, PackReg; 
FROM RegSlv IMPORT Slave, protect, FreeReg, StopSlaving,
                   PutIntoSlave, UseBitSet;
FROM GenProcs IMPORT GenShift, GenMove, GenExg, GenNeg;
FROM GenOp IMPORT SetResultItem;

VAR DataReg1 : ITEM;


PROCEDURE Immed (VAR item : ITEM) : BOOLEAN;
    BEGIN
        RETURN immediate (item) 
        AND (item.DispOrData <= 8)
    END Immed;


PROCEDURE shift (Op : Operator; VAR Opd1, Opd2, Dest : ITEM;
                                                NegateResult : BOOLEAN);

    PROCEDURE ShiftAndStoreResult (VAR shifter, shifted : ITEM);
        BEGIN
            GenShift (Op, shifter, shifted);
            IF NegateResult THEN
                GenNeg (shifted);
            END (* if *);
            IF equal (Dest, NullRegItem) THEN
                SetResultItem (shifted)
            ELSE 
                GenMove (shifted, Dest);
                PutIntoSlave (shifted, Dest, TRUE);
            END (* if *);
        END ShiftAndStoreResult;

    VAR SlvOpd1, SlvOpd2, SlvDest, Reg1, Reg2 : ITEM;

    BEGIN
        Slave (Opd1, SlvOpd1);
        Slave (Opd2, SlvOpd2);
        Slave (Dest, SlvDest);
        (* First the case where DataReg0 is the dest *)
        IF equal (Dest, DataReg0) THEN
         (* dont bother to adjust reg slave because are leaving a procedure *)
            IF  equal (SlvOpd1, DataReg0) THEN
                IF InDataReg (SlvOpd2) THEN
	           GenExg (SlvOpd2, SlvOpd1);
		   GenShift (Op, SlvOpd2, DataReg0)
		ELSE 
                    GenMove (SlvOpd1, DataReg1);
		    GenMove (Opd2, DataReg0);
		    GenShift (Op, DataReg1, DataReg0)
                END (* if *);
            ELSE 
                GenMove (SlvOpd2, DataReg0);
                (* generates no code if SlvOpd2 = DataReg0 *)
	        IF InDataReg (SlvOpd1) OR Immed (Opd1) THEN
		    GenShift (Op, Opd1, DataReg0)
		ELSE
                    GenMove (Opd1, DataReg1);
		    GenShift (Op, DataReg1, DataReg0)
                END (* if *);
            END (* if *);
            IF NegateResult THEN
                GenNeg (DataReg0);
            END (* if *);
        (* Now for the more mainstream cases *)
        ELSIF InDataReg (SlvOpd2) 
              AND (Immed (Opd1) OR InDataReg (SlvOpd1)) THEN
            ShiftAndStoreResult (SlvOpd1, SlvOpd2);
        ELSIF InDataReg (SlvOpd2) THEN
            FreeReg (Reg1, NOT UseBitSet);
            GenMove (Opd1, Reg1);
            PutIntoSlave (Reg1, Opd1, FALSE);
            ShiftAndStoreResult (Reg1, SlvOpd2);
        ELSIF InDataReg (SlvOpd1) OR Immed (Opd1) THEN
            FreeReg (Reg1, NOT UseBitSet);
            GenMove (Opd2, Reg1);
            ShiftAndStoreResult (SlvOpd1, Reg1);
        ELSIF InDataReg (SlvDest) THEN
            protect (SlvDest);
            FreeReg (Reg1, NOT UseBitSet);
            GenMove (Opd2, SlvDest);
            GenMove (Opd1, Reg1);
            PutIntoSlave (Reg1, Opd1, FALSE);
            ShiftAndStoreResult (Reg1, SlvDest);
        ELSE
            FreeReg (Reg1, UseBitSet);
            FreeReg (Reg2, NOT UseBitSet);
            GenMove (Opd2, Reg1);
	    GenMove (Opd1, Reg2);
            PutIntoSlave (Reg2, Opd1, FALSE);
            ShiftAndStoreResult (Reg2, Reg1);
        END (* if *);
    END shift;


BEGIN
    PackReg (DataReg1, D1)
END AuxGen2.
