IMPLEMENTATION MODULE Externals; (* $T- *)

FROM items IMPORT ITEM, MODE, REGISTER; 
FROM AddrReg IMPORT GetExternalBaseAddr, IncUseCount;
FROM CodeProcs IMPORT next;
FROM PsStk IMPORT Push, Pop, top;
FROM MCMnemonics IMPORT LEA, LEW, SEW;

PROCEDURE ExternalLoad (instruction : CARDINAL);
BEGIN
    IF instruction = LEA THEN
        LoadExtAddr ()
    ELSIF instruction = LEW THEN
        LoadExtWord ()
    ELSE (* LED *) LoadExtDoubleWord () 
    END
END ExternalLoad;


PROCEDURE LoadExtAddr ();
   VAR AddrReg : REGISTER;
   BEGIN
      AddrReg := GetExternalBaseAddr (next ());
      Push (ADDRaddrRegDisp, AddrReg, next ());
      IncUseCount (AddrReg, top);
   END LoadExtAddr;


PROCEDURE LoadExtWord ();
   VAR AddrReg : REGISTER;
   BEGIN
      AddrReg := GetExternalBaseAddr (next ());
      Push (AddrRegDisp, AddrReg, next ());
      IncUseCount (AddrReg, top);
   END LoadExtWord;


PROCEDURE LoadExtDoubleWord ();
   VAR AddrReg : REGISTER;
       disp : INTEGER;
   BEGIN
      AddrReg := GetExternalBaseAddr (next ());
      disp := next ();
      Push (AddrRegDisp, AddrReg, disp);
      Push (AddrRegDisp, AddrReg, disp+1);
      IncUseCount (AddrReg, top-1);
      IncUseCount (AddrReg, top);      
   END LoadExtDoubleWord;


PROCEDURE ExternalStore (instruction : CARDINAL);
   BEGIN
      IF instruction = SEW
      THEN StoreExtWord ()
      ELSE StoreExtDoubleWord ()
      END
   END ExternalStore;


PROCEDURE StoreExtWord ();
   VAR AddrReg : REGISTER;
   BEGIN
      AddrReg := GetExternalBaseAddr (next ());
      Pop (AddrRegDisp, AddrReg, next ());
   END StoreExtWord;


PROCEDURE StoreExtDoubleWord ();
   VAR AddrReg : REGISTER;
       disp : INTEGER;
   BEGIN
      AddrReg := GetExternalBaseAddr (next ());
      disp := next ();
      Pop (AddrRegDisp, AddrReg, disp+1);
      Pop (AddrRegDisp, AddrReg, disp);
   END StoreExtDoubleWord;


END Externals.
