IMPLEMENTATION MODULE SimpleStks; (* $T- *)

FROM Storage IMPORT ALLOCATE;

TYPE Stack = POINTER TO StackItem;
     StackItem = RECORD
		    Value : CARDINAL;
		    Next : Stack
		 END;


VAR TempItem, Spares : Stack;


PROCEDURE GetNewItem ();
   BEGIN
      IF Spares = NIL
      THEN NEW (TempItem)
      ELSE TempItem := Spares; 
           Spares := Spares^.Next
      END
   END GetNewItem;


PROCEDURE DisposeTempItem ();
   BEGIN
      TempItem^.Next := Spares;
      Spares := TempItem
   END DisposeTempItem;


PROCEDURE PushOnto (VAR stack : Stack; value : CARDINAL);
   BEGIN
      GetNewItem ();
      TempItem^.Value := value; TempItem^.Next := stack;
      stack := TempItem
   END PushOnto;


PROCEDURE TopValueOf (stack : Stack) : CARDINAL;
   BEGIN RETURN stack^.Value END TopValueOf;


PROCEDURE RemoveTopItemFrom (VAR stack : Stack);
   BEGIN
      TempItem := stack;
      stack := stack^.Next;
      DisposeTempItem ()
   END RemoveTopItemFrom;


PROCEDURE PopFrom (VAR stack : Stack) : CARDINAL;
   VAR result : CARDINAL;
   BEGIN
      result := TopValueOf (stack);
      RemoveTopItemFrom (stack);
      RETURN result
   END PopFrom;


PROCEDURE empty (stack : Stack) : BOOLEAN;
   BEGIN
      RETURN stack = NIL
   END empty;


PROCEDURE initialise (VAR stack : Stack);
   BEGIN stack := NIL END initialise;


BEGIN
   Spares := NIL
END SimpleStks.
