
MODULE m268kcg;

FROM SYSTEM IMPORT WORD, ADR;

FROM UnixArgs IMPORT
    GetArg, argCount;

FROM Stop IMPORT Stop;
FROM Streams IMPORT Stream, ErrorCode, Delete;

FROM WriteF IMPORT H;

FROM M2Files IMPORT CreateInput, CreateOutput, CreateInOutput;

FROM UnixErrors  IMPORT SysErrorString, sysErrList;


FROM SetUpCode IMPORT ReadInCode, WriteKeyFile;
FROM CodeProcs IMPORT ResetCodeAndLabelPtrs;
FROM FirstPass IMPORT PreProcessTable, PreProcessCode;
FROM MainPass  IMPORT GenHeaderTable, GenCode;
FROM Object    IMPORT AllocateCodeBuffer;
FROM DeadWood  IMPORT DestroyDeadWood;
FROM UtilError IMPORT ReportError, SetPrompt;
FROM ReadMcd   IMPORT SetMcdStream;
FROM BinOutput IMPORT OutputObjectCode;

FROM Version IMPORT VersionNumber;
IMPORT Strings, BinOutput;

PROCEDURE FileError (name : ARRAY OF CHAR; code : INTEGER);
    VAR
        ms : SysErrorString;
    BEGIN
        ms := sysErrList [code];
        ReportError (TRUE,
                     "File error; %S - %S*N", H(ms), H(name));
    END FileError;

PROCEDURE MakeFile(VAR filenam: ARRAY OF CHAR; str: ARRAY OF CHAR; 
                   strlength: CARDINAL);
VAR pos : CARDINAL;
VAR i: CARDINAL;
BEGIN
    pos:=0; 
    WHILE (filenam[pos] #0C) AND(filenam[pos]#'.')DO INC(pos); END;
    filenam[pos]:='.'; 
    FOR i := 1 TO strlength DO
        filenam[pos+i]:=str[i-1];
    END;
    filenam[pos+strlength+1]:=0C;
END MakeFile;


PROCEDURE Generate ();
    BEGIN
        ReadInCode ();
        ResetCodeAndLabelPtrs ();
        PreProcessTable ();
        PreProcessCode ();
        ResetCodeAndLabelPtrs ();
	DestroyDeadWood ();
        ResetCodeAndLabelPtrs ();
        GenHeaderTable ();
        GenCode ();
    END Generate;

(*  here starts the program					      *)

VAR status : CARDINAL;
VAR smcd, slnk, skey : Stream;
VAR argnum: CARDINAL;
VAR arglength: CARDINAL;
VAR argname : ARRAY [0 .. 19] OF CHAR;
VAR pos : CARDINAL;

CONST MinNoOfArgs = 2;

BEGIN
    SetPrompt ("m268kcg");
    argnum := 1;
    IF argCount < MinNoOfArgs THEN
        ReportError (TRUE,
                     "Usage: m268kcg [flags] file1 ...*N",
                     0, 0);
    ELSE
        LOOP
            GetArg(argnum, argname);
            
            IF argname[0] = '-' THEN
                CASE argname[1] OF
                  'v' : ReportError (FALSE,
		           "m268kcg: Version %S*N", H(VersionNumber), 0);
                ELSE ReportError (TRUE,
                                  "unknown option %C*N",
                                  argname [1], 0);
                END (* case *);
            ELSE
                Strings.CopyCC (argname, BinOutput.ArgName);		
                smcd := CreateInput(argname, "mcd");
                IF smcd^.status # Success THEN
		    ReportError (TRUE, "Can't open mcode file", 0, 0);
                END (* if *);
            
		Delete (CreateOutput (argname, "lnk"));
		
                slnk := CreateInOutput(argname, "lnk");
                IF slnk^.status # Success THEN
		    ReportError (TRUE, "Can't open obj file for %S",
		          H (argname), 0);
                END (* if *);
        
                skey := CreateOutput (argname, "key");
                IF skey^.status # Success THEN
		    ReportError (TRUE, "Can't open key file", 0, 0);
                END (* if *);

 
		AllocateCodeBuffer (0);
                SetMcdStream (smcd);
                Generate ();
        	OutputObjectCode (slnk);
		Delete (slnk);
                WriteKeyFile (skey);
		Delete (skey);
            END (* if *);
            
            INC (argnum);
            IF argnum = argCount  THEN
                EXIT;
            END (* if *);

        END (* loop *);

    END (* if *);


    Stop(status);

END m268kcg.

