IMPLEMENTATION MODULE Clock;                (* Unix Version 05.04.82*)

    (*  Greenwich Mean Time Clock routine. *)

    FROM SYSTEM IMPORT ADR, UNIXCALL;
    FROM UnixCalls IMPORT time;


    TYPE Utime = CARDINAL;  (*  Unix System Time (as returned by TIME). *)

    (*  "Constants". *)
    VAR secondsperminute, minutesperday: CARDINAL;
    VAR dmonth: ARRAY [1 .. 12] OF CARDINAL;


    PROCEDURE SysTime(VAR t: Utime);
    (*  Interface to the UNIX system clock. *)
    VAR rc: BOOLEAN;
    BEGIN
        t:= UNIXCALL(time, 0);
    END SysTime;


    PROCEDURE GetTime(VAR tim : Time);
    (*  Get Greenwich mean time and date. *)
        VAR s, m, d: CARDINAL;
        VAR Unixtime: Utime;
        VAR yr, mth, dy: CARDINAL;
        BEGIN
            SysTime(Unixtime);
            s := Unixtime MOD secondsperminute; 
            m := Unixtime DIV secondsperminute;   (* minutes *)
            d := m DIV minutesperday;             (* days *)
            m := m MOD minutesperday;
            dy := d+1;
            yr := 70;        (* 1970. *)
        (*  Groups of 4 years - 3 ordinary + 1 leap.*)
            yr := yr + 4 * ( dy DIV (365 * 4 + 1));
            dy := dy MOD (365 * 4 + 1);

        (*  Single years. *)
            LOOP
                IF (yr MOD 4) = 0 THEN
                    IF dy > 366 THEN
                        dy := dy - 366
                    ELSE
                        EXIT
                    END
                ELSE
                    IF dy > 365 THEN
                        dy := dy - 365
                    ELSE
                        EXIT
                    END
                END;
                yr := yr + 1
            END;

        (*  Months. *)
            mth := 1;
            LOOP
                IF mth = 2 THEN
                    IF (yr MOD 4) = 0 THEN
                    (*  Leap February. *)
                        IF dy > 29 THEN
                            dy := dy - 29
                        ELSE
                            EXIT
                        END
                    ELSE
                        IF dy > 28 THEN
                            dy := dy - 28
                        ELSE
                            EXIT
                        END
                    END
                ELSE
                    IF dy > dmonth[mth] THEN
                        dy := dy - dmonth[mth]
                    ELSE
                        EXIT
                    END
                END;
                mth := mth + 1
            END;

            WITH tim DO
                millisecond := s * 1000;
                minute := m;
                day := ((yr * 20B) + mth) * 40B + dy
            END
        END GetTime;

BEGIN
    secondsperminute := 60;
    minutesperday := 1440;
    dmonth[1] := 31;    dmonth[2] := 28;    dmonth[3] := 31;
    dmonth[4] := 30;    dmonth[5] := 31;    dmonth[6] := 30;
    dmonth[7] := 31;    dmonth[8] := 31;    dmonth[9] := 30;
    dmonth[10] := 31;   dmonth[11] := 30;   dmonth[12] := 31
END Clock.
