IMPLEMENTATION MODULE M2CErrors;

FROM WriteStrings IMPORT
	WriteString, WriteLn;
FROM NewStreams IMPORT STREAM, WriteChar;
FROM M2CErrW2 IMPORT we4, we5,  we6;

VAR OutputToTerminal: BOOLEAN;
VAR output: STREAM;

PROCEDURE OutputString(string: ARRAY OF CHAR);
BEGIN
    IF OutputToTerminal THEN
        WriteString(string);
    ELSE OutString(string);
    END;
END OutputString;

PROCEDURE OutString(str: ARRAY OF CHAR);
(*write a string on the output stream *)
VAR cnt : CARDINAL;
    ch : CHAR;
BEGIN
   cnt := 0;
   WHILE (cnt <= HIGH(str)) AND (str[cnt] <> 0C) DO
        WriteChar(output,str[cnt]);
        INC(cnt);
   END;
END OutString;

PROCEDURE WriteError (number: CARDINAL; terminal: BOOLEAN; s: STREAM);
BEGIN
    OutputToTerminal := terminal;
    output := s;

	CASE number OF
	    0 .. 19:
		we1 (number)
	|  20 .. 69:
		we2 (number)
	|  70 .. 119:
		we3 (number)
	| 120 .. 169:
		we4 (number)
	| 170 .. 499:
		we5 (number)
	ELSE
		we6 (number)
	END;
END WriteError;


PROCEDURE we1 (number: CARDINAL);
BEGIN
	CASE number OF
	    0:  OutputString ("illegal character")
	|   2:  OutputString ("constant out of range")
	|   3:  OutputString ("open comment at end of line")
	|   4:  OutputString ("string terminator not on this line")
	|   5:  OutputString ("too many errors")
	|   6:  OutputString ("string too long")
	|   7:  OutputString ("too many identifiers (identifier table full)")
	|   8:  OutputString ("too many identifiers (hash table full)")
	ELSE
		OutputString ("***  unexpected error  ***")
	END;
END we1;


PROCEDURE we2 (number: CARDINAL);
BEGIN
	CASE number OF
	   20:  OutputString ("identifier expected")
	|  21:  OutputString ("integer constant expected")
	|  22:  OutputString ("']' expected")
	|  23:  OutputString ("';' expected")
	|  24:  OutputString ("block name at the END does not match")
	|  25:  OutputString ("error in block")
	|  26:  OutputString ("':=' expected")
	|  27:  OutputString ("error in expression")
	|  28:  OutputString ("THEN expected")
	|  29:  OutputString ("error in LOOP statement")
	|  30:  OutputString ("constant must not be CARDINAL")
	|  31:  OutputString ("error in REPEAT statement")
	|  32:  OutputString ("UNTIL expected")
	|  33:  OutputString ("error in WHILE statement")
	|  34:  OutputString ("DO expected")
	|  35:  OutputString ("error in CASE statement")
	|  36:  OutputString ("OF expected")
	|  37:  OutputString ("':' expected")
	|  38:  OutputString ("BEGIN expected")
	|  39:  OutputString ("error in WITH statement")
	|  40:  OutputString ("END expected")
	|  41:  OutputString ("')' expected")
	|  42:  OutputString ("error in constant")
	|  43:  OutputString ("'=' expected")
	|  44:  OutputString ("error in TYPE declaration")
	|  45:  OutputString ("'(' expected")
	|  46:  OutputString ("MODULE expected")
	|  47:  OutputString ("QUALIFIED expected")
	|  48:  OutputString ("error in factor")
	|  49:  OutputString ("error in simple type")
	|  50:  OutputString ("',' expected")
	|  51:  OutputString ("error in formal type")
	|  52:  OutputString ("error in statement sequence")
	|  53:  OutputString ("'.' expected")
	|  54:  OutputString ("export at global level not allowed")
	|  55:  OutputString ("body in definition module not allowed")
	|  56:  OutputString ("TO expected")
	|  57:  OutputString ("nested module in definition module not allowed")
	|  58:  OutputString ("'}' expected")
	|  59:  OutputString ("'..' expected")
	|  60:  OutputString ("error in FOR statement")
	|  61:  OutputString ("IMPORT expected")
	ELSE
		OutputString ("***  unexpected error  ***")
	END
END we2;


PROCEDURE we3 (number: CARDINAL);
BEGIN
	CASE number OF
	   70:  OutputString ("identifier specified twice in importlist")
	|  71:  OutputString ("identifier not exported from qualifying module")
	|  72:  OutputString ("identifier declared twice")
	|  73:  OutputString ("identifier not declared")
	|  74:  OutputString ("type not declared")
	|  75:  OutputString ("identifier already declared in module environment")
	|  78:  OutputString ("value of absolute address must be of type CARDINAL")
	|  79:  OutputString ("scope table overflow in compiler")
	|  80:  OutputString ("illegal priority")
	|  81:  OutputString ("definition module belonging to implementation not found")
	|  82:  OutputString ("structure not allowed for implementation of hidden type")
	|  83:  OutputString ("procedure implementation different from definition")
	|  84:  OutputString ("not all defined procedures or hidden types implemented")
	|  86:  OutputString ("incompatible versions of symbolic modules")
	|  88:  OutputString ("function type is not scalar or basic type")
	|  90:  OutputString ("pointer-referenced type not declared")
	|  91:  OutputString ("tagfieldtype expected")
	|  92:  OutputString ("incompatible type of variant-constant")
	|  93:  OutputString ("constant used twice")
	|  94:  OutputString ("arithmetic error in evaluation of constant expression")
	|  95:  OutputString ("range not correct")
	|  96:  OutputString ("range only with scalar types")
	|  97:  OutputString ("type-incompatible constructor element")
	|  98:  OutputString ("element value out of bounds")
	|  99:  OutputString ("set-type identifier expected")
	| 101:  OutputString ("undeclared identifier in export-list of the module")
	| 103:  OutputString ("wrong class of identifier")
	| 104:  OutputString ("no such module name found")
	| 105:  OutputString ("module name expected")
	| 106:  OutputString ("scalar type expected")
	| 107:  OutputString ("set too large")
	| 108:  OutputString ("type must not be INTEGER or CARDINAL")
	| 109:  OutputString ("scalar or subrange type expected")
	| 110:  OutputString ("variant value out of bounds")
	| 111:  OutputString ("illegal export from program module")
	ELSE
		OutputString ("***  unexpected error  ***")
	END;
END we3;


END M2CErrors.
