IMPLEMENTATION MODULE M2Pass3PV;

FROM MCBase IMPORT
    Stset, Structform, Idset, Idptr, Levrange, Idclass, Symbol,
    Stptr, Constval, Stpures, substptr, cardptr, procptr,
    processptr, addrptr;
FROM MCP3Ident IMPORT SearchId, ExportSearch, FAmong;
FROM MCP3IO IMPORT GetSy, Error, ErrorLS, sy, spix, 
    PutSy, PutWord, PutGetSy;
FROM P3Exp IMPORT
    Expression, Attribut, Attributmode, ExprComp, AssignComp,
    TypeExpression, VariableStandard, VariantAnalyse, ExprSequence,
    PutConst, InCCALL;

  PROCEDURE QualIdent(klset: Idset; errnum: CARDINAL; VAR ip: Idptr);
    (* Search a possibly qualified identifier of indicated *)
    (* class. If the search fails then write the error     *)
    (* message ernum. The name spix is taken from MCP3IO.  *)
  BEGIN
    SearchId(ip);
    GetSy; (* next symbol already read *)
    IF ip = NIL THEN ErrorLS(errnum);
    ELSE
      LOOP
        IF ip^.klass <> mods THEN
          IF NOT (ip^.klass IN klset) THEN
            ErrorLS(103); (* identifier not of expected klass *)
            ip := NIL;
          END;
          EXIT;
        ELSIF sy <> period THEN Error(53); ip := NIL; EXIT;
        END;
        GetSy;
        ExportSearch(ip^.expp,ip); (* new value for ip *)
        GetSy; (* next symbol already read *)
        IF ip = NIL THEN ErrorLS(158); EXIT END;
      END; (* LOOP *)
    END;
    IF ip = NIL THEN (* read all qualifications *)
      WHILE sy = period DO GetSy; GetSy END;
    END;
  END QualIdent;
  
    PROCEDURE StProcCheck(ip: Idptr);
      VAR ok : BOOLEAN;
          i : CARDINAL; 
          at,at1 : Attribut;
          ltp : Stptr;
          lval : Constval;
          nam : Stpures;
          subp : Idptr;
    BEGIN
      nam := ip^.pname;
      (* test on procedures to be sustituted *)
      subp := substptr;
      WHILE (subp <> NIL) AND (subp^.pname <> nam) DO
        subp := subp^.link;
      END;
      IF subp <> NIL THEN (* procedure must be substituted *)
        spix := subp^.name; (* ATTENTION : spix is changed *)
        SearchId(ip);
        IF (ip <> NIL) AND (ip^.klass IN Idset{pures,vars}) THEN
          (* procedure found for substitution *)
          (* initialisation of attributes for compatibility check *)
          at.atp := subp^.idtyp; at.mode := exprm;
          at1.atp := ip^.idtyp; at1.mode := varm;
          IF NOT ExprComp(at,at1) THEN ErrorLS(125) END;
        ELSE ErrorLS(124);
        END;
      END;
      PutSy(namesy); PutWord(ip);
      PutGetSy; (* lparent *)
      i := 0;
      CASE nam OF
        incp,decp: (*INC,DEC*)
          IF sy = rparent THEN Error(127);
          ELSE
            VariableStandard(at,scalars);
            IF sy <> rparent THEN PutGetSy;
              TypeExpression(at1,Stset{ints,cards});
            END; 
          END;

       |ccap: (* CALLEXTPROC *)
          IF sy = rparent THEN
	    Error (127);
          ELSE
	     InCCALL := TRUE;
	     TypeExpression (at1, Stset {arrays});
	     IF at1.mode # constm THEN Error (121) END;
	     InCCALL := FALSE;
	     IF sy = comma THEN PutGetSy END;
	     LOOP
		IF (sy = rparent) THEN EXIT END;
		INC (i);
		TypeExpression (at1, Stset{enums .. proctypes});
		IF sy = comma THEN PutGetSy END;
	    END; (* LOOP *)
	END;
       |disp,newp:  (* NEW,DISPOSE *)
          IF sy = rparent THEN
            Error(127); ltp := NIL;
          ELSE
            VariableStandard(at,Stset{pointers});
            ltp := at.atp;
          END;
          IF FAmong(ltp,Stset{pointers}) THEN
            ltp := ltp^.elemp
          END;
          IF ltp = NIL THEN lval.value := 0 
          ELSE
            WITH ltp^ DO
              lval.value := size; 
              IF form = records THEN
                VariantAnalyse(tagp,lval);
              END;
            END; (* WITH ltp^ *)
          END;
          PutSy(comma);
          PutConst(cardptr,lval);
          (* substituted procedures now with two        *)
          (* parameters on the il1-file: (pointer,size) *)
       |inlp,exlp:  (* INCL,EXCL *) 
          IF sy = rparent THEN Error(127);
          ELSE
            VariableStandard(at,Stset{sets});
            IF sy = rparent THEN Error(127);
            ELSE PutGetSy; TypeExpression(at1,scalars);
              IF FAmong(at.atp,Stset{sets}) THEN
                at.atp := at.atp^.basep;
                IF NOT AssignComp(at,at1) THEN ErrorLS(128) END;
              END;
            END;
          END;
       |nprp:  (* NEWPROCESS *)
          LOOP
            IF sy = comma THEN PutGetSy END;
            IF sy = rparent THEN Error(127); EXIT END;
            INC(i);
            CASE i OF
              1: Expression(at);
                 at1.atp := procptr; at1.mode := varm;
                 IF NOT ExprComp(at,at1) THEN ErrorLS(127) END;
             |2,3: TypeExpression(at,Stset{cards});
             |4: Expression(at);
                 WITH at DO
                   IF NOT ((mode=varm) AND
                          ((atp=processptr)OR(atp=addrptr))) THEN
                     ErrorLS(127)
                   END
                 END;
                 EXIT;
             END (* CASE *)
           END; 
       |trsp:  (* TRANSFER *) 
          LOOP 
            IF sy = comma THEN PutGetSy END; 
            IF sy = rparent THEN Error(127); EXIT END; 
            INC(i);
            CASE i OF
              1,2:
                Expression(at); 
                WITH at DO
                  IF NOT ((mode = varm) AND
                         ((atp=processptr) OR (atp=addrptr))) THEN
                    ErrorLS(127) 
                  END
                END;
                IF (i = 2) AND (nam = trsp) THEN EXIT END;
             |3: TypeExpression(at,Stset{ints,cards}); EXIT 
            END (* CASE *)
          END; 
       |halp:  (* HALT *) (* NO ACTIVITY *)
      END; (* CASE *)
      IF sy = rparent THEN PutGetSy;
      ELSE ErrorLS(127); ExprSequence;
      END;
    END StProcCheck; 


END M2Pass3PV .
