
(*************************************
*                                    *  
*    MODULA 2 MULTI-PASS COMPILER    *  
*    ****************************    *  
*                                    *  
*    Pass 4: code generation         *  
*    for Lilith computer             *  
*    Version          5.4.81         *  
*                                    *
*    Christian Jacobi                *  
*    Institut fuer Informatik        *  
*    ETH-Zuerich                     *  
*    CH-8092 Zuerich                 *  
*                                    *  
*************************************)

(* $T- $S- *)
IMPLEMENTATION MODULE M2Pass4;  

  FROM MCBase IMPORT
    Idptr, Symbol, procnumber;

  FROM MCP4Global IMPORT 
    level,
    blockNptr, loadAddress,
    InitIO, CloseIO,
    GetSymbol, sy,
    nptr;

  FROM MCP4CodeSys IMPORT

    InitCodeSys;

  FROM P4CodeBlk IMPORT
        GenBlockEntry, TerminateBlock, GenCodeBlock;

FROM P4Stat IMPORT StatSeq1;




  (* MODULE LoopSys; - now in P4Loop *)

  PROCEDURE Block(fnptr: Idptr);
    VAR procnptr: Idptr; 
  BEGIN (* Block *)   
    WHILE (sy = proceduresy) DO 
      procnptr := nptr;
      GetSymbol;  
      INC(level);  
        Block(procnptr);  
      DEC(level)
    END;  
    blockNptr := fnptr;  
    IF sy=codesy THEN
      IF blockNptr^.externalaccess THEN 
        GenCodeBlock
      END;
      GetSymbol
    ELSE
      GenBlockEntry;
      IF sy = beginsy THEN GetSymbol;
        StatSeq1(endblock)  
      END;  
(*      Assert(loadCount=0); *)
      TerminateBlock
    END;
(*    Assert(sy=endblock);   *)
    GetSymbol (*endblock*)
  END Block;  

PROCEDURE Pass4;
BEGIN
  InitIO;
  InitCodeSys;
  loadAddress := procnumber;
  GetSymbol;  
  Block(NIL);  
  CloseIO;
END Pass4;

END M2Pass4.

