(*
    Title: 	Target Implementation data
    LastEdit:	"Thu Aug  5 12:18:42 1982"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory

    Version for a 32-bit implementation, byte-addressing.
*)

IMPLEMENTATION MODULE MCImpl;
FROM SYSTEM IMPORT 
    MAXINT, BITSPERWORD, MOSTSIGBIT, LEASTSIGBIT;

PROCEDURE InitialiseTarget(bytesperword, addressunitsperword: CARDINAL;
                           bitnumberfromleft: BOOLEAN; bitsperword,
                           realsize, expstacksize: CARDINAL);
VAR
    b: BITSET;
    i: CARDINAL;
    TrueMaxBitNumber: CARDINAL;
    HostBitNumberFromLeft: BOOLEAN;
    bmin, bmax: CARDINAL;
BEGIN
    BytesperWord := bytesperword;
    AddressUnitsperWord := addressunitsperword;
    BitNumberFromLeft := bitnumberfromleft;
    BitsperWord := bitsperword;
    Realsize := realsize;
    IF expstacksize=0 THEN expstacksize := CARDINAL(MAXINT); END;
    ExpStacksize := expstacksize;
(*  Ensure that, if compiling from smaller to larger wordlength,
    don't end up with silly values of MaxInt, MinInt etc.
*)
    IF BitsperWord<=BITSPERWORD THEN
        TrueMaxBitNumber := BitsperWord-1;
    ELSE
        TrueMaxBitNumber := BITSPERWORD-1;
    END (* if *);

    HostBitNumberFromLeft := MOSTSIGBIT < LEASTSIGBIT;
    
    IF (BitNumberFromLeft AND HostBitNumberFromLeft) OR
       ((NOT BitNumberFromLeft) AND (NOT HostBitNumberFromLeft)) THEN
        SameHostTargetBitNumbering := TRUE;
    ELSE
        SameHostTargetBitNumbering := FALSE;
    END;

    IF BitNumberFromLeft THEN
        MostSigBit := 0;
        LeastSigBit := BitsperWord-1;
    ELSE
        MostSigBit := BitsperWord-1;
        LeastSigBit := 0;
    END (* if *);

    b := {};
    IF HostBitNumberFromLeft THEN
        bmin := 1;
        bmax := TrueMaxBitNumber;
    ELSE
        bmin := 0;
        bmax := TrueMaxBitNumber-1;
    END (* if *);

    FOR i:=bmin TO bmax DO
       INCL(b, i);
    END (* for *);
    MaxInt := CARDINAL(b);
    MinInt := -INTEGER(MaxInt)-1;

    MaxCard := CARDINAL(MaxInt)*2+1;
END InitialiseTarget;

BEGIN
    InitialiseTarget(4, 4, FALSE, 32, 1, 0);
END MCImpl.
