(* $T- $S- *)
IMPLEMENTATION MODULE MCP4CallSys;   (* Ch. Jacobi 5.4.81; version: 6.6.81 *) 

(* procedure calls 
   for Pass 4 of the Compiler for the M-Code compiler *)
  FROM MCBase IMPORT  
    Idptr, Stptr, noprio,
    Idclass, Structform, 
    Varkind, Stpures, Stfuncs, wordptr,
    mainmodp, Symbol;

  FROM MCP4Global IMPORT 
    level, loadCount,
    GetSymbol, sy,  
    Error;

  FROM MCP4CodeSys IMPORT
   
    (*Codesys*)
         Emit, Emit2, LinkageMark,  
        
    (*SimpleCode*)
         EmitLI, EmitCL, UConstMul, UAddToTop, 

    (*TypeSystem*)
         ByteSize;
    
  FROM P4CodeBlk IMPORT
         CodeBody;

  FROM MCP4AttributSys IMPORT
    ArithmeticType, AtMode, Attribut, ModeSet,
    HasAlreadyCode, Arithmetic,
    RangeCheck,
    Load, LoadAddr,
    LoadDynHigh, PreAssign;

  FROM MCP4ExpressionSy IMPORT
    Expression;

  FROM MCMnemonics IMPORT
    LSA,
    GB1, GB, CX, CI, CF, FFCT,
    STORE, STOT, LODFW, LODFD, COPT, DECS, STOFV,
    TRA, TRAP,
    ADD, UADD, SUB,  USUB, SYS,
    SHR, SHL,  ANDD, ORR, ABSS, BIT, COM,
    FABS, CHKZ, FUNC;

  FROM P4CallStFunc IMPORT StandFunc;
  FROM P4CallStProc IMPORT StandProc;
  FROM P4CallParam IMPORT DynParam, LoadParam;


  PROCEDURE ProcFuncCall(VAR fat: Attribut);   
    VAR 
      lpsptr: Stptr;  
      lLoadCount: CARDINAL;
      storeGen: BOOLEAN;

  BEGIN (*ProcFuncCall*)  
    WITH fat DO  
      IF mode=procedureMod THEN
        IF procPtr^.isstandard THEN  
          IF procPtr^.klass=funcs THEN 
            StandFunc(fat, procPtr^.fname)  
          ELSE (* klass=pures*)
            StandProc(procPtr^.pname)  
          END;  
          GetSymbol; (*rparent*)  
        ELSIF procPtr^.klass=mods THEN
          EmitCL(procPtr^.procnum);
          GetSymbol; (*rparent*)
        ELSIF procPtr^.codeproc AND NOT procPtr^.externalaccess THEN
          (*used either inline or as procedure; priority cannot be used inline*)
          lLoadCount := loadCount; 
          LoadParam(procPtr^.idtyp);
          loadCount := lLoadCount; 
          CodeBody(procPtr);
          IF procPtr^.klass=funcs THEN
            typtr := procPtr^.idtyp^.funcp; 
            mode := loadedMod;
            INC(loadCount, typtr^.size)
          END   
        ELSE 
          lpsptr := procPtr^.idtyp;
          WITH lpsptr^ DO  
            storeGen := FALSE;
            IF (rkind=funcs) THEN
              IF loadCount>0 THEN
                Emit(STORE);
                storeGen := TRUE
              END;
              lLoadCount := loadCount 
            END;  
            LoadParam(lpsptr);  
            (*Call*)
            WITH procPtr^ DO
              IF (plev=level+1) THEN
                (*local procedure*)
                EmitCL(procnum)
              ELSIF plev>1 THEN 
                (*intermediate level procedure*)
                Emit(GB);
                Emit(level - plev + 1);
		(*GB's now say parmspace - we don't care here*)
		Emit(0);
                Emit(CI); Emit(procnum)
              ELSIF (plev=1) AND (globmodp=mainmodp) THEN  
                (*global procedure*)
                EmitCL(procnum)
              ELSE (*imported procedure*)
                Emit(CX);
                LinkageMark;
                Emit(globmodp^.modnum);
                Emit(procnum)
              END
            END;
            IF rkind=funcs THEN
              Emit(FUNC);
              typtr := funcp; mode := loadedMod;   
              IF typtr^.size=1 THEN 
                IF storeGen THEN Emit(LODFW) END;
                loadCount := lLoadCount+1
              ELSE
(*                Assert(typtr=realptr); *)
                IF storeGen THEN Emit(LODFD) END;
                loadCount := lLoadCount+2
              END
            ELSE loadCount := 0
            END  
          END
        END  
      ELSE (* procedure variable *)
        lLoadCount := loadCount;
        Load(fat);
        storeGen := FALSE;
        IF (typtr^.rkind=funcs) AND (lLoadCount>0) THEN 
          Emit(STOFV); storeGen := TRUE
        ELSE Emit(STOT)
        END;
        loadCount := 0;
        LoadParam(typtr);
        Emit(CF); 
        IF typtr^.rkind = funcs THEN Emit(FUNC); END;
        IF typtr^.rkind=funcs THEN
          typtr := typtr^.funcp; mode := loadedMod;   
          IF typtr^.size=1 THEN 
            IF storeGen THEN Emit(LODFW) END;
            loadCount := lLoadCount+1
          ELSE
(*            Assert(typtr=realptr); *)
            IF storeGen THEN Emit(LODFD) END;
            loadCount := lLoadCount+2
          END
        ELSE loadCount := 0
        END
      END  
    END  
  END ProcFuncCall;


END MCP4CallSys.
  
