(* $T- $S- *)


IMPLEMENTATION MODULE MCP4ExpressionSy;  (* Ch. Jacobi  5.4.81 *)

(* expressions 
   for Pass 4 of the Compiler for the Lilith Computer *)

  FROM MCBase IMPORT  
    Structform,
    Symbol, boolptr;

  FROM MCP4Global IMPORT 
    loadCount,
    GetSymbol, sy, CompilerError;

  FROM MCP4CodeSys IMPORT
   
    (*Codesys*)
         Emit, 
        
    (*SimpleCode*)
         EmitLI;

  FROM MCP4AttributSys IMPORT
    ArithmeticType, Attribut, Arithmetic,
    Load;

  FROM MCMnemonics IMPORT                                                   
    LID,  LLW,  SLW,
    FADD, FSUB, FMUL, FDIV, FCMP, FNEG,
    ORJP, ANDJP,
    ADD,  SUB,  MUL,  DIVV, UADD, USUB, UMUL, UDIV, UMOD,
    EQL,  NEQ,  LSS,  LEQ,  GTR,  GEQ,  NEG,
    ORR,  XORR, ANDD, COM,  NOTT, INN,
    ULSS, ULEQ, UGTR, UGEQ,
    CHKZ;

  IMPORT P4ExpWith;
  IMPORT P4ExpDes;
  FROM P4ExpFact IMPORT Term, Factor;
  FROM P4ExpSimp IMPORT SimpleExpression;

   
  (* MODULE WithSystem; - now in P4ExpWith *)

  PROCEDURE EnterWith(VAR fat: Attribut); 
  BEGIN P4ExpWith.EnterWith(fat);
  END EnterWith;

  PROCEDURE ExitWith;
  BEGIN P4ExpWith.ExitWith;
  END ExitWith;

  (* END WithSystem; *)

  PROCEDURE Designator(VAR fat: Attribut); (* now in P4ExpDes *)
  BEGIN P4ExpDes.Designator(fat);
  END Designator;



  PROCEDURE Expression(VAR fat: Attribut);          
    (* fat describes the first operand and the result *)
    VAR 
      inst: CARDINAL;  
      opsy : Symbol;
      lat: Attribut; (* descriptor of second operand *)  

    PROCEDURE EmitCompare(i: CARDINAL; t: ArithmeticType);
      (* Generate code for compare  
         compare instructions must have the same order   
         for signed and unSigned arithmetic *)
    BEGIN
      IF t=unSigned THEN
        IF i>NEQ THEN i := i+ULSS-LSS END;
      ELSIF t=floating THEN Emit(FCMP)
      END;
      Emit(i)
    END EmitCompare;

  BEGIN (* Expression *)
    SimpleExpression(fat);
    IF sy=insy THEN GetSymbol;  
      Load(fat);
      SimpleExpression(lat); Load(lat); 
      Emit(INN); DEC(loadCount);
      WITH fat DO
        (*mode := loadedMod;*)
        typtr := boolptr
      END  
    ELSIF (sy >= eql) AND (sy <= leq) THEN
      opsy := sy;  
      Load(fat);
      IF (fat.typtr^.form=sets) AND (opsy=geq) THEN Emit(COM) END;
      GetSymbol; SimpleExpression(lat); Load(lat);
      DEC(loadCount);
      IF (fat.typtr^.form=sets) AND ((opsy=geq)OR(opsy=leq)) THEN
        (* set operation >=,<= *)
        IF opsy=leq THEN Emit(COM) END;
        Emit(ANDD); EmitLI(0); Emit(EQL); DEC(loadCount)
      ELSE
        CASE opsy OF  
            eql: inst := EQL   
          | neq: inst := NEQ   
          | grt: inst := GTR   
          | geq: inst := GEQ 
          | lss: inst := LSS 
          | leq: inst := LEQ 
          ELSE   CompilerError(8)
        END;  
        EmitCompare(inst, Arithmetic(fat, lat))
      END;
      WITH fat DO
        (*mode := loadedMod;*)
        typtr := boolptr
      END  
    END;
  END Expression;  


  PROCEDURE ExpressionAndLoad;
    VAR lat: Attribut;
  BEGIN
    Expression(lat);
    Load(lat)
  END ExpressionAndLoad;


END MCP4ExpressionSy.  

