IMPLEMENTATION MODULE P1IOId;
(*  This version does not use a file to store the identifier table
    for the other passes.
*)
(* $T- *)
    FROM Storage IMPORT ALLOCATE, DEALLOCATE;
    FROM MCBase IMPORT Spellix, Symbol;
    FROM P1IOOut IMPORT Error;
    FROM MCP1IO IMPORT sy, spix, String14;
    FROM MCP1IOPV IMPORT ch;


    CONST 
      idmax = maxspix; idmaxplusone = idmax + 1;
      htabmax = 1567; (* MUST BE A PRIME NUMBER *)
      rswlgth = 14;

    TYPE
      Idindex   = [0..idmax];
      Htindex = [0..htabmax]; 

    VAR
      idtab : POINTER TO ARRAY Idindex OF CHAR;
      htab : POINTER TO
               ARRAY Htindex OF
                 RECORD
                   identry : [0..idmaxplusone];
                 END;
      idbase, idtop, inaux, outaux: CARDINAL;
      dmid: CARDINAL;
      hsix, ix : CARDINAL;

    PROCEDURE GetDmId;
    BEGIN
      INC(dmid); spix := dmid; outaux := 0;
    END GetDmId; 

    PROCEDURE InIdTab; 
    BEGIN
      idtab^[inaux] := ch; hsix := hsix MOD 257*ORD(ch)+1;
      IF inaux < idmax THEN INC(inaux) END
    END InIdTab;

    PROCEDURE OutIdTab;
      (* return character from idtab *)
    BEGIN
      ch := idtab^[outaux];
      INC(outaux);
    END OutIdTab;

    PROCEDURE EnterId;
      VAR h, i, id, b1, b2, dummy: CARDINAL;
    BEGIN
      idtab^[inaux] := ' '; (* separator *)
      IF inaux < idmax THEN INC(inaux) END;
      sy := ident; 
      h := hsix MOD htabmax; hsix := 1;
      IF inaux > idmax THEN GetDmId; Error(7)
      ELSE
        IF h = 0 THEN h := htabmax-1 END;
        i := h;
        LOOP id := htab^[i].identry; 
          IF id > idmax THEN (* a new identifier *) 
            IF inaux+20 < idmax THEN
              htab^[i].identry := idtop;
              spix := idtop;
              outaux := idtop;
              WHILE idtop < inaux DO
                INC(idtop);
              END;
            ELSE GetDmId; Error(7); inaux := idtop END;
            EXIT
          END;
          b1 := id; b2 := idtop; (* compare identifiers *)
          LOOP
            IF (idtab^[b1]<>idtab^[b2]) OR (b2=inaux) THEN EXIT END;
            INC(b1); INC(b2)
          END;
          IF b2 = inaux THEN inaux := idtop; (* identifier found *) 
            IF id < idbase THEN (* reserved word *)
              sy := VAL(Symbol,ORD(idtab^[b1]));
            ELSE
              outaux := id;
              spix := htab^[i].identry;
            END; 
            EXIT 
          END;
          i := (i+h) MOD htabmax;
          IF i = 0 THEN GetDmId; Error(8); EXIT END
        END
      END
    END EnterId;

    PROCEDURE HashIdent(VAR str: String14);
      VAR l: [0..rswlgth];
    BEGIN l := 0; 
      WHILE (l<rswlgth) AND (str[l]<>0C) DO
        ch := str[l]; InIdTab; INC(l);
      END;
      EnterId;
    END HashIdent;

    PROCEDURE EnterResWord(str: String14; s: Symbol);
    BEGIN
      HashIdent(str); idtab^[idtop] := CHR(ORD(s));
      INC(idtop); inaux := idtop; idbase := idtop;
    END EnterResWord; 

    PROCEDURE TermIdTab;
    BEGIN
    END TermIdTab; 

    PROCEDURE InitIdTab;
    BEGIN
    END InitIdTab;

    PROCEDURE IdSetPos(spix: Spellix);
        BEGIN
            outaux := spix;
        END IdSetPos;
    
    PROCEDURE IdGetChar(VAR ch: CHAR);
        BEGIN
            ch := idtab^[outaux];
            INC(outaux);
        END IdGetChar;

    BEGIN (* initialisation *)
      idbase := 0; idtop := 0; inaux := 0; dmid := maxspix; hsix := 1;
      NEW(idtab);
      NEW(htab);
      FOR ix := 0 TO htabmax DO htab^[ix].identry := idmaxplusone END; 

END P1IOId .
