IMPLEMENTATION MODULE P1IOOut;

    FROM NewStreams IMPORT
      STREAM, Connect, Reset, WriteWord, EndWrite, Disconnect;
    FROM Storage IMPORT ALLOCATE, DEALLOCATE;
    FROM MCBase IMPORT Symbol, Spellix;
    FROM MCPublic IMPORT Compilerstatus, compstat, il1File;
    FROM MCP1IO IMPORT sy, val, length, spix;
    FROM MCP1IOPV IMPORT pos, line;

    CONST errormax = 300;

    TYPE Syptr = POINTER TO Symb;
         Symb = RECORD next: Syptr; card: CARDINAL END;

    VAR savesys: BOOLEAN;
        first, last: Syptr;
        initline,stopline,restartline: CARDINAL;
        errorcount : CARDINAL;
        Il1 : STREAM;

    PROCEDURE PutSy(s : Symbol);
      VAR c: CARDINAL;
    BEGIN (* put symbol and pos into word *)
      c := ORD(s) * 400B;
      IF pos >= 400B THEN INC(c,377B) ELSE INC(c,pos) END;
      IF savesys THEN
        WITH last^ DO card := c;
          IF next = NIL THEN NEW(next); next^.next := NIL END;
          last := next
        END
      ELSE
        WriteWord(Il1,c);
      END
    END PutSy;

    PROCEDURE PutI(c : CARDINAL);
    BEGIN (* pack c in two bytes *) 
      IF savesys THEN
        WITH last^ DO card := c;
          IF next = NIL THEN NEW(next); next^.next := NIL END;
          last := next
        END;
      ELSE
        WriteWord(Il1,c);
      END
    END PutI;

    PROCEDURE PutS; 
    BEGIN
      PutSy(sy);
      CASE sy OF
        ident : PutI(spix)
       |intcon,cardcon,intcarcon,charcon,realcon : PutI(val.value)
       |stringcon : PutI(val.value); PutI(length)
       |eol : PutI(line)
      ELSE (* nothing *)
      END
    END PutS;

    PROCEDURE PutSyVal(sy: Symbol; val: CARDINAL); 
    BEGIN
      PutSy(sy); PutI(val);
    END PutSyVal;

    PROCEDURE PutIdent(spix: Spellix);
    BEGIN
      PutSy(ident); PutI(spix);
    END PutIdent;

    PROCEDURE Error(n: CARDINAL);
    BEGIN INC(errorcount); INCL(compstat,passerrs);
      IF errorcount <= errormax THEN
        IF errorcount = errormax THEN n := 5 END;
        PutSyVal(errorsy, n)
      ELSIF errorcount >= 10000 THEN HALT; (* LOOP *)
      END;
    END Error;

    PROCEDURE InitSave;
    BEGIN
      savesys := TRUE;
      initline := line;
      restartline := line;
    END InitSave;

    PROCEDURE StopSave;
    BEGIN
      savesys := FALSE;
      IF restartline <> line THEN PutSyVal(eol,line) END;
      stopline := line;
    END StopSave;

    PROCEDURE RestartSave;
    BEGIN
      savesys := TRUE;
      IF stopline <> line THEN PutSyVal(eol,line) END;
      restartline := line;
    END RestartSave;

    PROCEDURE ReleaseSys;
      VAR p : Syptr; 
    BEGIN savesys := FALSE; 
      IF initline <> line THEN PutSyVal(eol, initline) END;
      p := first; 
      WHILE p <> last DO
        WITH p^ DO PutI(card); p := next END;
      END;
      last := first;
      IF stopline <> line THEN PutSyVal(eol, line) END;
    END ReleaseSys;

    PROCEDURE InitOutput;
    BEGIN
      Connect(Il1,il1File,TRUE); Reset(Il1);
      NEW(first); first^.next := NIL;
      initline := 0; stopline := 0; restartline := 0;
      last := first; savesys := FALSE; errorcount := 0;
      EXCL(compstat,passerrs);
    END InitOutput;

    PROCEDURE TermOutput;
    BEGIN
      WHILE first <> NIL DO 
        last := first; first := first^.next;
        DISPOSE(last);
      END;
      PutSy(eop); EndWrite(Il1); Disconnect(Il1,FALSE)
    END TermOutput;

  END P1IOOut .

