IMPLEMENTATION MODULE P2Const;

    FROM SYSTEM IMPORT TSIZE;
    FROM Storage IMPORT ALLOCATE;
    FROM MCP2IO IMPORT
      sy, val, length, Error, ErrorLS, GetSy, PutGetSy;
    FROM MCBase IMPORT
      Idptr, Stptr, Idclass, Idset, Structform, Stset,
      Constval, Symbol,
      intptr, cardptr, intcarptr, realptr, charptr, boolptr,
      bitsetptr, strptrs;
    FROM MCOperations IMPORT RelOp, AddOp, MulOp, NotOp;
    FROM MCImpl IMPORT
        BitsperWord, SameHostTargetBitNumbering, MinInt, MaxInt;
    FROM P2Type IMPORT ArrayStruct;
    FROM M2Pass2PV IMPORT FAmong, QualIdent, symmod, scalars;

    TYPE Constform = RECORD
                       ctp: Stptr;
                       cval: Constval;
                     END; 

    VAR forms : Stset;
        err : BOOLEAN;

    PROCEDURE SetConstructor(VAR setptr: Stptr; VAR setval: Constval); 
      VAR styp,ctyp : Stptr;
          c1,c2 : CARDINAL;
          smin,smax : CARDINAL; 
          setpat : BITSET; (* set pattern *)
    BEGIN 
      smin := 0; smax := BitsperWord-1; setpat := {};
      IF FAmong(setptr,Stset{sets}) THEN 
        styp := setptr^.basep;
      ELSE ErrorLS(99); 
        styp := NIL; setptr := NIL; 
      END;
      IF styp <> NIL THEN 
        WITH styp^ DO 
          CASE form OF
            subranges: styp := scalp; 
              IF min > smin THEN smin := min END; 
              IF max < smax THEN smax := max END; 
           |enums: IF cstnr < smax THEN smax := cstnr END 
           |bools: smax := 1
          ELSE styp := NIL; 
          END; (* CASE *)
        END; (* WITH *) 
      END;
      GetSy; (* lconbr *) 
      WHILE sy <> rconbr DO 
        ConstantRange(ctyp,c1,c2); 
        IF (styp = NIL) AND FAmong(ctyp,Stset{enums,bools,cards}) THEN
          styp := ctyp
        END;
        IF (styp <> NIL) AND
           ((styp=ctyp) OR ((styp=cardptr) AND (ctyp=intcarptr))) THEN 
          IF (c1 < smin) OR (c2 > smax) THEN ErrorLS(98); 
          ELSE
            IF SameHostTargetBitNumbering THEN
              WHILE c1 <= c2 DO INCL(setpat,c1); INC(c1) END;
            ELSE 
              WHILE c1 <= c2 DO INCL(setpat,BitsperWord-(c1+1)); INC(c1) END;
            END;
          END;
        ELSE ErrorLS(97); 
        END;
      END;
      GetSy; (* rconbr *) 
      setval.value := CARDINAL(setpat);
    END SetConstructor; 

    PROCEDURE ConstExpression(VAR cf: Constform);
      (* expression in constant definitions *)
      VAR cf1: Constform;
          op : Symbol;
          res : Constval;
          tp, tp1 : Stptr;

      PROCEDURE Compatible(tp1,tp2: Stptr): BOOLEAN;          
        (* compare on type compatibility in constant expressions *) 
      BEGIN 
        RETURN
          (tp1=tp2) OR (tp1=NIL) OR (tp2=NIL) OR 
          (tp1=intcarptr) AND ((tp2=cardptr) OR (tp2=intptr)) OR 
          (tp2=intcarptr) AND ((tp1=cardptr) OR (tp1=intptr));  
      END Compatible;   
 
      PROCEDURE ConstSimpleExpression(VAR cf: Constform);
        (* simple expression in constant definitions *)
        VAR cf1 : Constform;
            op : Symbol;
            sign : BOOLEAN;

        PROCEDURE ConstTerm(VAR cf: Constform); 
          (* term in constant definitions *)  
          VAR cf1 : Constform; 
              op : Symbol; 

          PROCEDURE ConstFactor(VAR cf: Constform);  
            (* factor in constant definitions *)
            VAR ip : Idptr;
          BEGIN
            WITH cf DO ctp := NIL; cval.value := 0 END;
            IF (sy >= intcon) AND (sy <= stringcon) THEN
              WITH cf DO
                WITH cval DO
                  value := val;
                  CASE sy OF
                    intcon: ctp := intptr;
                   |intcarcon: ctp := intcarptr;
                   |cardcon: ctp := cardptr;
                   |realcon: ctp := realptr;
                   |charcon: ctp := charptr;
                   |stringcon:
                      IF (length > 20) OR (strptrs[length] = NIL) THEN
                        ctp := ArrayStruct(0,length-1,cardptr,charptr);
                        IF length <= 20 THEN strptrs[length] := ctp END;
                      ELSE
                        ctp := strptrs[length];
                      END;
                  END;
                  IF symmod AND (sy = cardcon) THEN (* get type identifier *)
                    GetSy;
                    QualIdent(Idset{types},73,ip);
                    ctp := ip^.idtyp;
                  ELSE GetSy;
                  END;
                END; (* WITH *)
              END; (* WITH *)
            ELSIF sy = ident THEN
              (* constant or set constructor with type identifier *)
              QualIdent(Idset{consts,types},73,ip);
              IF sy = lconbr THEN (* set constructor *)
                IF (ip <> NIL) AND (ip^.klass = types) THEN
                  cf.ctp := ip^.idtyp;
                ELSIF ip <> NIL THEN ErrorLS(103);
                END;
                SetConstructor(cf.ctp,cf.cval);
              ELSE
                IF (ip <> NIL) AND (ip^.klass = consts) THEN
                  WITH ip^ DO
                    cf.ctp := idtyp;
                    IF idtyp = realptr THEN (* make a copy of the real value *)
                      NEW(cf.cval.rvalue);
                      cf.cval.rvalue^ := cvalue.rvalue^;
                    ELSIF idtyp = NIL THEN ErrorLS(73);
                    ELSE cf.cval := cvalue;
                    END;
                  END;
                ELSIF ip <> NIL THEN ErrorLS(103); 
                END;
              END;
            ELSIF sy = lconbr THEN (* bitset *)
              cf.ctp := bitsetptr;
              SetConstructor(cf.ctp,cf.cval);
            ELSIF sy = lparent THEN
              GetSy;
              ConstExpression(cf);
              GetSy;
            ELSIF sy = notsy THEN
              GetSy;
              ConstFactor(cf);
              IF FAmong(cf.ctp,Stset{bools}) THEN
                NotOp(cf.cval,cf.cval);
              ELSE ErrorLS(140);
              END;
            END;
          END ConstFactor;

        BEGIN       
          ConstFactor(cf); 
          WHILE (sy >= andsy) AND (sy <= modsy) DO
            op := sy; 
            GetSy;
            ConstFactor(cf1); 
            IF cf.ctp = NIL THEN cf := cf1;
            ELSE
              WITH cf DO 
                IF (ctp = intcarptr) AND 
                   FAmong(cf1.ctp,Stset{ints,cards}) THEN
                  ctp := cf1.ctp;
                END;
                IF Compatible(ctp,cf1.ctp) THEN
                  CASE op OF
                    andsy: forms := Stset{bools};
                   |times: forms := Stset{ints,cards,sets,reals};
                   |slash: forms := Stset{sets,reals};
                   |divsy,modsy: forms := Stset{ints,cards};
                  END;
                  IF FAmong(ctp,forms) THEN
                    MulOp(cval,cf1.cval,cval,op,ctp,err);
                    IF err THEN ErrorLS(94) END;
                  ELSE ErrorLS(140); 
                  END; 
                ELSE ErrorLS(143); 
                END; 
              END; (* WITH *) 
            END; 
          END; (* WHILE *) 
        END ConstTerm; 

      BEGIN 
        sign := (sy = minus) OR (sy = plus);
        IF sign THEN op := sy; GetSy; END;
        ConstTerm(cf);
        IF sign THEN
          WITH cf DO
            IF (ctp=intptr) OR (ctp=intcarptr) OR (ctp=realptr) THEN
              IF op = minus THEN
                IF ctp = realptr THEN cf1.cval.rvalue := NIL;
                ELSE cf1.cval.value := 0;
                END;
                AddOp(cf1.cval,cval,cval,minus,ctp,err);
                IF err THEN ErrorLS(94) END;
              END;
            ELSIF ctp = cardptr THEN
              IF op = minus THEN
                IF cval.value = CARDINAL(MinInt) THEN ctp := intptr
                ELSE
                  ErrorLS(121);
                END;
              END;
            ELSE ErrorLS(121);
            END; 
          END; 
        END;
        WHILE (sy >= plus) AND (sy <= orsy) DO 
          op := sy;
          GetSy;
          ConstTerm(cf1);
          IF cf.ctp = NIL THEN cf := cf1;
          ELSE
            WITH cf DO 
              IF (ctp = intcarptr) AND
                 FAmong(cf1.ctp,Stset{ints,cards}) THEN
                ctp := cf1.ctp;
              END;
              IF Compatible(ctp,cf1.ctp) THEN
                CASE op OF
                  orsy: forms := Stset{bools};
                 |plus,minus: forms := Stset{ints,cards,sets,reals};
                END;
                IF FAmong(ctp,forms) THEN
                  AddOp(cval,cf1.cval,cval,op,ctp,err);
                  IF err THEN ErrorLS(94) END; 
                ELSE ErrorLS(140); 
                END; 
              ELSE ErrorLS(143); 
              END; 
            END; (* WITH *) 
          END; 
        END; (* WHILE *) 
      END ConstSimpleExpression;   

    BEGIN
      ConstSimpleExpression(cf);
      IF (sy >= eql) AND (sy <= insy) THEN
        res.value := CARDINAL(FALSE); (* initial value *)
        op := sy;
        GetSy;
        ConstSimpleExpression(cf1);
        tp := cf.ctp;
        tp1 := cf1.ctp;    
        IF op = insy THEN
          IF FAmong(tp1,Stset{sets}) THEN
            tp1 := tp1^.basep;
            IF Compatible(tp,tp1) THEN
              RelOp(cf.cval,cf1.cval,res,insy,tp,err); 
              IF err THEN ErrorLS(94) END;
            ELSE ErrorLS(142); 
            END;
          ELSE ErrorLS(149);
          END;
        ELSIF Compatible(tp,tp1) THEN
          IF tp = intcarptr THEN tp := tp1 END;
          CASE op OF
            eql,neq: forms := Stset{sets,pointers,reals} + scalars;
           |geq,leq: forms := Stset{sets,reals} + scalars;
           |grt,lss: forms := Stset{reals} + scalars;
          END;
          IF FAmong(tp,forms) THEN 
            RelOp(cf.cval,cf1.cval,res,op,tp,err);
            IF err THEN ErrorLS(94) END;
          ELSE ErrorLS(140);
          END;
        ELSE ErrorLS(143) 
        END; 
        cf.ctp := boolptr; 
        cf.cval := res; 
      END; 
    END ConstExpression; 

    PROCEDURE Constant(VAR c: Constform);
    BEGIN
      ConstExpression(c);
      WITH c DO
        IF ((ctp=intptr) OR (ctp=cardptr)) AND (cval.value<=MaxInt) THEN
          ctp := intcarptr;
        END;
      END;
    END Constant;

    PROCEDURE ConstantRange(VAR ctyp: Stptr; VAR cmin,cmax: CARDINAL);
      VAR c1,c2: CARDINAL; 
          tp : Stptr;
          c : Constform;
    BEGIN (* ConstantRange *)
      Constant(c);
      tp := c.ctp; c1 := c.cval.value; c2 := c1;
      IF sy = range THEN
        GetSy;
        IF FAmong(tp,scalars) THEN
          Constant(c);
          WITH c DO
            IF tp = intcarptr THEN
              IF FAmong(ctp,Stset{ints,cards}) THEN tp := ctp END;
            ELSIF ctp = intcarptr THEN
              IF FAmong(tp,Stset{ints,cards}) THEN ctp := tp END;
            END;
            IF tp = ctp THEN
              c2 := cval.value;
              IF tp = intptr THEN
                IF INTEGER(c2) < INTEGER(c1) THEN c2 := c1; ErrorLS(95) END;
              ELSE
                IF c2 < c1 THEN c2 := c1; ErrorLS(95) END;
              END;
            ELSE ErrorLS(95)
            END;
          END;
        ELSE ErrorLS(96); 
          Constant(c);
        END;
      END;
      ctyp := tp;
      cmin := c1; cmax := c2; 
    END ConstantRange; 

    PROCEDURE ConstantVal(VAR fsp: Stptr; VAR fval: Constval); 
      VAR c: Constform; 
    BEGIN Constant(c);
      WITH c DO fsp := ctp; fval := cval END;
    END ConstantVal;

END P2Const .


