IMPLEMENTATION MODULE P2Init;


    FROM MCP2IO IMPORT PutSy, PutWord;
    FROM MCBase IMPORT Symbol, Idptr;

    CONST
          blevelmax = 20; 

    VAR inittab : ARRAY Initrange OF 
                    RECORD toinit : BOOLEAN;
                      mptr : Idptr; 
                    END;
        blockdispl : ARRAY [1..blevelmax] OF Initrange; 
        blevel : CARDINAL; 
        inittop : CARDINAL;

    PROCEDURE MarkInitBlock;
    BEGIN
      INC(blevel);
      IF blevel > blevelmax THEN HALT END;
      blockdispl[blevel] := inittop;
    END MarkInitBlock;

    PROCEDURE ReleaseInitBlock;
    BEGIN 
      inittop := blockdispl[blevel];
      DEC(blevel); 
    END ReleaseInitBlock;

    PROCEDURE EnterInitModule(ip : Idptr; VAR initix : Initrange); 
    BEGIN INC(inittop); 
      IF inittop > initmax THEN HALT END;
      initix := inittop; 
      WITH inittab[inittop] DO toinit := FALSE; mptr := ip END;
    END EnterInitModule;

    PROCEDURE ToInitModule(initix : Initrange); 
    BEGIN 
      WITH inittab[initix] DO
        toinit := TRUE;
        PutSy(proceduresy); PutWord(mptr);
      END 
    END ToInitModule; 

    PROCEDURE InitModules;
      VAR i : CARDINAL;
    BEGIN i := blockdispl[blevel] + 1;
      WHILE i <= inittop DO 
        WITH inittab[i] DO
          IF toinit THEN PutSy(call); PutSy(namesy); PutWord(mptr); 
            PutSy(lparent); PutSy(rparent); 
          END;
        END; INC(i);
      END 
    END InitModules;

    PROCEDURE MustInit() : BOOLEAN; 
      VAR i : CARDINAL;
    BEGIN i := blockdispl[blevel] + 1;
      WHILE i <= inittop DO
        IF inittab[i].toinit THEN RETURN TRUE END;
        INC(i);
      END;
      RETURN blevel = 1; (* global modules must always be initialised *)
    END MustInit; 

    PROCEDURE ResetModuleInit;
    BEGIN
      inittop := 0;
      blevel := 0;
    END ResetModuleInit;

END P2Init .
