IMPLEMENTATION MODULE P2Type;

    FROM Storage IMPORT ALLOCATE, DEALLOCATE;
    FROM MCImpl IMPORT BytesperWord, BitsperWord,
      Realsize, MaxInt, MaxCard, MinInt;
    FROM MCBase IMPORT
      Idptr, Stptr, Idclass, Idset, Structform, Stset,
      Symbol,
      Varkind, Kindvar, Recpart,
      intptr, cardptr, intcarptr;
    FROM MCP2IO IMPORT
     sy, spix, val, Error, ErrorLS,
     GetSy, PutGetSy;
    FROM MCP2Ident IMPORT
      Locate, EnterList, EnterId, EnterForward,
      SearchId, SearchInBlock, MsEntry;
    FROM MCP2Reference IMPORT Reference;
    FROM P2Const IMPORT ConstantRange;
    FROM M2Pass2PV IMPORT
      symmod, nestlevel,
      oneword, doubleword, procmarkspace, scalars, charmax,
      FAmong, QualIdent, InitId;

    PROCEDURE CheckAndGetBounds(fsp: Stptr; VAR fmin,fmax: CARDINAL);
      VAR lmin,lmax: CARDINAL;
    BEGIN lmin := 0; lmax := 0;
      IF fsp <> NIL THEN
        WITH fsp^ DO
          CASE form OF
            enums: lmax := cstnr;
           |bools: lmax := 1;
           |chars: lmax := charmax;
           |ints,cards: ErrorLS(108);
           |subranges: lmin := min; lmax := max;
          ELSE ErrorLS(109);
          END; (* CASE *)
        END; (* WITH *) 
      END; (* IF *) 
      fmin := lmin; fmax := lmax;
    END CheckAndGetBounds;

    PROCEDURE Subrange(cp: Stptr; c1,c2: CARDINAL): Stptr; 
      VAR sp : Stptr; 
    BEGIN 
      NEW(sp,subranges);
      WITH sp^ DO 
        size := oneword;
        stidp := NIL; inlist := FALSE;
        form := subranges; scalp := cp; 
        min := c1; max := c2; 
      END;
      RETURN sp 
    END Subrange; 

    PROCEDURE ArrayStruct(imin,imax: CARDINAL; ind,el: Stptr): Stptr;
      VAR sp : Stptr;
          idiff : CARDINAL; (* index difference *)
          mc, mv : CARDINAL; (* help for multiplication *)
    BEGIN
      NEW(sp,arrays);
      WITH sp^ DO
        IF el <> NIL THEN
          (* assume that 'imin <= imax' in relation belonging to type *)
          IF FAmong(ind,Stset{ints}) THEN
            IF (INTEGER(imin) < 0) AND (INTEGER(imax) >= 0) THEN
              idiff := MaxCard - imin + 1 + imax;
            ELSE (* both bounds with same sign *)
              idiff := imax - imin;
            END;
          ELSE
            idiff := imax - imin;
          END;
          (* number of elements is 'idiff + 1' *)
          IF FAmong(el,Stset{chars}) THEN 
          (* character arrays are packed and aligned *)
            size := idiff DIV BytesperWord + 1;
          ELSE (* multiply with element size *)
            size := 0;
            IF idiff < MaxCard THEN
              mc := idiff + 1;
              IF mc < el^.size THEN mv := mc; mc := el^.size ELSE mv := el^.size END;
              WHILE (mv > 0) AND (size <= MaxCard - mc) DO DEC(mv); INC(size,mc) END;
              IF mv > 0 THEN ErrorLS(100) END;
            ELSE ErrorLS(100);
            END;
          END;
        ELSE size := 0;
        END;
        stidp := NIL; inlist := FALSE;
        form := arrays; dyn := FALSE; elp := el;
        IF FAmong(ind,Stset{subranges}) THEN ixp := ind
        ELSE ixp := Subrange(ind,imin,imax);
        END;
      END;
      RETURN sp;
    END ArrayStruct;

    PROCEDURE ParamList(withid: BOOLEAN; VAR paraddr: CARDINAL;
                        VAR procp: Stptr);
      VAR parh,part,parn : Idptr;
          ftp,sp : Stptr;
          rk : Idclass;
          vk : Varkind;
          cpar : BOOLEAN; (* parameters are copy parameters *)
          indac : BOOLEAN; (* indirect access to parameter value *)
          space : CARDINAL; (* space used for entry on stack *)

      PROCEDURE ParamId;
        VAR ip : Idptr;
      BEGIN
        NEW(ip,vars);
        InitId(ip,vars);
        WITH ip^ DO
          indaccess := FALSE;
          vkind := vk; vlevel := nestlevel;
          state := local; vlink := NIL;
        END;
        IF parh = NIL THEN parh := ip ELSE part^.vlink := ip END;
        part := ip;
        IF withid THEN EnterId(ip) END;
      END ParamId;

    BEGIN
      paraddr := procmarkspace;
      parh := NIL; part := NIL;
      rk := pures;
      IF sy = lparent THEN GetSy;
        WHILE sy <> rparent DO
          IF sy = varsy THEN GetSy; vk := varparam ELSE vk := valparam END;
          parn := part; (* mark new list of parameters *)
          IF withid THEN 
            WHILE sy <> colon DO ParamId; GetSy END;
            GetSy; (* colon *)
          ELSE ParamId;
          END;
          FormalTyp(ftp);
          space := oneword;
          cpar := FALSE;
          IF FAmong(ftp,Stset{reals,records,arrays}) THEN
            indac := TRUE;
            IF (ftp^.form = arrays) AND ftp^.dyn THEN
              space := doubleword;
              IF vk = valparam THEN
                cpar := TRUE;
              END;
            ELSIF vk = valparam THEN
              IF FAmong(ftp,Stset{reals}) THEN
                indac := FALSE;
                space := Realsize; (* expressions ! *)
              ELSE (* arrays, records *)
                cpar := TRUE;
              END;
            END;
          ELSE
            indac := vk <> valparam;
          END;
          (* allocation and type entry *)
          IF parn = NIL THEN parn := parh ELSE parn := parn^.vlink END;
          WHILE parn <> NIL DO
            WITH parn^ DO
              idtyp := ftp;
              IF cpar THEN vkind := copyparam END;
              indaccess := indac;
              vaddr := paraddr;
              INC(paraddr,space);
              IF withid THEN Reference(parn) END;
              parn := vlink;
            END;
          END;
        END; (* WHILE *)
        GetSy; (* rparent*)
        IF sy = colon THEN GetSy;
          rk := funcs;
          SimpleTyp(ftp);
          IF NOT FAmong(ftp,Stset{enums,bools,chars,ints,cards,words,reals,
                                  subranges,pointers,sets,hides}) THEN
            ErrorLS(88) 
          END;
        END;
      END;
      IF rk = pures THEN NEW(sp,proctypes,pures)
      ELSE NEW(sp,proctypes,funcs)
      END;
      WITH sp^ DO
        size := oneword; stidp := NIL; inlist := FALSE;
        form := proctypes; fstparam := parh;
        rkind := rk;
        IF rk = funcs THEN funcp := ftp END;
      END;
      procp := sp;
    END ParamList;
 
    PROCEDURE SimpleTyp(VAR trf: Stptr);
      VAR lsp: Stptr;
          lip, tref: Idptr;
          cp: Stptr; 
          c1, c2 : CARDINAL;

    BEGIN 
      IF sy = lparent THEN GetSy; c1 := 0;
        NEW(lsp,enums); 
        WITH lsp^ DO form := enums; stidp := NIL; inlist := FALSE END;
        tref := NIL;
        WHILE sy <> rparent DO
          NEW(lip,consts); 
          InitId(lip,consts);
          WITH lip^ DO
            idtyp := lsp;
            IF symmod THEN GetSy; cvalue.value := val;
            ELSE cvalue.value := c1;
            END;
          END;
          EnterList(tref,lip); 
          SearchInBlock(lip); (* new value for lip *) 
          IF (lip <> NIL) AND (lip^.klass <> unknown) THEN Error(72) END; 
          GetSy;
          INC(c1);
        END;
        WITH lsp^ DO
          size := oneword;
          fcstp := tref; cstnr := c1 - 1; (* c1 is number of elements *)
        END;
        MsEntry(tref);
        GetSy;
      ELSIF sy = ident THEN QualIdent(Idset{types},73,lip); 
        IF lip = NIL THEN lsp := NIL;
        ELSE
          lsp := lip^.idtyp;
          IF lsp = NIL THEN ErrorLS(74) END;
        END;
      ELSIF sy = lbrack THEN (* subrange *)
        GetSy;
        ConstantRange(cp,c1,c2);
        IF cp = intcarptr THEN cp := cardptr END; (* change to base type CARDINAL *)
        lsp := Subrange(cp,c1,c2);
        GetSy; (* rbrack *)
      END;
      trf := lsp; 
    END SimpleTyp;

    PROCEDURE PointerTyp(VAR trf: Stptr); 
      VAR lip: Idptr;
          lsp,t1rf: Stptr;
    BEGIN
      NEW(lsp,pointers); trf := lsp;
      WITH lsp^ DO
        size := oneword; stidp := NIL; inlist := FALSE; 
        form := pointers; elemp := NIL; 
      END;
      IF sy = ident THEN
        (* search for module name first *)
        SearchId(lip);
        IF (lip <> NIL) AND (lip^.klass = mods) THEN
          QualIdent(Idset{types},73,lip);
          IF lip <> NIL THEN
            lsp^.elemp := lip^.idtyp;
            IF lip^.idtyp = NIL THEN ErrorLS(74) END;
          END;
        ELSE
          (* search for a local declared name *)
          SearchInBlock(lip);
          IF (lip = NIL) OR (lip^.klass = unknown) THEN
            EnterForward(lsp);
          ELSE
            IF lip^.klass = types THEN
              lsp^.elemp := lip^.idtyp;
              IF lip^.idtyp = NIL THEN Error(74) END;
            ELSE Error(73);
            END;
          END;
          GetSy;
          IF sy = period THEN (* overread incorrect qualident *)
            ErrorLS(105);
            WHILE sy = period DO GetSy; GetSy; END;
          END;
        END;
      ELSE ActualTyp(t1rf); lsp^.elemp := t1rf; END;
    END PointerTyp; 

    PROCEDURE RecordTyp(VAR trf: Stptr);
      VAR vrf: Stptr;
          frf: Idptr; 
          offset: CARDINAL;
          lsp: Stptr;


      PROCEDURE FieldList(VAR offs: CARDINAL; VAR vtabref: Stptr); 
        VAR offset, offse, maxoffset: CARDINAL;
            ttp: Stptr;
            tagref, svtrf, cxv: Stptr;
            x, xh, xt: Idptr;
            ctp : Stptr;           (* type of new current case labels *)
            c1, c2: CARDINAL;      (* bound values of current case labels *)
            ltp : Stptr;           (* expected type of case labels *)
            lmin, lmax : CARDINAL; (* minimal and maximal value of case labels *)

        PROCEDURE EnterVariant(VAR vrf: Stptr; val: CARDINAL);
          VAR varref: Stptr;
        BEGIN NEW(varref,records,variantpart);
          WITH varref^ DO
            stidp := NIL; inlist := FALSE;
            form := records; rpart := variantpart; nxtvarp := NIL;
            subtagp := cxv; (* temporary link *)
            varval := val;
          END;
          cxv := varref; vrf := varref; 
        END EnterVariant; 

        PROCEDURE VariantField(val: CARDINAL); 
          VAR lsp: Stptr; goon: BOOLEAN;
        BEGIN goon := TRUE; 
          WITH tagref^ DO 
            IF fstvarp = NIL THEN EnterVariant(fstvarp,val); goon := FALSE; 
            ELSE lsp := fstvarp; END; 
          END;
          WHILE goon DO 
            WITH lsp^ DO
              IF varval = val THEN ErrorLS(93); goon := FALSE;
              ELSIF nxtvarp = NIL THEN EnterVariant(nxtvarp,val); goon := FALSE;
              ELSE lsp := nxtvarp END;
            END;
          END;
        END VariantField; 

        PROCEDURE IdentComplete(ip: Idptr); 
          VAR sz: CARDINAL; 
        BEGIN (* offset, ttp from FieldList *)
          IF ttp <> NIL THEN sz := ttp^.size ELSE sz := 0 END;
          WHILE ip <> NIL DO
            WITH ip^ DO
              ip := nxtidp; idtyp := ttp;
              fldaddr := offset;
              IF MaxCard - sz >= offset THEN INC(offset,sz);
              ELSE (* record structure too large *)
                ErrorLS(100);
              END;
            END;
          END;
        END IdentComplete;

        PROCEDURE DisposeCase(fsp: Stptr);
          VAR lsp,lsp1: Stptr;
        BEGIN 
          IF fsp <> NIL THEN
            lsp := fsp^.fstvarp;
            WHILE lsp <> NIL DO 
              IF lsp^.nxtvarp = NIL THEN DisposeCase(lsp^.subtagp); 
              ELSIF lsp^.nxtvarp^.subtagp <> lsp^.subtagp THEN
                DisposeCase(lsp^.subtagp);
              END;
              lsp1 := lsp; lsp := lsp^.nxtvarp; 
              DISPOSE(lsp1,records,variantpart);
            END;
            IF fsp^.elsevarp <> NIL THEN DisposeCase(fsp^.elsevarp^.subtagp); 
              DISPOSE(fsp^.elsevarp,records,variantpart); 
            END;
            lsp := fsp; DISPOSE(lsp,records,tagfield);
          END;
        END DisposeCase;

        PROCEDURE LabelTypeAndBounds(sp: Stptr);
         (* set the variables ltp, lmin, and lmax *)
        BEGIN (* LabelTypeAndBounds *)
          ltp := sp;
          lmin := 0; lmax := 0;
          IF ltp <> NIL THEN
            WITH ltp^ DO
              CASE form OF
                enums : lmax := cstnr;
              | bools : lmax := 1;
              | chars : lmax := charmax;
              | ints  : lmin := MinInt; lmax := MaxInt;
              | cards : lmax := MaxCard; ltp := cardptr; (* might be intcarptr *)
              | subranges : lmin := min; lmax := max; ltp := scalp;
              ELSE (* no scalar type *)
                ErrorLS(109);
                ltp := NIL;
              END; (* CASE *)
            END; (* WITH *)
          END;
        END LabelTypeAndBounds;

      BEGIN (*FieldList*) 
        offset := offs; tagref := NIL;
        DisposeCase(vtabref); 
        IF sy = casesy THEN GetSy;
          xh := NIL; 
          IF sy = ident THEN (* explicit tagfield *)
            NEW(xh,fields);
            InitId(xh,fields);
            EnterList(frf,xh); GetSy; 
          END;
          (* sy = colon ;  inserted by pass1 *) 
          GetSy;
          QualIdent(Idset{types},91,x); 
          IF x = NIL THEN ttp := NIL;
          ELSE ttp := x^.idtyp;
            IF ttp = NIL THEN ErrorLS(74) END;
          END;
          IF xh <> NIL THEN IdentComplete(xh) END;
          NEW(tagref,records,tagfield); 
          WITH tagref^ DO 
            stidp := NIL; inlist := FALSE;
            form := records;
            rpart := tagfield; fstvarp := NIL;
            tagtyp := ttp; elsevarp := NIL;
          END;
          LabelTypeAndBounds(ttp);
          maxoffset := offset; cxv := NIL;
          WHILE sy = ofsy DO GetSy; 
            REPEAT (*process variant label:*) 
              IF symmod THEN VariantField(val); GetSy;
              ELSE
                ConstantRange(ctp,c1,c2);
                IF ltp = NIL THEN LabelTypeAndBounds(ctp) END; 
                IF (ltp = intptr) AND ((ctp = intcarptr) OR (ctp = intptr)) THEN
                  IF (INTEGER(c1) < INTEGER(lmin)) OR
                     (INTEGER(c2) > INTEGER(lmax)) THEN
                    ErrorLS(110);
                  END;
                  VariantField(c1);
                  WHILE INTEGER(c1) < INTEGER(c2) DO
                    IF c1 = 177777B THEN c1 := 0 ELSE INC(c1) END;
                    VariantField(c1);
                  END;
                ELSIF (ltp = ctp) OR (ctp = intcarptr) AND (ltp = cardptr) THEN
                  IF (c1 < lmin) OR (c2 > lmax) THEN ErrorLS(110) END;
                  VariantField(c1);
                  WHILE c1 < c2 DO
                    INC(c1);
                    VariantField(c1);
                  END;
                ELSE ErrorLS(92); 
                END;
              END;
            UNTIL sy = colon; 
            (*process fields of variant:*)
            GetSy; offse := offset; svtrf := NIL; 
            WHILE (sy = ident) OR (sy = casesy) DO
              FieldList(offse,svtrf); 
            END;
            IF symmod THEN offse := val; GetSy END;
            WHILE cxv <> NIL DO (* enter size of variant in variantlabels *) 
                                (* cxv is set by procedure EnterVariant *)
                                (* field subtagp links variantlabels *)
              WITH cxv^ DO
                size := offse; cxv := subtagp; subtagp := svtrf;
              END;
            END;
            IF offse > maxoffset THEN maxoffset := offse END; 
          END (*while sy = ofsy*);
          IF sy = elsesy THEN (*else variant*)
            GetSy; offse := offset; svtrf := NIL; 
            EnterVariant(tagref^.elsevarp,0);
            WHILE (sy=ident)OR(sy=casesy) DO FieldList(offse,svtrf) END;
            IF symmod THEN offse := val; GetSy END;
            WITH cxv^ DO size := offse; subtagp := svtrf END; 
            IF offse > maxoffset THEN maxoffset := offse END; 
          END;
          tagref^.size := maxoffset; offs := maxoffset; 
          GetSy;
        ELSE (*sy <> casesy*) 
          xh := NIL; 
          WHILE sy <> colon DO
            NEW(x,fields); 
            InitId(x,fields);
            IF symmod THEN GetSy; x^.fldaddr := val;
            ELSE
              IF xh = NIL THEN xh := x ELSE xt^.nxtidp := x END;
              xt := x;
            END;
            EnterList(frf,x); GetSy; 
          END;
          GetSy; ActualTyp(ttp);
          IF symmod THEN
            WITH x^ DO
              idtyp := ttp;
            END;
          ELSE IdentComplete(xh)
          END;
          offs := offset;
        END;
        vtabref := tagref;
      END FieldList;

    BEGIN (*RecordTyp*) 
      offset := 0;
      frf := NIL; vrf := NIL;
      WHILE sy <> endsy DO FieldList(offset,vrf) END; 
      GetSy;
      IF symmod THEN offset := val; GetSy
      END; 
      NEW(lsp,records,fixedpart); 
      WITH lsp^ DO
        size := offset;
        stidp := NIL; inlist := FALSE;
        form := records; rpart := fixedpart;
        fieldp := frf; tagp := vrf; 
      END;
      trf := lsp; 
    END RecordTyp;

    PROCEDURE ArrayTyp(VAR trf: Stptr); 
      VAR lsp,lsp1,t1rf: Stptr; lmin,lmax: CARDINAL; 
    BEGIN SimpleTyp(lsp); 
      CheckAndGetBounds(lsp,lmin,lmax); 
      IF sy <> ofsy THEN ArrayTyp(t1rf) ELSE GetSy; ActualTyp(t1rf) END;
      trf := ArrayStruct(lmin,lmax,lsp,t1rf);
    END ArrayTyp; 

    PROCEDURE SetTyp(VAR trf: Stptr); 
      VAR lsp,lsp1: Stptr; lmin,lmax: CARDINAL;
    BEGIN SimpleTyp(lsp1);
      CheckAndGetBounds(lsp1,lmin,lmax);
      IF (lmax >= BitsperWord) OR (lmin >lmax) THEN ErrorLS(107) END; 
      NEW(lsp,sets);
      WITH lsp^ DO
        size := oneword; stidp := NIL; inlist := FALSE;
        form := sets; basep := lsp1; 
      END;
      trf := lsp; 
    END SetTyp; 

    PROCEDURE ProcedureTyp(VAR trf: Stptr); 
      VAR dummysize : CARDINAL;
    BEGIN
      ParamList(FALSE,dummysize,trf);
    END ProcedureTyp; 

    PROCEDURE HiddenTyp(VAR trf: Stptr);
    BEGIN
      NEW(trf,hides);
      WITH trf^ DO
        size := oneword; form := hides;
        stidp := NIL; inlist := FALSE;
      END;
    END HiddenTyp;

    PROCEDURE ActualTyp(VAR trf: Stptr);
    BEGIN 
      IF sy = arraysy THEN GetSy; ArrayTyp(trf);
      ELSIF sy = recordsy THEN GetSy; RecordTyp(trf); 
      ELSIF sy = setsy THEN GetSy; SetTyp(trf); 
      ELSIF sy = pointersy THEN GetSy; PointerTyp(trf); 
      ELSIF sy = proceduresy THEN GetSy; ProcedureTyp(trf); 
      ELSIF sy = hidden THEN  GetSy; HiddenTyp(trf);
      ELSE SimpleTyp(trf) END;
    END ActualTyp;

    PROCEDURE FormalTyp(VAR trf: Stptr); 
      VAR lsp,elementp: Stptr; 
    BEGIN 
      IF sy = arraysy THEN GetSy; 
        SimpleTyp(elementp);
        NEW(lsp,arrays); 
        WITH lsp^ DO
          size := doubleword; stidp := NIL; inlist := FALSE;
          form := arrays; dyn := TRUE; 
          ixp := cardptr; elp := elementp; 
        END;
        trf := lsp; 
      ELSE
        SimpleTyp(trf); (* expect type identifier *)
      END;
    END FormalTyp;

END P2Type. 

