IMPLEMENTATION MODULE P3Exp;
    FROM Storage IMPORT ALLOCATE, DEALLOCATE;
    FROM MCImpl IMPORT 
        BytesperWord, BitsperWord, SameHostTargetBitNumbering, Realsize,
        MaxInt;
    FROM MCBase IMPORT
      noprio,
      Idptr, Stptr, Idclass, Idset,
      Structform, Stset, Varkind, Kindvar,
      charptr, boolptr, intptr, intcarptr,
      realptr, cardptr, wordptr, bitsetptr,
      addrptr, procptr, strptrs, substptr,
      stringcount, stringroot, Stringptr,
      Stfuncs, Symbol, Constval;
    FROM MCP3IO IMPORT
      sy, val, length, spix,
      PutSy, PutWord,
      Savepos, InitSave, ResetSave, ReleaseSave,
      Error, ErrorLS, GetSy, PutGetSy;
    FROM MCP3Ident IMPORT
      Locate, FAmong, SearchId, FieldIndex;
    FROM MCOperations IMPORT RelOp, AddOp, MulOp, NotOp;
    FROM M2Pass3PV IMPORT
      scalars, oneword, doubleword,
      nestlevel, QualIdent;
    FROM P3ExpType IMPORT
        WordComp, OpenTest, IsString, TypFunction;
    IMPORT P3ExpType;
    IMPORT M2Pass3PV;

    VAR stringtail : Stringptr;

    (* MODULE TypeHandling; - now in P3ExpType *)

    PROCEDURE ExprComp(at1, at2: Attribut): BOOLEAN;
    BEGIN  RETURN P3ExpType.ExprComp(at1, at2);
    END ExprComp;

    PROCEDURE AssignComp(at1, at2: Attribut): BOOLEAN;
    BEGIN RETURN P3ExpType.AssignComp(at1, at2);
    END AssignComp;
    
    PROCEDURE AddressComp(at1, at2: Attribut): BOOLEAN;
    BEGIN RETURN P3ExpType.AddressComp(at1, at2);
    END AddressComp;

    (* END TypeHandling; *)

    PROCEDURE StProcCheck(ip: Idptr);
    BEGIN M2Pass3PV.StProcCheck(ip);
    END StProcCheck;
    
    PROCEDURE InitAt(VAR at : Attribut);
    BEGIN
      WITH at DO
        mode := varm;
        atp := NIL;
        aval.value := 0;
      END;
    END InitAt; 

    PROCEDURE StringStruct(length: CARDINAL): Stptr;
      (* get string structure entry *)
      VAR sp : Stptr;
    BEGIN
      IF (length > 20) OR (strptrs[length] = NIL) THEN
        (* generate new entry *)
        NEW(sp,arrays);
        WITH sp^ DO
          size := (length + BytesperWord-1) DIV BytesperWord; (* packing *)
          stidp := NIL;
          form := arrays; dyn := FALSE;
          elp := charptr;
          NEW(ixp,subranges);
          WITH ixp^ DO
            size := oneword;
            stidp := NIL;
            form := subranges;
            scalp := cardptr;
            min := 0; max := length - 1;
          END;
        END;
        IF length <= 20 THEN strptrs[length] := sp END;
      ELSE
        sp := strptrs[length];
      END;
      RETURN sp;
    END StringStruct;

    PROCEDURE AllocString(strval: Stringptr; length: CARDINAL);
    BEGIN
      IF strval^.loadoffset = 177777B THEN
        strval^.loadoffset := stringcount;
        IF NOT InCCALL THEN
            INC(stringcount,(length + BytesperWord) DIV BytesperWord);
	END;
        (* one to BytesperWord characters 0C terminate the constant *)
        (* enter link *)
        IF stringroot = NIL THEN stringroot := strval;
        ELSE stringtail^.slink := strval;
        END;
        stringtail := strval;
      END;
    END AllocString;

    PROCEDURE PutConst(sp: Stptr; cval: Constval);
    BEGIN
      PutSy(anycon);
      PutWord(sp); 
      PutWord(cval.value);
      IF IsString(sp) THEN
        AllocString(cval.svalue,sp^.ixp^.max + 1);
      END;
    END PutConst;

    PROCEDURE TypeExpression(VAR at : Attribut; forms: Stset);
      (* expression with type in forms expected *)
    BEGIN Expression(at); 
      IF NOT FAmong(at.atp,forms) THEN ErrorLS(121) END;
    END TypeExpression;

    PROCEDURE VariableStandard(VAR at: Attribut; forms: Stset);
      (* variable with type in forms expected *)
    BEGIN Expression(at); 
      IF at.mode = varm THEN
        IF NOT FAmong(at.atp,forms) THEN ErrorLS(121) END
      ELSE ErrorLS(122)
      END;
    END VariableStandard;

    PROCEDURE VariantAnalyse(tagref: Stptr; VAR sz: Constval);
      (* analyse of procedure parameters for record variants *)
      (* in standard procedures NEW, DISPOSE, TSIZE *)
      VAR equal : BOOLEAN;
          vxv,vtrf : Stptr;
          ttyp : Stptr; 
          tval : Constval;
    BEGIN
      vtrf := tagref;
      WHILE vtrf <> NIL DO
        IF sy = rparent THEN vtrf := NIL;
        ELSE GetSy; (* tags are not written in the il1 file *)
          ConstantVal(ttyp,tval); 
          WITH vtrf^ DO 
            IF (ttyp = tagtyp) OR 
               ((ttyp = intcarptr) AND FAmong(tagtyp,Stset{ints,cards})) OR
               ((tagtyp^.form = subranges) AND (ttyp = tagtyp^.scalp)) THEN
              vxv := fstvarp; equal := FALSE;
              WHILE (vxv <> NIL) AND NOT equal DO
                WITH vxv^ DO
                  IF varval = tval.value THEN equal := TRUE 
                  ELSE vxv := nxtvarp
                  END
                END; (* WITH vxv^ *)
              END;
              IF NOT equal AND (elsevarp <> NIL) THEN (* ELSE variant *)
                vxv := elsevarp; equal := TRUE;
              END;
              IF equal THEN sz.value := vxv^.size;
                vtrf := vxv^.subtagp;
                IF (vtrf = NIL) AND (sy <> rparent) THEN Error(132) END
              ELSE Error(148);
                vtrf := NIL;
              END;
            ELSE Error(92);
              vtrf := NIL;
            END;
          END;
        END;
      END;
      WHILE sy <> rparent DO GetSy; ConstantVal(ttyp,tval) END; 
    END VariantAnalyse; 

    PROCEDURE PreSelector(x: Idptr; VAR at: Attribut);
    BEGIN
      WITH x^ DO
        OpenTest(idtyp);
        WITH at DO
          IF klass IN Idset{vars,fields} THEN mode := varm;
          ELSE mode := exprm;
          END;
          atp := idtyp;
          IF NOT (klass IN Idset{consts,types}) THEN
            IF klass = fields THEN
              PutSy(field); PutWord(FieldIndex()); PutSy(period);
            END;
            PutSy(namesy); PutWord(x);
          END;
        END (* WITH at *)
      END (* WITH x^ *)
    END PreSelector;

    PROCEDURE Selector(VAR at : Attribut);
      VAR lat,indat : Attribut;
          x : Idptr;
    BEGIN
      REPEAT
        IF sy = lbrack THEN PutGetSy;
          Expression(lat);
          WITH at DO
            IF atp <> NIL THEN
              WITH atp^ DO
                IF form = arrays THEN
                  OpenTest(ixp); OpenTest(elp);
                  indat.atp := ixp; indat.mode := varm; 
                  IF NOT AssignComp(indat,lat) THEN ErrorLS(128) END;
                  atp := elp
                ELSE ErrorLS(130)
                END;
              END; (* WITH atp^ *)
            END;
          END; (* WITH at *)
          PutGetSy; (* rbrack *)
        ELSIF sy = period THEN
          PutGetSy;
          WITH at DO
            IF atp <> NIL THEN
              WITH atp^ DO
                IF form <> records THEN Error(131)
                ELSE
                  Locate(fieldp,x); (* entries with klass = fields assumed *)
                  IF x <> NIL THEN
                    PutSy(namesy); PutWord(x);
                    OpenTest(x^.idtyp);
                    atp := x^.idtyp;
                  ELSE Error(73)
                  END;
                END
              END; (* WITH atp^ *)
            END;
          END; (* WITH at *)
          GetSy;
        ELSIF sy = arrow THEN
          WITH at DO
            IF atp = addrptr THEN atp := wordptr
            ELSIF atp <> NIL THEN
              WITH atp^ DO
                IF form <> pointers THEN Error(146)
                ELSE
                  OpenTest(elemp);
                  atp := elemp
                END
              END; (* WITH typptr^ *)
            END;
          END; (* WITH at *)
          PutGetSy;
        END;
      UNTIL (sy <> lbrack) AND (sy <> period) AND (sy <> arrow);
    END Selector;

    PROCEDURE ParamCheck(fstp : Idptr);
      VAR at1,at2 : Attribut;
          ls :Idptr;
          comp : BOOLEAN;

      PROCEDURE DynArrCheck(dynarelp,aptr: Stptr);
        (* compare element types *) 
      BEGIN
        IF dynarelp <> wordptr THEN
          IF aptr^.form = arrays THEN
            IF aptr^.elp <> dynarelp THEN
              ErrorLS(135)
            END;
          ELSE ErrorLS(128);
          END;
        END;
      END DynArrCheck;

    BEGIN (* ParamCheck *)
      ls := fstp;
      WHILE sy <> rparent DO
        Expression(at1);
        IF ls = NIL THEN Error(132) 
        ELSE
          WITH at1 DO
            IF atp <> NIL THEN
              WITH ls^ DO 
                IF (vkind = varparam) AND (mode <> varm) THEN
                  ErrorLS(134);
                END;
                OpenTest(idtyp);
                IF (idtyp<>NIL) AND (idtyp^.form=arrays) AND
                   idtyp^.dyn THEN
                  DynArrCheck(idtyp^.elp,atp)
                ELSIF idtyp = wordptr THEN
                  IF NOT WordComp(atp) THEN ErrorLS(150) END; 
                ELSE
                  at2.atp := idtyp; at2.mode := varm;
                  IF vkind=varparam THEN comp := ExprComp(at2,at1)
                  ELSE comp := AssignComp(at2,at1)
                  END;
                  IF NOT (comp OR AddressComp(at1,at2)) THEN
                    ErrorLS(128)
                  END
                END;
              END; (* WITH ls^ *)
            END;
            ls := ls^.vlink;
          END; (* WITH at1 *)
        END;
        IF sy = comma THEN PutGetSy END;
      END; (* WHILE *)
      PutGetSy; 
      IF ls <> NIL THEN ErrorLS(137) END;
    END ParamCheck;

    PROCEDURE ExprSequence;
      (* Terminate a sequence of Expressions *)
      VAR at: Attribut;
    BEGIN
      WHILE sy <> rparent DO
        IF sy = comma THEN PutGetSy END;
        Expression(at);
      END;
      PutGetSy; (* rparent *)
    END ExprSequence;

    PROCEDURE Expression(VAR at : Attribut);
      VAR lat : Attribut;
          tpat,tplat : Stptr;
          op : Symbol;
          forms: Stset;
          err : BOOLEAN;
          save : Savepos;

      PROCEDURE SimpleExpression(VAR at : Attribut);
        VAR lat : Attribut;
            op : Symbol;
            sign : BOOLEAN;
            save : Savepos;

        PROCEDURE Term(VAR at : Attribut);
          VAR lat : Attribut;
              op : Symbol;
              save : Savepos;
 
          PROCEDURE Factor(VAR at : Attribut);
            VAR x : Idptr;
                lat : Attribut;
                save : Savepos;

            PROCEDURE SetConstructor(VAR at: Attribut);
              VAR styp, ctyp : Stptr;
                  smin, smax, v1, v2 : CARDINAL;
                  c1, c2 : Constval;
                  spat : BITSET; (* set pattern *)
            BEGIN
              smin := 0; smax := BitsperWord-1; spat := {};
              IF FAmong(at.atp,Stset{sets}) THEN 
                styp := at.atp^.basep;
              ELSE ErrorLS(99);
                styp := NIL;
              END;
              IF FAmong(styp,Stset{enums,bools,cards}) THEN
                WITH styp^ DO
                  CASE form OF
                    subranges:
                      styp := scalp;  (* must not be INTEGER *)
                      IF min > smin THEN smin := min END;
                      IF max < smax THEN smax := max END;
                   |enums: IF cstnr < smax THEN smax := cstnr END
                   |bools: smax := 1
                  ELSE styp := NIL;
                  END;
                END; (* WITH *)
              ELSE styp := NIL
              END;
              GetSy; (* lconbr *) 
              WHILE sy <> rconbr DO
                ConstantRange(ctyp,c1,c2);
                IF (styp = NIL) AND FAmong(ctyp,Stset{enums,bools,cards}) THEN
                  styp := ctyp
                END;
                IF (styp <> NIL) AND
                   ((styp=ctyp) OR ((styp=cardptr) AND (ctyp=intcarptr))) THEN
                  v1 := c1.value; v2 := c2.value;
                  IF (v1 < smin) OR (v2 > smax) THEN ErrorLS(98);
                  ELSE
                    IF SameHostTargetBitNumbering THEN
                      WHILE v1 <= v2 DO INCL(spat,v1); INC(v1) END;
                    ELSE 
                      WHILE v1 <= v2 DO INCL(spat,BitsperWord-(v1+1)); INC(v1) END;
                    END;
                  END;
                ELSE ErrorLS(97); 
                END;
              END; (* WHILE *)
              GetSy;
              at.mode := constm;
              at.aval.value := CARDINAL(spat);
            END SetConstructor;

            PROCEDURE SkipFactor;
              (* skip semantical incorrect elements of factor *)
              VAR at : Attribut;
            BEGIN
              InitAt(at);           
              IF sy = lconbr THEN SetConstructor(at)
              ELSE Selector(at);
                IF sy = lparent THEN GetSy; ExprSequence END;
              END;
            END SkipFactor;

            PROCEDURE StFuncCheck(ip: Idptr; VAR at : Attribut);
              CONST all = Stset{enums..records};
              VAR at1 : Attribut; 
                  lval : Constval;
                  sp : Stptr;
                  nam : Stfuncs;

              PROCEDURE NextParameter(VAR at: Attribut; forms: Stset);
              BEGIN
                IF sy = rparent THEN Error(127);
                ELSE TypeExpression(at,forms);
                END;
              END NextParameter;

            VAR i: CARDINAL;

            BEGIN
              InitAt(at);
              at.mode := exprm;
              nam := ip^.fname;
              PutSy(namesy); PutWord(ip);
              PutGetSy; (* lparent *)
              CASE nam OF
                higf: (* HIGH *)
                  at.atp := cardptr;
                  IF sy = rparent THEN Error(127);
                  ELSE
                    VariableStandard(at1,Stset{arrays});
                    WITH at1 DO
                      IF (atp<>NIL) AND (atp^.form=arrays) THEN
                        IF NOT atp^.dyn THEN
                          at.mode := constm;
                          at.aval.value := atp^.ixp^.max;
                          IF at.aval.value<=MaxInt THEN
                            at.atp := intcarptr;
                          END;
                        END;
                      END;
                    END;
                  END;
               |sizf: (* SIZE *)
                  at.atp := intcarptr;
                  IF sy = rparent THEN Error(127);
                  ELSE
                    VariableStandard(at1,all); 
                    WITH at1 DO
                      IF atp <> NIL THEN
                        IF NOT ((atp^.form=arrays) AND atp^.dyn) THEN
                          at.mode := constm;
                          at.aval.value := atp^.size;
                          IF at.aval.value > MaxInt THEN
                            at.atp := cardptr;
                          END;
                        END;
                      END;
                    END;
                  END;
               |tszf: (* TSIZE *)
                  at.atp := intcarptr;
                  IF sy = ident THEN
                    QualIdent(Idset{types},129,ip);
                    (* new value for ip *)
                    IF ip <> NIL THEN
                      sp := ip^.idtyp;
                      IF sp = NIL THEN lval.value := 0;
                      ELSE
                        WITH sp^ DO
                          lval.value := size;
                          IF form = records THEN
                            VariantAnalyse(tagp,lval)
                          END;
                        END;
                      END;
                      at.mode := constm;
                      at.aval := lval;
                    END;
                  ELSE Error(135);
                  END;
                  CASE sy OF
                    lparent, lconbr, lbrack, period, arrow:
                      Error(135);
                      SkipFactor;
                  ELSE (* nothing *)
                  END; (* CASE *)
               |adrf: (* ADR *)
                  at.atp := addrptr;
                  IF sy = rparent THEN Error(127);
                  ELSE VariableStandard(at1,all); 
                  END;
               |oddf: (* ODD *)
                  at.atp := boolptr;
                  NextParameter(at1,Stset{ints,cards});
               |regf: (* REGISTER *)
                  InitAt(at1);
                  NextParameter(at1,Stset{ints,cards});
                  at.atp := at1.atp;
               |ccaf: (* CCALL *)
                   InCCALL := TRUE;
		   at.atp := wordptr;
	           NextParameter(at1, Stset{arrays});
		   IF at1.mode <> constm THEN Error(121); END;
		   InCCALL := FALSE;
		   IF sy = comma THEN PutGetSy END;
                   i := 0;
		   LOOP
		       IF (sy = rparent) THEN EXIT END;
		       INC(i);
		       NextParameter(at1, Stset{enums .. proctypes});
		       IF sy = comma THEN PutGetSy END;
		   END; (* LOOP *)

               |uxcf: (* UNIXCALL*)
                  at.atp := intptr;
                  i := 0;
                  LOOP
                      IF (sy = rparent) THEN EXIT END;
		      INC(i);
                      NextParameter(at1,Stset{enums .. proctypes});
		      IF (i=1) AND (at1.mode # constm) THEN Error(121) END;
                      IF sy = comma THEN PutGetSy END;
                  END; (* LOOP *)
                  IF i<1 THEN Error(127); END;

               |absf: (* ABS *)
                  InitAt(at1);
                  NextParameter(at1,Stset{ints,cards,reals});
                  at.atp := at1.atp;
               |capf: (* CAP *)
                  at.atp := charptr;
                  NextParameter(at1,Stset{chars});
               |fltf: (* FLOAT *)
                  at.atp := realptr;
                  NextParameter(at1,Stset{ints,cards});
               |trcf: (* TRUNC *)
                  at.atp := cardptr;
                  NextParameter(at1,Stset{reals});
               |ordf: (* ORD *)
                  at.atp := cardptr;
                  NextParameter(at1,scalars);
               |chrf: (* CHR *)
                  at.atp := charptr;
                  NextParameter(at1,Stset{ints,cards});
               |valf: (* VAL *)
                  at.atp := NIL;
                  IF sy = ident THEN
                    QualIdent(Idset{types},129,ip); (* new value for ip *)
                    IF ip <> NIL THEN
                      IF FAmong(ip^.idtyp,scalars) THEN
                        at.atp := ip^.idtyp;
                      ELSE ErrorLS(121);
                      END;
                    END;
                    PutSy(namesy); PutWord(ip);
                  ELSE Error(135);
                  END;
                  CASE sy OF
                    lparent, lconbr, lbrack, period, arrow:
                      Error(135);
                      SkipFactor;
                  ELSE (* nothing *)
                  END; (* CASE *)
                  IF sy = comma THEN PutGetSy END;
                  NextParameter(at1,Stset{ints,cards});
              END; (* CASE nam *) 
              IF sy = rparent THEN PutGetSy;
              ELSE ErrorLS(127); ExprSequence;
              END;
            END StFuncCheck;

          BEGIN (* Factor *)
            InitSave(save);
            InitAt(at);
            IF sy = ident THEN
              QualIdent(Idset{consts..funcs},73,x);
              IF x <> NIL THEN (* ident IN [consts..funcs] *)
                IF (x^.klass IN Idset{pures,funcs}) AND
                   x^.isstandard
                THEN
                  IF sy = lparent THEN
                    IF x^.klass = funcs THEN StFuncCheck(x,at);
                    ELSE
                      Error(145);
                      PutGetSy; (* lparent *)
                      ExprSequence;
                    END;
                  ELSE
                    CASE sy OF
                      lconbr, lbrack, period, arrow:
                        Error(144); SkipFactor;
                    ELSE
                      ErrorLS(147);
                    END; (* CASE *)
                  END;
                ELSE
                  PreSelector(x,at);
                  WITH x^ DO
                    CASE klass OF
                      consts :
                        CASE sy OF
                          lparent, lconbr, lbrack, period, arrow:
                            Error(123); InitAt(at);
                            SkipFactor;
                        ELSE
                          at.mode := constm;
                          IF idtyp = realptr THEN (* make a copy of the real value *)
                            NEW(at.aval.rvalue);
                            at.aval.rvalue^ := cvalue.rvalue^;
                          ELSE at.aval := cvalue;
                          END;
                        END; (* CASE *)
                     |types :
                        CASE sy OF
                          lconbr: SetConstructor(at)
                         |lparent:
                            PutSy(namesy); PutWord(x);
                            TypFunction(at)
                         |lbrack, period, arrow:
                            Error(144); InitAt(at);
                            SkipFactor;
                        ELSE
                          ErrorLS(137); InitAt(at);
                        END; (* CASE *)
                     |vars,fields,pures,funcs:
                        IF at.mode = varm THEN Selector(at) END;
                        CASE sy OF
                          lparent:
                            at.mode := exprm;
                            IF (klass=funcs)AND(priolev<>noprio) THEN
                              externalaccess := TRUE;
                            END;
                            PutGetSy;
                            IF at.atp <> NIL THEN
                              WITH at.atp^ DO
                                IF (form=proctypes) AND (rkind=funcs) THEN
                                  ParamCheck(fstparam);
                                  at.atp := funcp;
                                ELSE ErrorLS(145);
                                  at.atp := NIL;
                                  ExprSequence;
                                END;
                              END;
                            ELSE ExprSequence;
                            END;
                         |lconbr, lbrack, period, arrow:
                            Error(144); InitAt(at);
                            SkipFactor;
                        ELSE
                          IF (klass = pures) OR (klass = funcs) THEN
                            externalaccess := TRUE;
                            IF plev <> 1 THEN ErrorLS(141) END;
                          END;
                        END; (* CASE *)
                    END; (* CASE *)
                  END; (* WITH x^ *)
                END;
              ELSE (* x = NIL *)
                SkipFactor;
              END;
            ELSIF sy = lconbr THEN (* BITSET *)
              at.atp := bitsetptr; SetConstructor(at);
            ELSIF sy = notsy THEN
              PutGetSy;
              Factor(at);
              IF FAmong(at.atp,Stset{bools}) THEN
                IF at.mode = constm THEN
                  NotOp(at.aval,at.aval);
                ELSE
                  at.mode := exprm;
                END;
              ELSE
                at.mode := exprm;
                ErrorLS(138);
              END;
            ELSIF sy = lparent THEN
              PutGetSy;
              Expression(at);
              IF at.mode = varm THEN at.mode := exprm END;
              PutGetSy
            ELSE (* constants *)
              WITH at DO
                mode := constm;
                aval.value := val;
                CASE sy OF
                  intcon : atp := intptr;
                 |intcarcon : atp := intcarptr;
                 |cardcon : atp := cardptr;
                 |charcon : atp := charptr;
                 |realcon : atp := realptr;
                 |stringcon : atp := StringStruct(length);
                END; (* CASE *)
                GetSy;
              END;
            END;
            IF at.mode = constm THEN
              ResetSave(save);
              PutConst(at.atp,at.aval);
            END;
            ReleaseSave(save);
          END Factor;

        BEGIN (* Term *)
          InitSave(save);                      
          Factor(at);
          WHILE (sy >= andsy) AND (sy <= modsy) DO
            op := sy;
            PutGetSy;
            Factor(lat);
            IF at.atp = NIL THEN at.atp := lat.atp;
            ELSE
              IF (at.atp=intcarptr) AND
                 FAmong(lat.atp,Stset{ints,cards}) THEN
                at.atp := lat.atp;
              END;
              IF ExprComp(at,lat) THEN
                CASE op OF
                  andsy: forms := Stset{bools}
                 |times: forms := Stset{ints,cards,sets,reals}
                 |slash: forms := Stset{sets,reals}
                 |divsy,modsy: forms := Stset{ints,cards}
                END; (* CASE *)
                IF FAmong(at.atp,forms) THEN
                  IF (at.mode = constm) AND (lat.mode = constm) THEN
                    MulOp(at.aval,lat.aval,at.aval,op,at.atp,err);
                    IF err THEN
                      at.mode := exprm;
                      IF NOT FAmong(at.atp,Stset{reals}) THEN
                        ErrorLS(94);
                      END;
                    ELSE
                      ResetSave(save);
                      PutConst(at.atp,at.aval);
                    END;
                  ELSE at.mode := exprm;
                  END;
                ELSE
                  at.mode := exprm; 
                  ErrorLS(140);
                END;
              ELSE
                at.mode := exprm;
                ErrorLS(143);
              END;
            END;
          END; (* WHILE *) 
          ReleaseSave(save);
        END Term;

      BEGIN (* SimpleExpression *)
        InitSave(save);
        sign := (sy = minus) OR (sy = plus);
        IF sign THEN
          op := sy;
          IF op = minus THEN PutGetSy ELSE GetSy END;
        END;
        Term(at);
        IF sign THEN
          WITH at DO
            IF mode = varm THEN mode := exprm END;
            IF (atp = intcarptr) OR FAmong(atp,Stset{ints,reals}) THEN
              IF op = minus THEN
                IF mode = constm THEN
                  IF atp = realptr THEN lat.aval.rvalue := NIL;
                  ELSE lat.aval.value := 0;
                  END;
                  AddOp(lat.aval,aval,aval,op,atp,err);
                  IF err THEN
                    mode := exprm;
                    ErrorLS(94);
                  ELSE
                    ResetSave(save);
                    PutConst(atp,aval);
                  END;
                END;
              END;
            ELSIF FAmong(atp,Stset{cards}) THEN
              IF op = minus THEN mode := exprm; ErrorLS(121) END;
            ELSE
              mode := exprm;
              ErrorLS(121); 
            END;
          END; (* WITH *)
        END;
        WHILE (sy >= plus) AND (sy <= orsy) DO
          op := sy;
          PutGetSy;
          Term(lat);
          IF at.atp = NIL THEN at.atp := lat.atp;
          ELSE
            IF (at.atp = intcarptr) AND
               FAmong(lat.atp,Stset{ints,cards}) THEN
              at.atp := lat.atp;
            END;
            IF ExprComp(at,lat) THEN
              CASE op OF
                orsy: forms := Stset{bools}
               |plus,minus: forms := Stset{ints,cards,sets,reals}
              END; (* CASE *)
              IF FAmong(at.atp,forms) THEN
                IF (at.mode = constm) AND (lat.mode = constm) THEN
                  AddOp(at.aval,lat.aval,at.aval,op,at.atp,err);
                  IF err THEN
                    at.mode := exprm;
                    IF NOT FAmong(at.atp,Stset{reals}) THEN
                      ErrorLS(94);
                    END;
                  ELSE
                    ResetSave(save);
                    PutConst(at.atp,at.aval);
                  END;
                ELSE at.mode := exprm;
                END;
              ELSE
                at.mode := exprm;
                ErrorLS(140);
              END;
            ELSE
              at.mode := exprm;
              ErrorLS(143);
            END;
          END;
        END; (* WHILE *)
        ReleaseSave(save);
      END SimpleExpression;

    BEGIN (* Expression *)
      InitSave(save);
      SimpleExpression(at);
      IF (sy >= eql) AND (sy <= insy) THEN
        op := sy;
        PutGetSy;
        SimpleExpression(lat);
        tpat := at.atp;
        tplat := lat.atp;
        IF op = insy THEN 
          IF FAmong(tplat,Stset{sets}) THEN 
            lat.atp := tplat^.basep;
            IF ExprComp(at,lat) THEN
              IF (at.mode=constm) AND (lat.mode=constm) THEN
                RelOp(at.aval,lat.aval,at.aval,insy,tpat,err);
                IF err THEN
                  at.mode := exprm;
                  ErrorLS(94);
                ELSE
                  ResetSave(save);
                  PutConst(boolptr,at.aval);
                END;
              ELSE 
                at.mode := exprm;
              END;
            ELSE
              at.mode := exprm;
              ErrorLS(142);
            END;
          ELSE
            at.mode := exprm;
            ErrorLS(149);
          END
        ELSIF ExprComp(at,lat) OR AddressComp(at,lat) THEN
          IF tpat = intcarptr THEN tpat := tplat END;
          CASE op OF
            eql,neq : forms := Stset{sets,pointers,reals} + scalars
           |geq,leq : forms := Stset{sets,reals} + scalars
           |grt,lss : forms := Stset{reals} + scalars
          END;
          IF FAmong(tpat,forms) THEN
            IF (at.mode=constm) AND (lat.mode=constm) THEN
              RelOp(at.aval,lat.aval,at.aval,op,tpat,err);
              IF err THEN
                at.mode := exprm;
                IF NOT FAmong(tpat,Stset{reals}) THEN
                  ErrorLS(94);
                END;
              ELSE
                ResetSave(save);
                PutConst(boolptr,at.aval);
              END;
            ELSE at.mode := exprm;
            END;
          ELSE
            at.mode := exprm;
            ErrorLS(140);
          END;
        ELSE
          at.mode := exprm;
          ErrorLS(143);
        END;
        at.atp := boolptr;
      END;
      ReleaseSave(save);
    END Expression;

    PROCEDURE Constant(VAR at: Attribut);
      VAR save : Savepos;
    BEGIN
      InitSave(save);
      Expression(at);
      WITH at DO
        IF mode = constm THEN
          ResetSave(save);
          IF ((atp=cardptr)OR(atp=intptr))AND(aval.value<=MaxInt) THEN
            atp := intcarptr; 
          END;
        ELSE ErrorLS(136);
        END;
      END;
      ReleaseSave(save);
    END Constant;

    PROCEDURE ConstantRange(VAR tp: Stptr; VAR c1, c2: Constval);
      VAR fval,lval : CARDINAL;
          at : Attribut;
    BEGIN
      Constant(at);
      tp := at.atp;
      fval := at.aval.value; lval := fval;
      IF sy = range THEN
        IF FAmong(tp,scalars) THEN 
          GetSy; (* range *)
          Constant(at);
          WITH at DO
            IF tp = intcarptr THEN
              IF FAmong(atp,Stset{ints,cards}) THEN tp := atp END;
            ELSIF atp = intcarptr THEN
              IF FAmong(tp,Stset{ints,cards}) THEN atp := tp END;
            END;
            IF tp = atp THEN
              lval := aval.value;
              IF tp = intptr THEN
                IF INTEGER(lval) < INTEGER(fval) THEN
                  ErrorLS(95);
                  lval := fval;
                END;
              ELSIF lval < fval THEN ErrorLS(95); lval := fval;
              END;
            ELSE ErrorLS(95);
            END;
          END; (* WITH *)
        ELSE Error(96); GetSy;
        END;
      END;
      c1.value := fval; c2.value := lval;
    END ConstantRange;

    PROCEDURE ConstantVal(VAR tp: Stptr; VAR c: Constval);
      VAR at : Attribut;
    BEGIN
      Constant(at);
      tp := at.atp;
      c := at.aval;
    END ConstantVal;

  BEGIN
    stringcount := 0;
    stringroot := NIL;
    InCCALL := FALSE;
END P3Exp .


