IMPLEMENTATION MODULE P4CallStFunc;

  FROM MCImpl IMPORT BytesperWord;
  FROM MCBase IMPORT  
    Idptr, Stptr, noprio,
    Idclass, Structform, 
    Varkind, Stfuncs, wordptr,
    Symbol, cardptr, intcarptr, intptr,
    addrptr, boolptr, charptr, realptr;

  FROM MCP4Global IMPORT 
    loadCount, arithmeticRangeCheck,
    GetSymbol, sy, nptr,
    Error;

  FROM MCP4CodeSys IMPORT
   
    (*Codesys*)
         Emit, Emit2,
        
    (*SimpleCode*)
         EmitLI, UConstMul, UAddToTop, 

    (*TypeSystem*)
         ByteSize, IsArrayType;
    
  FROM MCP4AttributSys IMPORT
    ArithmeticType, Attribut, AtMode,
    Arithmetic,
    RangeCheck, SizeType,
    Load, LoadAddr, Store,
    LoadDynHigh;

  FROM MCP4ExpressionSy IMPORT
    Expression, Designator, ExpressionAndLoad;

  FROM MCMnemonics IMPORT
    FFCT,
    STOT, DECS,
    SHR, SHL,  ANDD, ABSS, 
    FABS, CHKZ, FUNC;

  FROM P4StFuOS IMPORT StandFuncOS;

    PROCEDURE Forget(VAR fat: Attribut);
    BEGIN
      IF fat.mode=addrLoadedMod THEN
        (* forget the top of the expression stack *)
        Emit(STOT); Emit(DECS); DEC(loadCount)
      END
    END Forget;


    PROCEDURE StandFunc(VAR fat: Attribut; fCalling: Stfuncs);   

      VAR
        lat1, lat2 : Attribut;
        ltyp: ArithmeticType; 
        lTypP: Stptr;

    BEGIN
      CASE fCalling OF  
          higf: (* HIGH *)  
            Designator(fat); Forget(fat);  
            WITH fat DO  
(*              Assert(IsArrayType(typtr));   *)
              WITH typtr^ DO
                IF dyn THEN
                  LoadDynHigh(fat); mode := loadedMod;
                  typtr := cardptr   
                ELSE   
(*                  Assert(ixp^.form=subranges);   *)
                  mode := constantMod;  
                  value := ixp^.max;  
                  typtr := ixp^.scalp   
                END  
              END  
            END  

        | sizf: (*SIZE *)  
            Designator(fat); Forget(fat);  
            WITH fat DO  
              IF IsArrayType(typtr) AND typtr^.dyn THEN  
                LoadDynHigh(fat); mode := loadedMod;
                IF ByteSize(typtr^.elp) THEN
                  EmitLI(BytesperWord DIV 2); Emit(SHR); DEC(loadCount);
                  UAddToTop(1) 
                ELSE
                  UAddToTop(1); 
                  UConstMul(typtr^.elp^.size)
                END
              ELSE 
                mode := constantMod;  
                value := SizeType(fat)  
              END;  
              typtr := intcarptr   
            END  

        | adrf: (* ADR *)  
            Designator(fat);  
            LoadAddr(fat); fat.mode := loadedMod;
            fat.typtr:= addrptr  

        | oddf: (* ODD *)  
            Expression(fat); Load(fat);
            fat.typtr := boolptr;  
            EmitLI(1); Emit(ANDD); DEC(loadCount)

        | chrf: (* CHR *)  
            Expression(fat); 
            RangeCheck(charptr, fat);
            (*EmitLI(377B); Emit(ANDD); DEC(loadCount);*)
            fat.typtr := charptr  

        | ordf: (* ORD *)  
            Expression(fat); 
            fat.typtr := cardptr  

        | valf:   
(*            Assert((sy=namesy) AND (nptr^.klass=types)); *)
            lTypP := nptr^.idtyp; GetSymbol;
            GetSymbol; (*comma*)
            Expression(fat); 
            RangeCheck(lTypP, fat);
            fat.typtr := lTypP  

        | absf:  (* ABS *)
            Expression(fat); 
            ltyp := Arithmetic(fat, fat);
            IF ltyp = signed  THEN
              Load(fat); Emit(ABSS)
            ELSIF ltyp=floating THEN 
              Load(fat);  Emit(FABS)
            ELSE 
(*              Assert(ltyp=unSigned) *)
            END
  
        | capf:  (* CAP *)
            Expression(fat); Load(fat);  
            EmitLI(137B); Emit(ANDD); DEC(loadCount)

        | fltf:  (* FLOAT *)
            Expression(fat); Load(fat); fat.typtr := realptr;
            INC(loadCount); 
            Emit(FFCT); Emit(0)

        | trcf:  (* TRUNC *)
            Expression(fat); Load(fat); fat.typtr := cardptr; 
            DEC(loadCount); 
            Emit(FFCT); Emit(2)

        ELSE 	(* might be an machine specific function *)
            StandFuncOS(fat, fCalling);
	    IF fCalling = ccaf THEN Emit (FUNC) END;
      END;
    END StandFunc;  

END P4CallStFunc .
