IMPLEMENTATION MODULE P4CallStProc;

  FROM MCImpl IMPORT BitsperWord;
  FROM MCBase IMPORT  
    Idptr, Stptr, noprio,
    Idclass, Structform, 
    Varkind, Stpures,
    Symbol, Stfuncs;

  FROM MCP4Global IMPORT 
    loadCount, arithmeticRangeCheck,
    GetSymbol, sy, blockNptr,
    Error;

  FROM MCP4CodeSys IMPORT
   
    (*Codesys*)
         Emit, 
        
    (*SimpleCode*)
         EmitLI;

  FROM MCP4AttributSys IMPORT
    ArithmeticType, AtMode, Attribut, ModeSet,
    HasAlreadyCode, Arithmetic,
    RangeCheck, SizeType,
    Load, LoadAddr, Store,
    LoadDynHigh, PreAssign;

  FROM MCP4ExpressionSy IMPORT
    Expression, Designator, ExpressionAndLoad;

  FROM MCMnemonics IMPORT
    LSA,
    GB1, GB, CX, CI, CF, FFCT,
    STORE, STOT, LODFW, LODFD, COPT, DECS, STOFV,
    TRA, TRAP,
    ADD, UADD, SUB,  USUB, SYS,
    SHR, SHL,  ANDD, ORR, ABSS, BIT, COM,
    FABS, CHKZ;

FROM P4StFuOS IMPORT StandFuncOS;

  PROCEDURE StandProc(fCalling: Stpures);   

    PROCEDURE TransfProc;
    (* Treat call of procedure TRANSFER *)
      VAR lat: Attribut; (* descriptor of parameter *)
    BEGIN
      (* first parameter: old coroutine *)
      Designator(lat); LoadAddr(lat);
      GetSymbol; (*comma*)
      (* second parameter: new coroutine *)
      Designator(lat); 
      LoadAddr(lat);
      Emit(TRA); DEC(loadCount, 2);
      IF blockNptr^.priolev=noprio THEN Emit(0) ELSE Emit(1) END
    END TransfProc;

    PROCEDURE NewPrProc; 
    (* Treat call of procedure NEWPROCESS *)
      VAR lat: Attribut; (* descriptor of parameter *)
          i: CARDINAL;
    BEGIN
      FOR i := 1 TO 3 DO
        (* parameter transmission as for user procedure *)
        ExpressionAndLoad;
        GetSymbol; (*comma*)
      END;
      Designator(lat); LoadAddr(lat);
      Emit(CX); Emit(0); Emit(2); DEC(loadCount, 4)
    END NewPrProc;


    VAR 
      lat1, lat2, lat3: Attribut;
      AType: ArithmeticType;
      lLoadCount: CARDINAL;
  BEGIN  
    lLoadCount := loadCount;
    CASE fCalling OF   
        incp, decp: (* INC, DEC(lat1, lat2) *)
          Designator(lat1); 
          PreAssign(lat1);
          IF lat1.mode IN HasAlreadyCode THEN 
            IF lat1.mode=byteIndexMod THEN Error(206); lat1.mode := indexMod END;
            LoadAddr(lat1); 
            Emit(COPT);   (* address loaded twice *)
            INC(loadCount);
          END;
          lat3 := lat1; Load(lat3); (* save lat1 for subsequent store *)
          IF sy=comma THEN GetSymbol;
            ExpressionAndLoad
          ELSE EmitLI(1) 
          END;
          AType := Arithmetic(lat1, lat1); (* twice lat1 !*)
          IF fCalling=incp THEN
            CASE AType OF
                signed:   Emit(ADD)
              | unSigned: Emit(UADD)
            END
          ELSE (*decp*)
            CASE AType OF
                signed:   Emit(SUB)
              | unSigned: Emit(USUB)
            END
          END;
          DEC(loadCount);
          Store(lat1);
          lat1.mode := illegalMod;
          lat2.mode := illegalMod;
          lat3.mode := illegalMod
               
      | halp: (* HALT *)  
          EmitLI(10); Emit(TRAP) 

      | inlp, exlp: (* INCL, EXCL(lat1, lat2) *)   
          Designator(lat1); PreAssign(lat1);
          IF lat1.mode IN HasAlreadyCode THEN 
            LoadAddr(lat1); 
            Emit(COPT);    (* address loaded twice *) 
            INC(loadCount)
          END;
          lat3 := lat1; Load(lat3); (* save lat1 for subsequent store *)
          GetSymbol; 
          ExpressionAndLoad;
          (* insert later optimisation for constants *)
          IF arithmeticRangeCheck THEN EmitLI(BitsperWord-1); Emit(CHKZ) END;
          Emit(BIT);
          IF fCalling=inlp THEN
            Emit(ORR)
          ELSE (*exclp*)
            Emit(COM); Emit(ANDD)
          END;
          DEC(loadCount);
          Store(lat1);
          lat1.mode := illegalMod;
          lat2.mode := illegalMod;
          lat3.mode := illegalMod

      | ccap: StandFuncOS (lat1, ccaf);

      | trsp: (* TRANSFER *)
         TransfProc;

      | nprp: (* NEWPROCESS *)
          NewPrProc;
    
      END;  
      loadCount := lLoadCount (* To undo any INC(LoadCount)'s *)
                              (* of CODE which can't be counted *)
    END StandProc;  

END P4CallStProc .
