IMPLEMENTATION MODULE P4CodeBlk;
  FROM MCImpl IMPORT BytesperWord;
  FROM MCBase IMPORT
    Idptr, Stptr, mainmodp, Varkind, Structform,
    charptr, globvarnext, root, Idclass, noprio;
  FROM MCP4Global IMPORT 
    blockNptr, 
    loadAddress, loadCount, CompilerError; 
  FROM MCP4CodeSys IMPORT
         PC,
         Emit, Emit2, 
         Insert, Insert2, 
         MoveCode,
         MarkShort, UpdateShort,
         MarkLong,  UpdateLong,
         LinkageMark, 
         Emit2GivePC, Fixup2,
         EmitPacked, EmitLI, EmitLSW,
         EmitSSW, EmitCL, UAddToTop, UConstMul,
         PutCodeWord, PutCodeText,
         IsArrayType, ByteSize, IsSetType;

  FROM MCMnemonics IMPORT   
    LIn,
    LIB,  LIW,  LGA, LSA,  
    JPFC, TRAP, NOP,
    LLD, LLW, UADD,
    SLW,  SLD,  
    LGW,  SGW,  SGD,   
    ENTR, ALOC, 
    COPT, DECS, PCOP,
    ENTP, EXP,
    SHR,  
    RTN,  CX,   CI,  CF, TS;

  FROM UtilError IMPORT ReportError;
     
  PROCEDURE GenBlockEntry;
    (* fix proceduretable and generate entry sequence *)
    VAR lvp, lpp, lpp1: Idptr;
        n, i, l: CARDINAL;
  BEGIN loadCount := 0; PC := 0;
    IF blockNptr<>NIL THEN
      WITH blockNptr^ DO
        PutCodeWord(procnum, 2*loadAddress); (* Fix ProcedureTable *)
        Emit(ENTR); Emit(varlength-4); (*>= 4 local vars !*)
        IF blockNptr=mainmodp THEN
	    Emit (0); (* PARAMATER CHANGE *)
          (* Test and return if already initialized *)
            EmitPacked(LGA, 1);
            Emit(TS);
            Emit(JPFC); Emit(2);
            Emit(RTN);
          (* globalMod variables *)        
            (* GlobalSize := globvarnext; *)
            Emit(LGA); Emit(globvarnext);
(*            Assert(globvarnext<=400B); *)
            EmitPacked(SGW, 2);
            lvp := globvarp;
            WHILE lvp<>NIL DO
              WITH lvp^ DO
(*                Assert((klass=vars) AND (vkind=noparam)); *)
                IF indaccess THEN
                  (* Emit(GlobALLOC); Emit(vaddr); Emit2(idtyp^.size) *)
                  (* INC(GlobalSize, idtyp^.size) *)
                  EmitPacked(LGW, 2);
                  Emit(COPT);
                  EmitPacked(SGW, vaddr);
                  UAddToTop(idtyp^.size);
                  EmitPacked(SGW, 2)
                END;
                lvp := vlink
              END
            END;
          (* Call the Initilaisations of Imported modules *)
            lpp := root^.locp^.link;
            WHILE lpp<>NIL DO
              IF lpp<>mainmodp THEN
(*                Assert(lpp^.globalmodule); *)
                Emit(CX);
                LinkageMark; Emit(lpp^.modnum);
                Emit(0); (* Procedure Number for Initialisation *)
              END;
              lpp := lpp^.link
            END;
          (* There are no parameters *)
            lpp := NIL;
        ELSIF blockNptr^.klass=mods THEN
          lpp := NIL; lvp := NIL;
	  Emit (0);  (*  PARAMETER CHANGE *)
        ELSE lvp := locvarp;
	  Emit (CountParamSpace (idtyp^.fstparam)); (* PARAMETER CHANGE *)
          lpp := idtyp^.fstparam
        END
      END;
      (* save first parameter to allow interrupts *)
      (* reverse order, but no change of link since parameter are 
         used before and after this peace of code *)
      n := 0; lpp1 := lpp;
      WHILE lpp<>NIL DO INC(n); lpp := lpp^.vlink END;
      FOR i := n TO 1 BY -1 DO
        lpp := lpp1;
        FOR l := 2 TO i DO lpp := lpp^.vlink END;
        WITH lpp^ DO
(*          Assert(klass=vars);  *)
          CASE vkind OF
            noparam:  CompilerError(6)
          | varparam:                             
              IF IsArrayType(idtyp) AND idtyp^.dyn THEN
                Emit(SLD); Emit(vaddr);
              ELSE
                EmitPacked(SLW, vaddr)
              END
          | valparam:
              IF idtyp^.size=1 THEN EmitPacked(SLW, vaddr);
              ELSE 
(*                Assert(idtyp^.size=2);  *)
ReportError (FALSE, "Val NOT size 1", 0, 0);
                Emit(SLD); Emit(vaddr)
              END
          | copyparam:
              IF IsArrayType(idtyp) AND idtyp^.dyn THEN
                Emit(SLD); Emit(vaddr);
                Emit(LLD); Emit(vaddr);
                IF ByteSize(idtyp^.elp) THEN
                  EmitLI(BytesperWord DIV 2); Emit(SHR); DEC(loadCount);
(*                Emit(LSA); Emit(1) (* Add ONE!!! *)		      *)
                  EmitLI(1); Emit(UADD);
                ELSE
(*                Emit(LSA); Emit(1);				      *)
                  EmitLI(1); Emit(UADD);
		  UConstMul(idtyp^.elp^.size)
                END
              ELSE
(*                Assert(indaccess); *)
                EmitLI(idtyp^.size); DEC(loadCount)
              END;
              Emit(PCOP); Emit(vaddr)
          END
        END (*With*)
      END; (*FOR*)
      (* allocate space for local variables *)
      WHILE lvp<>NIL DO  
        WITH lvp^ DO
(*          Assert((klass=vars) AND (vkind=noparam)); *)
          IF indaccess THEN      
            EmitLI(idtyp^.size); DEC(loadCount);
            Emit(ALOC);
            EmitPacked(SLW, vaddr)
          END;
          lvp := vlink
        END
      END;
      IF (blockNptr^.priolev<>noprio) AND blockNptr^.externalaccess THEN
        Emit(ENTP);
        Emit(blockNptr^.priolev+1)
      END
    END;
    loadCount := 0;
  END GenBlockEntry;

  (*   PARAMETER CHANGE - CODE TO COUNT PARAM SPACE *)

  PROCEDURE CountParamSpace (pp : Idptr) : CARDINAL;
  VAR n : CARDINAL;
      lpp : Idptr;
  BEGIN
      n := 0;
      lpp := pp;
      WHILE lpp<>NIL DO
        WITH lpp^ DO
              IF IsArrayType(idtyp) AND idtyp^.dyn THEN
                INC (n,2)
	      ELSE INC (n)
	      END
        END; (*With*)
        lpp := lpp^.vlink
      END;
      RETURN (n);
    END CountParamSpace;

  PROCEDURE GenBlockReturn;
    (* generate a return from a block *)
  BEGIN
    IF (blockNptr^.priolev<>noprio) AND blockNptr^.externalaccess THEN
      Emit(EXP)
    END;
    Emit(RTN);
    loadCount := 0
  END GenBlockReturn;


  PROCEDURE TerminateBlock;
    (* generate exit sequence and 
       terminates handling of the current block*)
  BEGIN
    IF blockNptr<>NIL THEN
      IF blockNptr^.klass=funcs THEN
        EmitLI(9); Emit(TRAP)
      ELSE 
        GenBlockReturn 
      END;
      IF ODD(PC) THEN Emit(NOP) END;
      PutCodeText(loadAddress);
      INC(loadAddress, PC DIV 2); 
      PC := 0
    END;
    loadCount := 0
  END TerminateBlock;


  PROCEDURE CodeBody(fpptr: Idptr);
    (* inline body of CODE procedure *)
    TYPE CodePtr = POINTER TO ARRAY [0..77777B] OF CARDINAL;
    VAR i: CARDINAL; cptr: CodePtr;
  BEGIN  
    WITH fpptr^ DO
      cptr := CodePtr(codeentry);
      i := 0;
      WHILE i<codelength DO 
        Emit(cptr^[i]); INC(i)
      END
    END
  END CodeBody;


  PROCEDURE GenCodeBlock;
    (* complete non-inline CODE procedure *)
  BEGIN
    PC := 0;
    WITH blockNptr^ DO
      PutCodeWord(procnum, 2*loadAddress) (* Fix ProcedureTable *)
    END;
    IF (blockNptr^.priolev<>noprio) THEN (*allways externalaccess*)
      Emit(ENTP);
      Emit(blockNptr^.priolev+1)
    END;
    CodeBody(blockNptr);
    (* TerminateBlock would generate TRAP instead of RTN *)
    GenBlockReturn;
    IF ODD(PC) THEN Emit(NOP) END;
    PutCodeText(loadAddress);
    INC(loadAddress, PC DIV 2);
    loadCount := 0
  END GenCodeBlock;


END P4CodeBlk.
