IMPLEMENTATION MODULE P4ExpDes;

FROM MCBase IMPORT
    Symbol, Structform, Stptr, Idclass, Idptr, Kindvar, Varkind,
    intptr, charptr, addrptr, wordptr;
FROM MCP4Global IMPORT
    GetSymbol, sy, val, Error, level, loadCount, nptr,
    controlRangeCheck, CompilerError;
FROM MCP4AttributSys IMPORT
    Attribut, AtMode, LoadAddr, Load, RangeCheckForConstant,
    TestBaseType,  LoadDynHigh;
FROM MCP4CodeSys IMPORT
    Emit, Emit2, EmitLI, ByteSize, UConstMul;
FROM MCP4ExpressionSy IMPORT
    Expression;
FROM MCMnemonics IMPORT GB, GB1, SUB, USUB, CHKZ;
FROM P4ExpWith IMPORT UseWith;

  PROCEDURE Designator(VAR fat : Attribut);   


    PROCEDURE TypFunction(ftp: Stptr; VAR fat : Attribut);   
      (* ftp is type of function *)
    BEGIN GetSymbol; GetSymbol; 
      Expression(fat);  
      IF fat.mode=stringTemplateMod THEN LoadAddr(fat) END;
      WITH fat DO
        IF (typtr^.size<>ftp^.size) 
           OR ((typtr^.form=arrays) AND typtr^.dyn) THEN Error(220) 
        ELSE
          (* in type conversion no rangetests!
             IF ftp=charptr THEN
               Load(fat); EmitLI(377B); Emit(ANDD); DEC(loadCount)
             END;
          *) 
          IF ftp^.size>2 THEN LoadAddr(fat) 
          ELSE Load(fat)
          END
        END;
        typtr := ftp
      END
    END TypFunction;  


    PROCEDURE PreDesignator(VAR fat: Attribut);
      (* The code for loading a procedure base address will already be generated 
         if necessary, but neither the value nor the address is completely
         loaded *)
      VAR i: CARDINAL;
          lType: Stptr;
    BEGIN
      WITH fat DO
        IF sy=namesy THEN
          WITH nptr^ DO
            typtr := idtyp;
            IF klass=vars THEN
              addr := vaddr;
              CASE state OF
                global:   mode := globalMod;
              | local:  i := level-vlevel;
                  IF i=0 THEN mode := localMod
                  ELSE mode := addrLoadedMod; 
                    INC(loadCount);
                    IF i=1 THEN Emit(GB1)  
                    ELSE Emit(GB); Emit(i)
                    END;
		    (* Emit ParmSpace *)
		    Emit (ParmSpace);
                  END;
                  IF (typtr^.form=arrays) AND typtr^.dyn THEN
                    dynArrLevelDiff := i; dynArrOffset := vaddr+1;
		    dynArrPS := ParmSpace;
                  END
              | absolute: mode := absolutMod
              | separate: mode := externalMod; 
                          moduleNo := globmodp^.modnum
              END;
              IF indaccess THEN
                lType := typtr; typtr := intptr;
                Load(fat); mode := addrLoadedMod; addr := 0;
                typtr := lType
              END
            ELSIF (klass=pures) OR (klass=funcs) OR (klass=mods) THEN
              mode := procedureMod;
              procPtr := nptr
            ELSE (*klass=types*)
(*              Assert(klass=types); *)
              TypFunction(idtyp, fat)
            END (*IF klass=..*)  
          END (*WITH nptr^*)
        ELSE (*sy=field*)
(*          Assert(sy=field);  *)
          UseWith(val, fat)
        END;
      END (*WITH fat*);
      GetSymbol
    END PreDesignator;


    PROCEDURE SwitchAddr(VAR fat: Attribut; x: CARDINAL);
      (* adds x to the address of fat, may generate code *)
    BEGIN
      CASE fat.mode OF       (*prepare fat*)
          externalMod, addrLoadedMod, localMod, globalMod:    
            IF (fat.addr+x) > 255 THEN LoadAddr(fat) END;
            INC(fat.addr, x)
        | indexMod, doubleIndexMod, absolutMod: 
            IF x<>0 THEN
              LoadAddr(fat);
              fat.addr := x
            END
        ELSE CompilerError(7)
      END;
    END SwitchAddr;


    PROCEDURE IndexVar(VAR fat: Attribut);
      (* compilation of array indexing *)
      VAR iat: Attribut; xtyp: Stptr;
          elsize: CARDINAL;
          isdyn: BOOLEAN;
          newMode: AtMode;
    BEGIN
      WITH fat DO  (* attribut for array *)
(*        Assert(IsArrayType(typtr)); *)
        LoadAddr(fat); (* -> mode := addrLoadedMod, addr := 0 *)
        WITH typtr^ DO
          xtyp := ixp;
          elsize := elp^.size; isdyn := dyn;
          IF (elsize=1) AND ByteSize(elp) THEN newMode := byteIndexMod 
          ELSIF elsize=2 THEN newMode := doubleIndexMod
          ELSE newMode := indexMod
          END
        END;
        Expression(iat); 
        IF (iat.mode=constantMod) AND NOT isdyn THEN 
          RangeCheckForConstant(xtyp, iat);
          IF (newMode<>byteIndexMod) THEN
            IF TestBaseType(xtyp)=intptr THEN 
              SwitchAddr(fat, (CARDINAL(INTEGER(iat.value)-
                                        INTEGER(xtyp^.min))*elsize))
            ELSE 
              SwitchAddr(fat, (iat.value-xtyp^.min)*elsize)
            END;
          ELSE (* for byte indexing no optimization is possible *) 
            Load(iat);
            IF xtyp^.min<>0 THEN 
              EmitLI(xtyp^.min); 
              IF TestBaseType(xtyp)=intptr THEN Emit(SUB)
              ELSE Emit(USUB) END
            END;
            mode := byteIndexMod;
          END
        ELSE 
          Load(iat);
          IF isdyn THEN
            IF controlRangeCheck THEN 
              LoadDynHigh(fat);
              Emit(CHKZ); DEC(loadCount);
            END
          ELSE
            IF xtyp^.min<>0 THEN 
              EmitLI(xtyp^.min); 
              IF TestBaseType(xtyp)=intptr THEN Emit(SUB)
              ELSE Emit(USUB) END;
	    DEC (loadCount);  (* Bug fix IML Oct 87 *)
            END;
            IF controlRangeCheck THEN
              IF TestBaseType(xtyp)=intptr THEN
                EmitLI(CARDINAL(INTEGER(xtyp^.max)-INTEGER(xtyp^.min))) 
              ELSE EmitLI(xtyp^.max-xtyp^.min) END;
              Emit(CHKZ); DEC(loadCount);
            END
          END;
          mode := newMode;                     
          IF (mode=indexMod) AND (elsize>1) THEN
            UConstMul(elsize)
          END;
        END; 
        typtr := typtr^.elp
      END
    END IndexVar;

 
  BEGIN (* Designator *)  
    PreDesignator(fat);  
    WHILE (sy=lbrack) OR (sy=arrow) OR (sy=period) DO  
      IF sy = lbrack THEN GetSymbol;  
        IndexVar(fat);
(*        Assert(sy=rbrack);   *)
        GetSymbol (*rbrack*)  
      ELSIF sy = arrow THEN (* indirection via a pointer *)
        GetSymbol;  
        Load(fat); 
        WITH fat DO  
          IF typtr=addrptr THEN typtr := wordptr
          ELSE
(*            Assert((typtr<>NIL) AND (typtr^.form=pointers));   *)
            typtr := typtr^.elemp  
          END;
          mode := addrLoadedMod; addr := 0
        END  
      ELSE (* record field *)
        GetSymbol; (*period*) 
(*        Assert((sy=namesy) AND (nptr<>NIL) AND (nptr^.klass=fields)); *)
        SwitchAddr(fat, nptr^.fldaddr); 
        fat.typtr := nptr^.idtyp;
        GetSymbol  
      END  
    END  
  END Designator;  
 
END P4ExpDes .
