IMPLEMENTATION MODULE P4ExpFact;

FROM SYSTEM IMPORT ADDRESS;
FROM MCBase IMPORT
    Symbol, Stringptr, realptr;
FROM MCP4ExpressionSy IMPORT Expression;
FROM P4ExpDes IMPORT Designator;
FROM MCP4AttributSys IMPORT
    Attribut, Load, SimpleType, AtMode, Arithmetic, 
    ArithmeticType, ResultType;
FROM MCP4Global IMPORT
    GetSymbol, sy, val, cstPtr, cString, loadCount;
FROM MCP4CallSys IMPORT ProcFuncCall;
FROM MCP4CodeSys IMPORT
    Emit, EmitLI, IsSetType,  PutConstString, UConstMul, UConstMod,
    UConstDiv, MarkShort, UpdateShort;
FROM MCMnemonics IMPORT
    FADD, FSUB, FMUL, FDIV, FCMP, FNEG,
    ORJP, ANDJP,
    ADD,  SUB,  MUL,  DIVV, UADD, USUB, UMUL, UDIV, UMOD,
    ORR,  XORR, ANDD, COM,  NOTT, COPT;

FROM MCImpl IMPORT Realsize;

  PROCEDURE Factor(VAR fat: Attribut);   
    VAR rptr: POINTER TO (*REAL*)
                RECORD r1, r2: CARDINAL END;
  BEGIN (* Factor *)  
    IF sy = lparent THEN
      GetSymbol; Expression(fat); GetSymbol; (* rparent *)  
    ELSIF sy = notsy THEN GetSymbol; Factor(fat);         
      IF IsSetType(fat.typtr) THEN           
        Load(fat); Emit(COM)
      ELSE (* BOOLEAN *)
        IF fat.mode<>constantMod THEN
          Load(fat); Emit(NOTT)
        ELSE fat.value := 1-fat.value (* NOT fat.value *)
        END
      END  
    ELSIF (sy = namesy) OR (sy = field) THEN
      Designator(fat);  
      IF sy=lparent THEN (* function call *)  
        GetSymbol; ProcFuncCall(fat)  
      END
    ELSE (*Constant*)   
(*      Assert(sy=anycon);   *)
      WITH fat DO 
        typtr := cstPtr;  
        IF NOT SimpleType(fat) THEN                         
          mode := stringTemplateMod;
          addr := cString^.loadoffset;
          PutConstString(cstPtr, cString)
        ELSIF typtr=realptr THEN 
          rptr := ADDRESS(cString);
          r1 := rptr^.r1;  r2 := rptr^.r2;
	  IF Realsize=2 THEN
              mode := doubleConstMod;
	  ELSE
	      mode := constantMod;
	      value := r1;
          END;
          Load(fat)
        ELSE mode := constantMod;
          value := CARDINAL(val)
        END  
      END; 
      GetSymbol  
    END  
  END Factor;   
  PROCEDURE Term(VAR fat: Attribut);   
    VAR 
      lat: Attribut; opsy: Symbol;  
      AType: ArithmeticType;
      lPC: INTEGER; 

    PROCEDURE Multiplication(VAR fat, lat: Attribut);
      VAR cat: Attribut; opt: BOOLEAN;                     
    BEGIN opt := FALSE;
      IF fat.mode<>constantMod THEN Load(fat) END;        
      GetSymbol;
      Factor(lat);
      IF lat.mode<>constantMod THEN Load(lat) END;
      CASE Arithmetic(fat, lat) OF
        bitwise: 
           Load(fat); Load(lat);  (* commutative !!  *)
                                  (* if lat=loaded and fat=const *)
           Emit(ANDD); DEC(loadCount) |

        floating:
           Load(fat); Load(lat);  (* commutative !! *)
           Emit(FMUL); DEC(loadCount) |

        signed:
           IF fat.mode=constantMod THEN cat := fat; opt := TRUE;
             IF lat.mode<>loadedMod THEN Load(lat) END (* commutative!! *)
           ELSIF lat.mode=constantMod THEN cat := lat; opt := TRUE;
             (* pass 3: fat.mode=loadedMod *)
(*             Assert(fat.mode=loadedMod)  *)
           END;
           IF opt THEN
             IF cat.iValue<>1 THEN
               IF cat.iValue=0 THEN Emit(COPT); Emit(XORR)
               ELSIF cat.iValue=2 THEN Emit(COPT); Emit(ADD)
               ELSE EmitLI(cat.value); Emit(MUL); DEC(loadCount)
               END
             END
           ELSE
             Emit(MUL); DEC(loadCount)
           END;
           fat.mode := loadedMod |

        unSigned:
           IF fat.mode=constantMod THEN   
             IF lat.mode<>loadedMod THEN Load(lat) END; (*commutative !!*)
             UConstMul(fat.value);
           ELSIF lat.mode=constantMod THEN
             (* pass 3: fat.mode=loadedMod *)
(*             Assert(fat.mode=loadedMod);  *)
             UConstMul(lat.value)
           ELSE
             Emit(UMUL); DEC(loadCount);
           END;
           fat.mode := loadedMod
      END 
    END Multiplication;

  BEGIN (* Term *)  
    lPC := 0;
    Factor(fat);  
    WHILE (sy >= andsy) AND (sy <= modsy) DO opsy := sy;  
      IF sy=times THEN
        Multiplication(fat, lat)
      ELSE
        Load(fat);
        GetSymbol;  
        IF opsy=andsy THEN
          Emit(ANDJP); MarkShort(lPC)
        END;
        Factor(lat); 
        AType := Arithmetic(fat, lat);
        CASE opsy OF
          andsy:
            Load(lat); DEC(loadCount);
(*            Assert(AType=logical) *)
            (* Do nothing, short circuit AND *)

        | divsy:
            CASE AType OF
                signed:
                  Load(lat); DEC(loadCount);
                  Emit(DIVV)
              | unSigned:
                    Load(lat); DEC(loadCount);
                    Emit(UDIV)
            END
       
        | slash:
            Load(lat); DEC(loadCount);
            CASE AType OF
                bitwise:  Emit(XORR)
              | floating: Emit(FDIV);
            END;

        | modsy:
            CASE AType OF
                signed: Load(lat); DEC(loadCount);
                        Emit(UMOD) (* no integer modulus *)
              | unSigned:
                  IF lat.mode=constantMod THEN 
                    UConstMod(lat.value)
                  ELSE 
                    Load(lat); DEC(loadCount);
                    Emit(UMOD)
                  END
            END
         
        END
      END;
      fat.typtr := ResultType(fat, lat)
    END;  
    UpdateShort(lPC)
  END Term;  

END P4ExpFact .
