IMPLEMENTATION MODULE P4ExpSimp;

FROM MCBase IMPORT
    Symbol;
FROM MCP4AttributSys IMPORT 
    Attribut, ArithmeticType, Load, Arithmetic, AtMode, ResultType;
FROM MCP4Global IMPORT
     sy, GetSymbol, loadCount;
FROM MCP4CodeSys IMPORT Emit, MarkShort, UpdateShort;
FROM P4ExpFact IMPORT Term;
FROM MCMnemonics IMPORT
    SUB, USUB, COM, ANDD, FSUB, ADD, UADD, ORR, FADD, NEG, FNEG, ORJP;

  PROCEDURE SimpleExpression(VAR fat: Attribut);   
    (* fat describes the first operand and the result *)
    VAR 
      opsy: Symbol;  
      lat: Attribut; (* descriptor of second operand *)
      negb: BOOLEAN; (* a negation has to take place *)  
      AType: ArithmeticType;
      lPC: INTEGER; 
  BEGIN lPC := 0;
    negb := sy = minus; 
    IF negb THEN GetSymbol END;  
    Term(fat);  
    IF negb THEN  
      IF Arithmetic(fat, fat)=floating THEN
        Load(fat); 
        Emit(FNEG) 
      ELSIF fat.mode <> constantMod THEN
        (* negation *)
        Load(fat);
        Emit(NEG)
      ELSE 
        fat.iValue := -fat.iValue  
      END  
    END;  
    WHILE (sy >= plus) AND (sy <= orsy) DO opsy := sy;
      Load(fat);
      GetSymbol;
      IF opsy=orsy THEN
        Emit(ORJP); MarkShort(lPC)
      END;
      Term(lat); Load(lat);
      AType := Arithmetic(fat, lat);
      DEC(loadCount);
      CASE opsy OF   
        minus:
          CASE AType OF
              signed:   Emit(SUB)
            | unSigned: Emit(USUB)
            | bitwise:  Emit(COM); Emit(ANDD)
            | floating: Emit(FSUB);
          END
      | plus:
          CASE AType OF
              signed:   Emit(ADD)
            | unSigned: Emit(UADD)
            | bitwise:  Emit(ORR) (*sets*)
            | floating: Emit(FADD);
          END
      | orsy:        
         (* booleans,   do nothing, short circuit OR *)
      END;  
      fat.typtr := ResultType(fat, lat)
    END;  
    UpdateShort(lPC)
  END SimpleExpression;   

END P4ExpSimp .
