IMPLEMENTATION MODULE P4ExpWith;

    FROM Storage IMPORT
      ALLOCATE, DEALLOCATE;
    FROM MCP4AttributSys IMPORT
      Attribut, PreAssign, AtMode, LoadAddr, HasAlreadyCode;
    FROM MCP4Global IMPORT loadCount, blockNptr;
    FROM MCP4CodeSys IMPORT EmitPacked;
    FROM MCMnemonics IMPORT
      LLW, SLW;

    TYPE
      WithPt = POINTER TO WithRecord;   
      WithRecord = 
        RECORD wat: Attribut;
          next: WithPt      
        END;

    VAR 
      firstWith: WithPt;
      withCount: INTEGER;


    PROCEDURE UseWith(i: INTEGER; VAR fat: Attribut);
      (* fat gets the description of the with element.   
         May produce code for loading the address of the with variable *)
      VAR lWith: WithPt; l: INTEGER;
     BEGIN lWith := firstWith;
(*      Assert(i<=withCount); *)
      FOR l := 1 TO i DO lWith := lWith^.next END;
      WITH lWith^ DO
        fat := wat
      END;
      IF fat.mode=addrLoadedMod THEN
        EmitPacked(LLW, blockNptr^.varlength-CARDINAL(i));
        INC(loadCount)
      END
    END UseWith; 


    PROCEDURE EnterWith(VAR fat: Attribut); 
      (* Store fat for further use by UseWith,  
         code for entry of a with statement *)
      VAR lWith: WithPt; i: INTEGER;
    BEGIN 
      INC(withCount); lWith := firstWith;
      FOR i := 2 TO withCount DO lWith := lWith^.next END;
      NEW(lWith^.next); lWith := lWith^.next;
      PreAssign(fat);
      IF fat.mode IN HasAlreadyCode THEN
        LoadAddr(fat);
        EmitPacked(SLW, blockNptr^.varlength-CARDINAL(withCount));
        DEC(loadCount)
      END;
      WITH lWith^ DO
        wat := fat
      END
    END EnterWith;
 

    PROCEDURE ExitWith;
      (* Exit the innermost with statement *)
      VAR lWith: WithPt; i: INTEGER;
    BEGIN lWith := firstWith;
      FOR i := 1 TO withCount DO lWith := lWith^.next END;
      DISPOSE(lWith);
(*       Assert(withCount>0); *)
      DEC(withCount);
    END ExitWith;
 

  BEGIN 
    withCount := 0;
    NEW(firstWith)

END P4ExpWith.


