IMPLEMENTATION MODULE P4If;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM MCBase IMPORT
    Symbol, intptr;
FROM MCP4AttributSys IMPORT
    Attribut, RangeCheck, Load, AtMode;
FROM MCP4Global IMPORT
    GetSymbol, sy, Error, val,
    controlRangeCheck, loadCount, spPosition;
FROM MCP4CodeSys IMPORT
    Emit, EmitLI, Emit2, Emit2GivePC, Insert, 
    Insert2, Fixup2, PC, MoveCode;
FROM MCMnemonics IMPORT JPFC, JPF, JP, JPC;
FROM MCP4ExpressionSy IMPORT
    Expression;
FROM M2Pass4PV IMPORT Skip;
FROM P4Stat IMPORT  StatSeq1, StatSeq3;

  PROCEDURE IfStatement;   
    TYPE
      ListPtr = POINTER TO JumpRecord;
      JumpRecord = 
        RECORD nextPtr: ListPtr;
          nextJump: CARDINAL;
          endJump: CARDINAL
        END;
    VAR 
      lat: Attribut;
      lp, jumpList: ListPtr;
      shift, curPC, c: CARDINAL;

    PROCEDURE NewListEntry;
      VAR lp: ListPtr;
    BEGIN NEW(lp);
      lp^.nextPtr := jumpList;
      jumpList := lp
    END NewListEntry; 

  BEGIN (*IfStatement*) 
    (* analysis *)
    jumpList := NIL; 
    LOOP Expression(lat);
      IF lat.mode=constantMod THEN
        IF BOOLEAN(lat.value) THEN
          StatSeq3(endsy, elsifsy, elsesy); 
          IF sy<>endsy THEN Skip(endsy, endsy) END;
          EXIT
        ELSE Skip(elsesy, elsifsy);
          IF sy <> elsifsy THEN EXIT END;  
          GetSymbol
        END 
      ELSE
        NewListEntry;
        Load(lat); DEC(loadCount);
        jumpList^.nextJump := PC; Emit(JPFC); Emit(0);
        StatSeq3(endsy, elsifsy, elsesy); 
        jumpList^.endJump := PC; 
        IF sy<>endsy  THEN Emit(JPF); Emit(0)
        END;
        IF sy <> elsifsy THEN EXIT END;  
        GetSymbol 
      END 
    END;  
    IF sy = elsesy THEN GetSymbol;  
      (*the occurence of an else can be detected by jumpList^.endJump<>PC*)
      StatSeq1(endsy)  
    END;  
    GetSymbol; (* skip endsy *)  

    (* compute total displacement *)
    shift := 0;
    lp := jumpList;
    WHILE lp<>NIL DO
      (* test for the jump to the end *)
      (* c gets the length of the jump instruction to the end *)
      IF (ORD(PC)+shift-lp^.endJump)=0 THEN c := 0 
      ELSIF (ORD(PC)+shift-lp^.endJump)>(255+1) THEN INC(shift); c := 3 
      ELSE c := 2 END;
      (* test for the jump to the next test or else part *)
      IF (c+lp^.endJump-lp^.nextJump)>(255+1) THEN INC(shift) END;
      lp := lp^.nextPtr
    END;

    (* fix jump adresses *)
    lp := jumpList;
    curPC := PC;
    WHILE lp<>NIL DO
      (* handle the jump to the end *)
      (* c gets the length of the jump instruction to the end *)
      IF lp^.endJump<curPC THEN
        IF shift>0 THEN MoveCode(lp^.endJump, curPC-1, shift) END;
        IF (ORD(PC)-shift-lp^.endJump)>(255+1) THEN
          Insert(lp^.endJump+shift-1, JP); 
          Insert2(lp^.endJump+shift, ORD(PC)-(lp^.endJump+shift));
          DEC(shift); c := 3
        ELSE 
          Insert(lp^.endJump+shift+1, ORD(PC)-(lp^.endJump+shift+1));
          c := 2
        END
      ELSE c := 0  (*no else part*)
      END;
      curPC := lp^.nextJump;
      (* handle the jump to the next test or else part *)
      IF shift>0 THEN MoveCode(lp^.nextJump, lp^.endJump-1, shift) END;
      c := c+lp^.endJump-lp^.nextJump-1;
      IF c>255 THEN
        Insert(lp^.nextJump+shift-1, JPC); 
        Insert2(lp^.nextJump+shift, c+1);
        DEC(shift)
      ELSE
        Insert(lp^.nextJump+shift+1, c);
      END;
      lp := lp^.nextPtr
    END
END IfStatement;

END P4If .


