IMPLEMENTATION MODULE P4Misc;

FROM MCBase IMPORT Symbol;
FROM MCP4Global IMPORT
    GetSymbol, sy, blockNptr, loadCount;
FROM MCMnemonics IMPORT
    JPC, JPBC, JP, JPFC, JPB;
FROM MCP4CodeSys IMPORT
    Emit, Emit2, PC, Insert, Insert2, MoveCode;
FROM P4CodeBlk IMPORT GenBlockReturn;
FROM P4Stat IMPORT
    StatSeq1;
FROM MCP4AttributSys IMPORT
    Attribut, PreAssign, Assign, RangeCheck, Load;
FROM MCP4ExpressionSy IMPORT
    Expression, ExpressionAndLoad, Designator, EnterWith, ExitWith;

  PROCEDURE RepeatStatement;    
    VAR lPC: INTEGER;
  BEGIN
    lPC := PC;
    StatSeq1(untilsy); GetSymbol;  
    ExpressionAndLoad; DEC(loadCount);
    lPC := PC-lPC+1;
    IF lPC>255 THEN Emit(JPC); Emit2(-lPC)
    ELSE Emit(JPBC); Emit(lPC)
    END
  END RepeatStatement;  


  PROCEDURE WhileStatement;   
    VAR startPC, jumpOutPC, forwardOffset: INTEGER;
  BEGIN
    startPC := PC;
    ExpressionAndLoad; DEC(loadCount);
    jumpOutPC := PC; Emit(JPFC); Emit(0);
    StatSeq1(endsy);  
    forwardOffset := PC-jumpOutPC+1;
    IF (PC-startPC)>(255-1) THEN (*backjump is long*)
      IF forwardOffset>(255-1) THEN (*two long jumps*)
        MoveCode(jumpOutPC+2, PC-1, 1);
        Insert(jumpOutPC, JPC); Insert2(jumpOutPC+1, forwardOffset+2)
      ELSE (*only backjump is longjump*)
        Insert(jumpOutPC+1, forwardOffset+1)
      END;
      Emit(JP); Emit2(startPC-PC)
    ELSE (*all short jumps*)
      Emit(JPB); Emit(PC-startPC);
      Insert(jumpOutPC+1, forwardOffset)
    END;
    GetSymbol  
  END WhileStatement;  

     

  PROCEDURE ReturnStatement;   
    VAR lat: Attribut;  
  BEGIN  
    IF sy = lparent THEN  
      Expression(lat);  
(*      Assert((blockNptr<>NIL) AND (blockNptr^.klass=funcs));   *)
      WITH blockNptr^.idtyp^ DO  
(*        Assert((form=proctypes) AND (rkind=funcs));   *)
        RangeCheck(funcp, lat);
        Load(lat)
      END  
    END;  
    GenBlockReturn;
  END ReturnStatement;  

  PROCEDURE Assignment;   
    VAR lat1, lat2: Attribut;  
  BEGIN
    Designator(lat1); PreAssign(lat1);  
    GetSymbol;
    Expression(lat2); Assign(lat1, lat2)  
  END Assignment;  


  PROCEDURE WithStatement;   
    VAR lat: Attribut;  
  BEGIN  
    Designator(lat); EnterWith(lat);   
    StatSeq1(endsy);  
    GetSymbol; ExitWith  
  END WithStatement;  

END P4Misc .
