(*********************************************************************)
(* Title:	m2whereis					     *)
(* Author: 	Mick Jordan,107,x304				     *)
(* 		Copyright (C) 1985 by Acorn Research Centre	     *)
(*********************************************************************)


(*
  $Revision: 1.4 $
  $Author: dm $
  $Date: 88/01/26 14:36:49 $
  $Source: /m2/util/m2whereis/RCS/m2whereis.mod,v $
  $State: Exp $
*)

MODULE m2whereis;

FROM M2Files IMPORT Filename,CreateInput,Extension, SetM2PathFromFile;
FROM UnixArgs IMPORT argCount,GetArg;
FROM Streams IMPORT Stream,Delete,ErrorCode;
FROM SysStreams IMPORT sysOut;
FROM Stop IMPORT Stop;
IMPORT Strings;
FROM WriteF IMPORT WriteF1,WriteF2,H;
FROM UtilError IMPORT ReportError, SetPrompt;

VAR
   ext  : Extension;
   ds   : Stream;
   argno,arglength,i  : CARDINAL;
   fname : ARRAY [0..79] OF CHAR;
   status: CARDINAL;

PROCEDURE Open(ext: Extension);
    BEGIN
        ds := CreateInput(fname,ext);
        IF ds^.status # Success THEN
            ReportError(FALSE, "%S.%S not found",H(fname), H(ext));
            status := 1;
        ELSE
            WriteF1(sysOut, "%S \n",H(Filename));
            Delete(ds);            
        END;    
    END Open;
   
PROCEDURE Usage();
  BEGIN
    ReportError(TRUE,"Usage: m2whereis [-E] module|file ...",0,0); 
  END Usage;
   
BEGIN
    status := 0;
    SetPrompt("m2whereis");
    IF argCount < 2 THEN
        Usage()
    END (* if *);
    argno := 1;
    WHILE argno < argCount DO
        GetArg(argno,fname);
        IF fname[0] = '-' THEN
          CASE fname[1] OF
            'E': SetM2PathFromFile()
          ELSE
            Usage()
          END
        ELSE
          arglength := Strings.LengthC(fname);
          IF (arglength > 4) AND (fname[arglength-4] = ".") THEN
            fname[arglength-4] := 0C;
            FOR i := 0 TO 2 DO
                ext[i] := fname[arglength-3+i];
            END (* for *);
            ext[3] := 0C;
            Open(ext);
          ELSE
            Open("def");
            Open("mod");
            Open("sym");
            Open("lnk");
            Open("ref");
            Open("key");
          END (* if *);
        END;
        INC(argno);
    END (* while *);

    Stop(status);

END m2whereis.

(*
$Log:	m2whereis.mod,v $
Revision 1.4  88/01/26  14:36:49  dm
Reremoved module -E!

Revision 1.3  88/01/26  13:52:09  dm
Added -E argument.

Revision 1.2  85/04/17  16:38:57  mjj
Fix problem with module names < 4 characters.

Revision 1.1  85/04/17  16:17:00  mjj
Initial revision

*)

