IMPLEMENTATION MODULE DisAsm;

    FROM BFormatIO IMPORT
        WriteF1, WriteF2, WriteF3, WriteS, NewLine, WriteCard, H;
    FROM CountStream IMPORT MovetoPos;
    FROM ReadMcd IMPORT
        IMPORTFRAME, IMPORTFRAMEPTR,
        KEY, KEYSIZE, MODULENAME, MODULENAMESIZE,
        Headerframe, Importlist, Version, BytesperWord,
        ReadMCode, Codeframe, Dataframe, Fixupframe, Stringframe,
        CodeSize, DataSize, FixupSize, ProcadrSize, 
        StringSize, StringConstantBase;

    TYPE LDIR = (FORWARD, BACKWARD);

    VAR PC, SPC: CARDINAL;
    VAR nextprocadr: CARDINAL;

    PROCEDURE next(): CARDINAL;
    BEGIN
        INC(PC); RETURN CARDINAL(Codeframe[PC-1]);
    END next;

    PROCEDURE next2(): CARDINAL;
    BEGIN
        INC(PC,  2);
	RETURN CARDINAL(Codeframe[PC-2])*400B + 
               CARDINAL(Codeframe[PC-1]);
    END next2;
    
    PROCEDURE Findnextprocadr(): CARDINAL;
    (*  Find the next procedure entry in the table		      *)
    VAR i, min, n: CARDINAL;
    BEGIN
        min := CodeSize;
        FOR i := 0 TO ProcadrSize-1 BY 2 DO
	    n := Codeframe[i]*400B + Codeframe[i+1];
            IF (n > nextprocadr+1) AND (n < min) THEN
                min := n;
            END;
        END;
	RETURN min;
    END Findnextprocadr;

    PROCEDURE OctDisAsm(offset, nbytes: CARDINAL);
    (*  offset is in bytes from start of Codeframe *)
    VAR i: CARDINAL;
    BEGIN
        FOR i := 0 TO nbytes-1 DO
            IF (i MOD 8) = 0 THEN 
                 NewLine; WriteF1("%I6:  ", i + offset); 
            END;
            WriteF1("%O3  ", Codeframe[i]);
        END;
        NewLine;
    END OctDisAsm;

    PROCEDURE DisAsm(offset, sizeINbytes: CARDINAL);
    BEGIN
        PC := offset; SPC := PC;
        nextprocadr := ProcadrSize;
        DisAsm1(sizeINbytes);
    END DisAsm;
    
    PROCEDURE WriteLocation;
    BEGIN
        WriteF1("*NL%N:", PC);
	MovetoPos(9);
    END WriteLocation;
    
    PROCEDURE WriteOctalComment;
    VAR i: CARDINAL;
    BEGIN
        MovetoPos(40); WriteS("; ");
        FOR i := SPC TO PC-1 DO
            WriteF1("%O3 ", Codeframe[i]);
        END;
        SPC := PC;
    END WriteOctalComment;
    
    PROCEDURE Lnext(Direction: LDIR): CARDINAL;
    VAR cPC: CARDINAL;
    BEGIN
        cPC := PC;		(* order of evaluation!	      *)
	IF Direction = FORWARD THEN
  	    RETURN cPC + next();
	ELSE
	    RETURN cPC - next();
	END;
    END Lnext;

    PROCEDURE Lnext2(): CARDINAL;
    VAR cPC: CARDINAL;
    BEGIN
        cPC := PC;
	RETURN cPC + next2();
    END Lnext2;

    PROCEDURE DisAsm1(sizeINbytes: CARDINAL);
    VAR IR, maxPC,i: CARDINAL;
    BEGIN
        maxPC := PC + sizeINbytes;

    REPEAT
        IF PC = nextprocadr THEN
            WriteS("*N*NPROCEDURE Entry*N");
            nextprocadr := Findnextprocadr();
        END;

        WriteLocation;
        IR := next();
        CASE IR OF
            0B .. 17B:  WriteF1("LI%N", IR MOD 16);

        |   20B:        WriteF1("LIB %N", next());

        |   22B:        WriteF1("LIW %N", next2());

        |   23B:        WriteF2("LID %N,%N", next2(), next2());

        |   24B:        WriteF1("LLA %N", next());

        |   25B:        WriteF1("LGA %N", next());

        |   26B:        WriteF1("LSA %N", next());

        |   27B:        WriteF2("LEA %N,%N", next(), next());

        |   30B:        WriteF1("JPC L%N", Lnext2());

        |   31B:        WriteF1("JP L%N", Lnext2());

        |   32B:        WriteF1("JPFC L%N", Lnext(FORWARD));

        |   33B:        WriteF1("JPF %N",  Lnext(FORWARD));

        |   34B:        WriteF1("JPBC L%N", Lnext(BACKWARD));

        |   35B:        WriteF1("JPB L%N", Lnext(BACKWARD));

        |   36B:        WriteF1("ORJP L%N", Lnext(FORWARD));

        |   37B:        WriteF1("ANDJP L%N", Lnext(FORWARD));

        |   40B:        WriteF1("LLW %N", next());

        |   41B:        WriteF1("LLD %N", next());

        |   42B:        WriteF2("LEW %N, %N", next(), next());

        |   43B:        WriteF2("LED %N, %N", next(), next());

        |   44B .. 57B: WriteF1("LLW%N", IR MOD 16);

        ELSE            DisAsm2(IR);
        END;
        WriteOctalComment;
    UNTIL PC >= maxPC;

    END DisAsm1;

    PROCEDURE DisAsm2(IR: CARDINAL);
    BEGIN
        CASE IR OF
            60B:        WriteF1("SLW %N", next());

        |   61B:        WriteF1("SLD %N", next());

        |   62B:        WriteF2("SEW %N, %N", next(), next());

        |   63B:        WriteF2("SED %N, %N", next(), next());

        |   64B .. 77B: WriteF1("SLW%N", IR MOD 16);

        |  100B:        WriteF1("LGW %N", next());

        |  101B:        WriteF1("LGD %N", next());

        |  102B .. 117B:WriteF1("LGW%N", IR MOD 16);

        |  120B:        WriteF1("SGW %N", next());

        |  121B:        WriteF1("SGD %N", next());

        |  122B .. 137B:WriteF1("SGW%N", IR MOD 16);

        |  140B .. 157B:WriteF1("LSW%N", IR MOD 16);

        |  160B .. 177B:WriteF1("SSW%N", IR MOD 16);

        ELSE            DisAsm3(IR);
        END;
    END DisAsm2;

    PROCEDURE DisAsm3(IR: CARDINAL);
    BEGIN
        CASE IR OF
           200B:        WriteF1("LSW %N", next());

        |  201B:        WriteF1("LSD %N",  next());

        |  202B:        WriteS("LSD0");

        |  203B:        WriteS("LXFW");

        |  204B:        WriteF1("LSTA %N", next());

        |  205B:        WriteS("LXB");

        |  206B:        WriteS("LXW");

        |  207B:        WriteS("LXD");

        |  210B:        WriteS("DADD");

        |  211B:        WriteS("DSUB");

        |  212B:        WriteS("DMUL");

        |  213B:        WriteS("DDIV");

        |  214B:        WriteS("FUNC");

        |  216B:        WriteS("DSHL");

        |  217B:        WriteS("DSHR");

        |  220B:        WriteF1("SSW %N", next());

        |  221B:        WriteF1("SSD %N", next());

        |  222B:        WriteS("SSD0");

        |  223B:        WriteS("SXFW");

        |  224B:        WriteS("TS");

        |  225B:        WriteS("SXB");
       
        |  226B:        WriteS("SXW");

        |  227B:        WriteS("SXD"); 

        ELSE            DisAsm4(IR);
        END;
    END DisAsm3;

    PROCEDURE DisAsm4(IR:CARDINAL);
    VAR sysn, sysi: CARDINAL;
    BEGIN
        CASE IR OF
            230B:        WriteS("FADD");

        |   231B:        WriteS("FSUB");

        |   232B:        WriteS("FMUL");

        |   233B:        WriteS("FDIV");

        |   234B:        WriteS("FCMP");

        |   235B:        WriteS("FABS");

        |   236B:        WriteS("FNEG");

        |   237B:        WriteF1("FFCT %N", next());

        |   245B:        WriteS("UCHK");

        |   247B:        (* first byte specifies how many to follow *)
                         sysn := next();
                         WriteF1("SYS %N ", sysn);
                         FOR sysi:=1 TO sysn DO
                             WriteF1("%N ", next())
                         END;

        |   250B:        WriteF1("ENTP %O6", next());

        |   251B:        WriteS("EXP");

        |   252B:        WriteS("ULSS");

        |   253B:        WriteS("ULEQ");

        |   254B:        WriteS("UGTR");

        |   255B:        WriteS("UGEQ");

        |   256B:        WriteF1("TRA %N", next());

        |   257B:        WriteF1("RDS %N", next());

        |   260B:        WriteS("LODFW");

        |   261B:        WriteS("LODFD");

        |   262B:        WriteS("STORE");

        |   263B:        WriteS("STOFV");

        |   264B:        WriteS("STOT");

        |   265B:        WriteS("COPT");

        |   266B:        WriteS("DECS");

        |   267B:        WriteF1("PCOP %N", next());

        |   270B:        WriteS("UADD");

        |   271B:        WriteS("USUB");

        |   272B:        WriteS("UMUL");

        |   273B:        WriteS("UDIV");

        |   274B:        WriteS("UMOD");

        |   275B:        WriteS("ROR");

        |   276B:        WriteS("SHL");

        |   277B:        WriteS("SHR");

        ELSE             DisAsm5(IR);
        END;
    END DisAsm4;

    PROCEDURE DisAsm5(IR: CARDINAL);
    VAR i, casePC, casel, lcase, hcase, ncases: CARDINAL;
    BEGIN
        CASE IR OF
           300B:        WriteF2("FOR1 %N, L%N", next(), Lnext2());

        |  301B:        WriteF2("FOR2 %N, L%N", next(), Lnext2());

        |  302B:        casePC := PC-1; casel := next2()-1;
                        WriteF1("ENTC L%N", casePC+casel+2);
			WriteOctalComment;
                        (* Disassemble the bodies of the CASE statement *)
                        DisAsm1(casel-1);
                        lcase := next2(); hcase := next2();
                        WriteF3("*N*NCASE table from L%N, low=%N, high=%N", 
                                casePC, lcase, hcase);
                        WriteOctalComment;
                        FOR i := lcase TO hcase+1 DO
                            WriteLocation;
                            WriteF1("L%N", Lnext2());
                            WriteOctalComment;
                        END;
			WriteS("*NEND of CASE table*N");

        |  303B:        WriteS("EXC");

        |  304B:        WriteS("TRAP");

        |  305B:        WriteS("CHK");

        |  306B:        WriteS("CHKZ");

        |  307B:        WriteS("CHKS");

        |  310B:        WriteS("EQL");

        |  311B:        WriteS("NEQ");

        |  312B:        WriteS("LSS");

        |  313B:        WriteS("LEQ");

        |  314B:        WriteS("GTR");

        |  315B:        WriteS("GEQ");

        |  316B:        WriteS("ABS");

        |  317B:        WriteS("NEG");

        |  320B:        WriteS("OR");

        |  321B:        WriteS("XOR");

        |  322B:        WriteS("AND");

        |  323B:        WriteS("COM");

        |  324B:        WriteS("IN");

        |  325B:        WriteS("LIN");

        |  326B:        WriteS("MSK");

        |  327B:        WriteS("NOT");

        |  330B:        WriteS("ADD");

        |  331B:        WriteS("SUB");

        |  332B:        WriteS("MUL");

        |  333B:        WriteS("DIV");

        |  334B:        WriteS("MOD");

        |  335B:        WriteS("BIT");

        |  336B:        WriteS("NOP");

        |  340B:        WriteS("MOV");

        |  346B:        WriteS("UNPK");

        |  347B:        WriteS("PACK");

        |  350B:        WriteF1("GB %N", next());

        |  351B:        WriteS("GB1");

        |  352B:        WriteS("ALLOC");

        |  353B:        WriteF1("ENTR %N", next());

        |  354B:        WriteS("RTN");

        |  355B:        WriteF2("CX %N, %N", next(), next());

        |  356B:        WriteF1("CI %N", next());

        |  357B:        WriteS("CF");

        |  360B:        WriteF1("CL %N", next());

        |  361B .. 377B:WriteF1("CL%N", IR MOD 16);

        ELSE            WriteF1("Undecoded OP %N", IR);
        END;
    END DisAsm5;

PROCEDURE PrintHeader;
BEGIN
    WriteF1("MODULE: %S, ", H(Headerframe^.name));
    PrintKey(Headerframe^.key);
    WriteF1(", datasize %N words*N*N", Headerframe^.datasize);
    WriteF2("VERSION: %S, BytesperWord=%N*N*N", H(Version), BytesperWord);
END PrintHeader;

PROCEDURE PrintImports;
VAR ip: IMPORTFRAMEPTR;
BEGIN
    ip := Importlist;
    WriteS("IMPORT*N");
    WHILE ip <> NIL DO
        WriteF1("    %S ", H(ip^.name));
        MovetoPos(20);
        PrintKey(ip^.key); 
        NewLine;
        ip := ip^.link;
    END;
END PrintImports;

PROCEDURE PrintKey(key: KEY);
BEGIN
    WriteF3("key = %O6,%O6,%O6", key[1], key[2], key[3]);
END PrintKey;

PROCEDURE PrintCode(OctalCode: BOOLEAN);
VAR i: CARDINAL;
BEGIN
    WriteF1("*NPROCEDURE address table, size %N bytes*N", ProcadrSize);
    IF ProcadrSize > 0 THEN
        FOR i := 0 TO ProcadrSize-1 BY 2 DO
            WriteF1("*NL%N:", i); MovetoPos(9);
            WriteCard(Codeframe[i]*400B+Codeframe[i+1], 6);
        END;
    END;
    NewLine; NewLine;
    (*  Now disassemble the real code *)
    WriteF1("CODEFRAMES, size %N bytes*N", CodeSize);
    IF OctalCode THEN
        OctDisAsm(ProcadrSize, CodeSize-ProcadrSize);
    ELSE
        DisAsm(ProcadrSize, CodeSize-ProcadrSize);
    END;
    NewLine; NewLine;
END PrintCode;

PROCEDURE PrintData;
VAR i: CARDINAL;
BEGIN
    WriteF1("*NDATAFRAME, size %N words*N", DataSize);
    FOR i := 0 TO DataSize-1 DO
        IF (i MOD 4) = 0 THEN 
            NewLine; WriteF1("%I6:  ", i); 
        END;
        WriteF2("%I6 (#%O6)  ", Dataframe[i],Dataframe[i]);
    END;
    NewLine; 
END PrintData;

PROCEDURE PrintString;
VAR i: CARDINAL;
BEGIN
    WriteF1("*NSTRINGFRAME, size %N bytes*N", StringSize);
    IF StringSize>0 THEN
        FOR i := 0 TO StringSize-1 DO
            IF (i MOD BytesperWord) = 0 THEN 
                NewLine; 
                WriteF1("%I6:  ", StringConstantBase+(i DIV BytesperWord)); 
            END;
            WriteF2("%C (#%O3) ", Stringframe[i], Stringframe[i]);
        END;
    END;
    NewLine; NewLine;
END PrintString;

PROCEDURE PrintFixups;
VAR i: CARDINAL;
BEGIN
IF FixupSize <> 0 THEN
    WriteS("*NFIXUP locations*N");
    FOR i := 1 TO FixupSize DO
        IF ((i-1) MOD 10) = 0 THEN NewLine; END;
            WriteCard(Fixupframe[i-1], 6);
    END;
    NewLine;
END;
END PrintFixups;

PROCEDURE PrintMcd(OctalCode: BOOLEAN);
BEGIN
    PrintHeader;
    PrintImports;
    PrintData;
    PrintString;
    PrintCode(OctalCode);
    PrintFixups;
END PrintMcd;

END DisAsm .

