(*
    Title: 	M-Code decoder
    LastEdit:	"Sun Jan 30 18:31:08 1983"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory

    A program to decode M-Code files output by m2m.
*)

MODULE m2decmcd;

FROM Arguments IMPORT 
    ArgCount, GetArg;

IMPORT BStreams;
FROM BStop IMPORT Stop;
FROM BStreams IMPORT
    STREAM, Rdword, UnRdword, Rdch,
    ErrorCode, ERRORCODE, SysErr, InValid,
    SelectInput, SelectOutput, EndRead, EndWrite;

IMPORT BFormatIO;
FROM BFormatIO IMPORT
    H, WriteF1, WriteF2, WriteF3, WriteF4, WriteS, NewLine, WriteCard;

FROM BFileIO IMPORT 
    FindInput, FindOutput, StreamErrorCode;

IMPORT ReadMcd;
FROM ReadMcd IMPORT ReadMCode, McdError, MCDERROR;

FROM PMcdError IMPORT PrintMcdError;

IMPORT CountStream;
FROM CountStream IMPORT
    FindCountOutput;
FROM UnixErrors IMPORT SYSERRORSTRING, SysErrlist;

FROM DisAsm IMPORT PrintMcd;


(*  Local declarations for decmcd				      *)

PROCEDURE FError(name: ARRAY OF CHAR; code: INTEGER);
VAR ms: SYSERRORSTRING;
BEGIN
    ms := SysErrlist[code];
    SelectOutput(SysErr);
    WriteF2("m2decmcd: %S - %S*N", H(ms), H(name));
    status := 1;
END FError;

PROCEDURE MakeFile(VAR filenam: ARRAY OF CHAR; str: ARRAY OF CHAR);
VAR pos : INTEGER;
BEGIN
    pos:=0; 
    WHILE (filenam[pos] #0C) AND(filenam[pos]#'.')DO INC(pos); END;
    filenam[pos]:='.'; filenam[pos+1]:=str[0];
    filenam[pos+2]:=str[1]; filenam[pos+3]:=str[2];
    filenam[pos+4]:=0C;
END MakeFile;

(*  here starts the program					      *)

VAR status: CARDINAL;
VAR smcd, sdec, csdec: STREAM;
VAR argnum: CARDINAL;
VAR arglength: CARDINAL;
VAR argname, mcdfile, decfile: ARRAY [0 .. 80] OF CHAR;
VAR OctalCode, DebugMcd: BOOLEAN;

BEGIN
    status := 0;
    OctalCode := FALSE;
    DebugMcd := FALSE;
    argnum := 1;
    IF ArgCount < 2 THEN
        WriteS("Usage: m2decmcd file1 ...*N");
	Stop(1);
    ELSE
        LOOP
            GetArg(argnum, argname, arglength);
            IF argname[0] = '-' THEN
            ELSE
                mcdfile := argname; decfile := argname;
                MakeFile(mcdfile, "mcd");
                MakeFile(decfile, "dec");
                smcd := FindInput(mcdfile);
                IF InValid(smcd) THEN
                    FError(mcdfile, StreamErrorCode);
                    EXIT;
                END;
            
                sdec := FindOutput(decfile);
                IF InValid(sdec) THEN
                    FError(decfile, StreamErrorCode);
                    EXIT;
                END;

                csdec := FindCountOutput(sdec);
                IF InValid(csdec) THEN
                    WriteF1("CountOutput open failure %N", ErrorCode);
                    EXIT;
                END;

                SelectInput(smcd); 
		SelectOutput(csdec);
                ReadMCode(DebugMcd);

                IF McdError <> McdOK THEN
                    SelectOutput(SysErr);
                    PrintMcdError(McdError);
                ELSE
                IF NOT DebugMcd THEN PrintMcd(OctalCode); END;
                END;
                EndRead; EndWrite;
            END;

            INC(argnum);
            IF argnum = ArgCount THEN EXIT END;
        END;
    END;

    Stop(status);

END m2decmcd .

