(*
    Title: 	Append a user defined makefile
    LastEdit:	"Thu Feb 25 13:36:22 1988"
    Author: 	Derek McAuley
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE AppendUser;

IMPORT
  FileStream, GenMakeFile, Streams, SYSTEM, UtilError;

CONST
  BuffSize = 1024;
  
PROCEDURE Try();
  VAR
    n:CARDINAL;
    buffer:ARRAY [0..BuffSize-1] OF CHAR;
    stMake,
    stOther:Streams.Stream;
  BEGIN
    IF noAppend THEN RETURN END;
    stOther := FileStream.CreateInput(fileName);
    IF stOther^.status # Streams.Success THEN
      UtilError.ReportError(TRUE, "Bad user file name", 0, 0)
    END;
    stMake := FileStream.CreateOutput(GenMakeFile.makeFilename);
    IF stMake^.status # Streams.Success THEN
      UtilError.ReportError(TRUE, "Unable to open makefile", 0, 0)
    END;
    IF stMake^.status # Streams.Success THEN
      UtilError.ReportError(TRUE, "Unable to seek to end of makefile", 0, 0)
    END;
    WHILE stOther^.status = Streams.Success DO
      n := Streams.GetN(stOther, SYSTEM.ADR(buffer), BuffSize);
      IF Streams.PutN(stMake, SYSTEM.ADR(buffer), n) # n THEN
        UtilError.ReportError(TRUE, "Error writing append", 0, 0)
      END
    END;
    Streams.Delete(stMake);
    Streams.Delete(stOther);
  END Try;

  
BEGIN
  noAppend := TRUE
END AppendUser.
