(*
  Title:	OSNames
  $Header: OSNames.mod,v 1.1 84/11/30 16:18:26 mjj Exp $
  		Copyright (C) 1984 by Acorn Research Centre
*)

IMPLEMENTATION MODULE OSNames;
IMPORT Strings; FROM Strings IMPORT String;

FROM GenGraph IMPORT Class;

TYPE
  Extension = ARRAY [0..2] OF CHAR;

VAR 
  dotS: ARRAY [0..0] OF CHAR; (* silly language *)
  slashS: ARRAY [0..0] OF CHAR; 

PROCEDURE IsModuleName (file: ARRAY OF CHAR;
    VAR m2mod: ARRAY OF CHAR;
    VAR class: Class): BOOLEAN;
  VAR i, j: INTEGER;
      ext: ARRAY [0..2] OF CHAR;
  BEGIN
    IF IsAlpha(file [0]) THEN
      m2mod [0] := file [0];
      i := 1;
      WHILE IsAlphanumeric(file [i]) DO
        m2mod [i] := file [i];
        INC (i)
      END;
      IF file [i] = "." THEN
        m2mod [i] := 0C;
        INC (i)
      ELSE RETURN FALSE
      END;
      j := 0;
      WHILE IsAlphanumeric(file [i]) AND (j <= HIGH(ext)) DO
        ext [j] := file [i];
        INC (i);
        INC (j);
      END;
      IF file [i] = 0C THEN
        IF Strings.EqualCC(ext, "def") THEN
          class := Def; RETURN TRUE;
        ELSIF Strings.EqualCC(ext, "mod") THEN
          class := Impl; RETURN TRUE;
        ELSE
          RETURN FALSE;
        END;
      ELSE RETURN FALSE
      END
    ELSE RETURN FALSE
    END;
  END IsModuleName;

PROCEDURE GenFileName (m2mod: String; class: Class;
    VAR file: ARRAY OF CHAR);
  VAR
    ext: Extension;
    xext: ARRAY [0..4] OF CHAR;
  BEGIN
    Strings.CopySC(m2mod, file);
    ClassExt(class, ext);
    CASE class OF
      Def, Impl, Prog, Exe: 
        Strings.ConcatCC (file, dotS, file);
        Strings.ConcatCC (file, ext, file);
    | Obj, Sym: 
        Strings.ConcatCC(dotS, ext, xext);
        Strings.ConcatCC(xext, slashS, xext);
        Strings.ConcatCC(xext, file, file);
    END;
  END GenFileName;

PROCEDURE ClassExt(c: Class; VAR ext: Extension);
  BEGIN
    CASE c OF
      Def: ext := "def";
    | Impl, Prog: ext := "mod";
    | Obj: ext := "lnk";
    | Exe: ext := "out";
    | Sym: ext := "sym";
    END;
  END ClassExt;

PROCEDURE GenPathName(
    dirName, fileName: String;
    VAR pathName: ARRAY OF CHAR);
  VAR
    xpathName: ARRAY [0..255] OF CHAR;
  BEGIN
      Strings.CopySC(dirName, pathName);
      Strings.CopySC(fileName, xpathName);
      Strings.ConcatCC(pathName, slashS, pathName);
      Strings.ConcatCC(pathName, xpathName, pathName);    
  END GenPathName;

PROCEDURE IsAlpha(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN ((ch >= 'a') AND (ch <= 'z')) OR
     ((ch >= 'A') AND (ch <= 'Z'))
  END IsAlpha;

PROCEDURE IsAlphanumeric(ch: CHAR): BOOLEAN;
  BEGIN
    RETURN ((ch >= 'a') AND (ch <= 'z')) OR
     ((ch >= 'A') AND (ch <= 'Z')) OR
     ((ch >= '0') AND (ch <= '9'))
  END IsAlphanumeric;

BEGIN
  dotS[0] := '.'; slashS[0] := '/';
END OSNames.

(*
$Log:	OSNames.mod,v $
Revision 1.1  84/11/30  16:18:26  mjj
Initial revision

*)

