(*
    Title: 	KeyOutput - Implementation
    LastEdit:	"Sun Sep 23 17:24:02 1984"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE KeyOutput;

FROM SYSTEM IMPORT ADR, ADDRESS;
(* FROM MCBase IMPORT Idptr, root, mainmodp, Idclass, Modnamarr; *)
IMPORT Streams; FROM Streams IMPORT Put, PutN, Stream;
IMPORT BinaryIO, TextIO;
FROM ReadMcd IMPORT IMPORTFRAMEPTR;
(* FROM P4Error IMPORT Assert;  *)
(* FROM P4Types IMPORT SNODEPTR, STYPE; *)
FROM KeyTypes IMPORT
    ModulenameSize, KeySize, Modulename, Keys, ModuleModes,
    ModuleStatus, KeyData;
FROM SysStreams IMPORT sysOut;

VAR kS: Stream;

PROCEDURE OutputKeys(s: Stream; Headerframe, Imports: IMPORTFRAMEPTR);
    VAR
        p1: IMPORTFRAMEPTR;
        count: CARDINAL;
        i: CARDINAL;
        moduleStatus : ModuleStatus;
    BEGIN
        kS := s;
        p1 := Imports;
        count := 0;
        WHILE p1 # NIL DO
            INC(count);
            p1 := p1^.link;
        END (* while *);
        TextIO.WriteChars(kS, "KEY"); 
        BinaryIO.WriteCHAR(kS, 0C);     (* version *)
        BinaryIO.WriteCARDINAL(kS, count+1);
        OutputNameAndKey(Headerframe);
        (* output the status of this module, to help the linker *)
        moduleStatus := ModuleStatus{};
(*        IF Empty(module) THEN
            INCL(moduleStatus, EmptyModule);
            INCL(moduleStatus, NoInitCode);
        END;
        IF NoInit(module) THEN
            INCL(moduleStatus, NoInitCode);
        END;						*)

        BinaryIO.WriteBITSET(kS, BITSET(moduleStatus));

        p1 := Imports;
	WHILE p1 # NIL DO
            OutputNameAndKey(p1);
	    p1 := p1^.link
        END 

    END OutputKeys;

PROCEDURE OutputNameAndKey(id: IMPORTFRAMEPTR);
    VAR
        void: CARDINAL;
    BEGIN
(*      Assert(id # NIL);  *)
      WITH id^ DO
(*         Assert((klass=mods) AND globalmodule);  *)
        void := PutN(kS, ADR(name), ModulenameSize);
        BinaryIO.WriteCARDINAL(kS, key[1]);
        BinaryIO.WriteCARDINAL(kS, key[2]);
      END (* with *);
    END OutputNameAndKey;

(*

PROCEDURE Empty(module: SNODEPTR): BOOLEAN;
BEGIN
    RETURN (module^.stype = MODULEs) AND (module^.next = NIL) AND
            (module^.body = NIL);
END Empty;

PROCEDURE NoInit(module: SNODEPTR): BOOLEAN;
BEGIN
    WHILE module^.next # NIL DO
        module := module^.next;
    END;
    RETURN module^.body = NIL;
END NoInit;

*)


END KeyOutput.
