(*
    Title: 	NewStreams - Implementation in terms of Streams
    LastEdit:	"Tue Sep 23 12:44:12 1986"
    Author: 	Mick Jordan
		Cambridge University Computer Laboratory
*)

IMPLEMENTATION MODULE NewStreams;

FROM SYSTEM IMPORT WORD, BYTESPERWORD, ADR;
FROM SystemTypes IMPORT LongCARDINAL, LongINTEGER;
FROM Streams IMPORT ErrorCode, SeekMode, Stream, Delete;
FROM StreamRep IMPORT Procs;

PROCEDURE Connect(VAR s: STREAM; f: CARDINAL; ws: BOOLEAN);
(*  'f' is really a Btreams.Stream.
*)
BEGIN
    s := STREAM( f );
    Reset(s);
END Connect;

PROCEDURE Disconnect(VAR s: STREAM; closefile: BOOLEAN);
BEGIN
    IF closefile THEN Delete(Stream (s)); END;
END Disconnect;

PROCEDURE Reset(s: STREAM);
VAR
    xp : Procs;
BEGIN
    xp := Procs(s^.procs);
    xp^.Seek(s, Beginning, 0);
END Reset;

PROCEDURE WriteWord(s: STREAM; w: WORD);
    VAR
        xp: Procs;
        n: CARDINAL;
    BEGIN
        xp := Procs(s^.procs);
        n := xp^.PutN(s, ADR(w), BYTESPERWORD);
    END WriteWord;

PROCEDURE WriteChar(s: STREAM; ch: CHAR);
    VAR
        xp: Procs;
    BEGIN
        xp := Procs(s^.procs);
        xp^.Put(s, ch);
    END WriteChar;


PROCEDURE EndWrite(s: STREAM);
    VAR
        xp: Procs;
    BEGIN
        xp := Procs(s^.procs);
        xp^.Flush(s);
    END EndWrite;

PROCEDURE ReadWord(s: STREAM; VAR w: WORD);
    VAR
        xp: Procs;
        n: CARDINAL;
    BEGIN
        xp := Procs(s^.procs);
        n := xp^.GetN(s, ADR(w), BYTESPERWORD);
    END ReadWord;

PROCEDURE ReadChar(s: STREAM; VAR ch: CHAR);
    VAR
        xp: Procs;
    BEGIN
        xp := Procs(s^.procs);
        ch := CHAR( xp^.Get(s) );
    END ReadChar;

PROCEDURE EOS(s: STREAM): BOOLEAN;
    BEGIN
        RETURN s^.status = EndOfStream;
    END EOS;

PROCEDURE GetPos(s: STREAM; VAR highpos, lowpos: CARDINAL);
    VAR
        xp: Procs;
    BEGIN
        xp := Procs(s^.procs);
        highpos := 0;         (* only relevant for 16-bit machine *)
        xp^.Tell(s, lowpos);
    END GetPos;
        
PROCEDURE SetPos(s: STREAM; highpos, lowpos: CARDINAL);
    VAR
        xp: Procs;
    BEGIN
        xp := Procs(s^.procs);
        xp^.Seek(s, Beginning, lowpos);
    END SetPos;


BEGIN
    eolc := 012C;
END NewStreams .

