(*
    Title: 	KeyInput
    LastEdit:	"Sun Sep 23 17:26:52 1984"
    Author: 	Mick Jordan
		Acorn Research Centre
*)

IMPLEMENTATION MODULE KeyInput;

FROM SYSTEM IMPORT ADR;
FROM Streams IMPORT Stream, ErrorCode, GetN;
IMPORT BinaryIO;
FROM KeyTypes IMPORT
    ModulenameSize, KeySize, Modulename, Keys, ModuleModes,
    ModuleStatus, KeyData;

VAR firstKey: BOOLEAN;
    nKeys: CARDINAL;

PROCEDURE IsKeyData(s: Stream; VAR version: CARDINAL): BOOLEAN;
VAR
    keyid: ARRAY [0..3] OF CHAR;
    void: CARDINAL;
BEGIN
    void := GetN(s, ADR(keyid), 4);
    IF s^.status = Success THEN
        IF (keyid[0] = 'K') AND (keyid[1] = 'E') AND (keyid[2] = 'Y') THEN
            version := CARDINAL( keyid[3] );
            nKeys := BinaryIO.ReadCARDINAL(s);
            firstKey := TRUE;
            RETURN s^.status = Success;
        END (* if *);
    END (* if *);
    RETURN FALSE;
END IsKeyData;

PROCEDURE NKeys(s: Stream): CARDINAL;
BEGIN
    RETURN nKeys;
END NKeys;

PROCEDURE NextKey(s: Stream; VAR keyData: KeyData): BOOLEAN;
VAR
    n: CARDINAL;
    ok: BOOLEAN;
BEGIN
    n := GetN(s, ADR(keyData.name), ModulenameSize);
    IF s^.status # Success THEN
        RETURN FALSE;
    END (* if *);
    keyData.keys[0] := BinaryIO.ReadCARDINAL(s);
    keyData.keys[1] := BinaryIO.ReadCARDINAL(s);
    ok := s^.status = Success;
    IF ok THEN
        IF firstKey THEN
            firstKey := FALSE;
            keyData.moduleStatus := ModuleStatus(BinaryIO.ReadBITSET(s));
            ok := s^.status = Success;
        ELSE
            ok := TRUE;
        END (* if *);
    END (* if *);
    RETURN ok;
END NextKey;

END KeyInput.
