(*
    Title: 	IsArchive - Implementation
    LastEdit:	"Tue Sep 25 17:12:46 1984"
    Author: 	Mick Jordan
		Acorn Research Centre
*)


IMPLEMENTATION MODULE IsArchive;
IMPORT Strings, Slist;
FROM Storage IMPORT ALLOCATE;

VAR
    archive: ARRAY [0..10] OF CHAR;

PROCEDURE IsArchive(fname: ARRAY OF CHAR): BOOLEAN;
    VAR
        l, i, j, k: CARDINAL;
        a: ARLIST;
    BEGIN
        l := Strings.LengthC(fname);
        IF l > 10 THEN
            i := l-10; k := 0;
            FOR j := i TO i+10 DO
                IF fname[j] # archive[k] THEN
                    RETURN FALSE;
                END (* if *);
                INC(k);
            END (* for *);
            (* OK its an archive file, have we already seen it? *)
            a := ArList;
            WHILE a # NIL DO
                IF Strings.EqualCS(fname, a^.archive) THEN
                    RETURN TRUE;
                END (* if *);
                a := a^.link;
            END (* while *);
            (* new archive *)
            NEW(a);
            a^.archive := Strings.CopyCS(fname);
            Slist.AddE(ArList, a);
            RETURN TRUE;
        ELSE
            RETURN FALSE;
        END (* if *);
    END IsArchive;

BEGIN
    archive := "archive.ar";
    ArList := NIL;
END IsArchive.
