IMPLEMENTATION MODULE Config;
FROM Storage IMPORT ALLOCATE;
FROM UtilError IMPORT ReportError;
FROM LModule IMPORT MODULENAME, Pname;
IMPORT Slist;
IMPORT Strings;
FROM SystemTypes IMPORT String;

TYPE
    CONFIGPTR = POINTER TO CONFIG;
    CONFIG = RECORD
            link: CONFIGPTR;
            module: String;
            imodule: String;
        END (* record *);

VAR configlist: CONFIGPTR;

PROCEDURE Set(configpair: ARRAY OF CHAR);
    VAR
        index: CARDINAL;
        configptr: CONFIGPTR;
        tempString: ARRAY [0..255] OF CHAR;
    BEGIN
        index:=0;
        IF Strings.FindC(configpair, ':', index) THEN
            NEW(configptr);
            WITH configptr^ DO
                Strings.ExtractCC(configpair, 0, index, tempString);
                module := Strings.CopyCS(tempString);
                Strings.ExtractCC(configpair, index+1, HIGH(configpair)+1, tempString);
                imodule := Strings.CopyCS(tempString);
            END (* with *);
            Slist.AddE(configlist, configptr);
        ELSE
            ReportError(TRUE, "bad syntax: -m defname:implname",0,0);
        END;
    END Set;

PROCEDURE Specified(mname: MODULENAME; VAR cname: String): BOOLEAN;
    VAR
        c: CONFIGPTR;
        pname: String;
    BEGIN
        c := configlist;
        WHILE c # NIL DO
            Pname(mname, pname);
            IF Strings.EqualSS(c^.module, pname) THEN
                cname := c^.imodule;
                RETURN TRUE;
            ELSE
                c := c^.link;
            END (* if *);
        END (* while *);
        RETURN FALSE;
    END Specified;

BEGIN
    configlist := NIL;
END Config.
